CREATE OR REPLACE
PROCEDURE INCLUI_ERRCNABR
  (P_CDBANCCNAB IN VARCHAR2,
   P_CDERRCNABR IN VARCHAR2,
   P_DSERRCNABR IN VARCHAR2) IS

   V_CDBANCO BANCO.CDBANCO%TYPE;
BEGIN
   FOR C_BANCO IN (SELECT CDBANCO
                     FROM BANCO
                    WHERE CDBANCCNAB = P_CDBANCCNAB
                      AND CDBANCO IS NOT NULL) LOOP

      /*DELETA O BANCO DA TABELA ANTES DE INSERIR PARA NAO DA ERRO DE PK*/
      SELECT MAX(CDBANCO)
        INTO V_CDBANCO
        FROM ERRCNABR
       WHERE CDBANCO    = C_BANCO.CDBANCO
         AND CDERRCNABR = P_CDERRCNABR;

      IF V_CDBANCO IS NOT NULL THEN
         DELETE FROM ERRCNABR
          WHERE CDBANCO    = C_BANCO.CDBANCO
            AND CDERRCNABR = P_CDERRCNABR;
      END IF;

      INSERT INTO ERRCNABR (CDBANCO, CDERRCNABR, DSERRCNABR) VALUES (C_BANCO.CDBANCO, P_CDERRCNABR, P_DSERRCNABR);

   END LOOP;
END;
/

BEGIN
-- BANCO BRADESCO 237

   INCLUI_ERRCNABR('237', '0200', '[ENTRADA CONFIRMADA] OCORRENCIA ACEITA');
   INCLUI_ERRCNABR('237', '0217', '[ENTRADA CONFIRMADA] DATA VENCIMENTO ANTERIOR A DATA DE EMISSAO');
   INCLUI_ERRCNABR('237', '0221', '[ENTRADA CONFIRMADA] ESPECIE DO TITULO INVALIDO');
   INCLUI_ERRCNABR('237', '0224', '[ENTRADA CONFIRMADA] DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('237', '0238', '[ENTRADA CONFIRMADA] PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('237', '0239', '[ENTRADA CONFIRMADA] PEDIDO P.PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('237', '0243', '[ENTRADA CONFIRMADA] PRAZO PARA BAIXA DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('237', '0245', '[ENTRADA CONFIRMADA] NOME DO SACADO INVALIDO');
   INCLUI_ERRCNABR('237', '0246', '[ENTRADA CONFIRMADA] TIPO/NUM. DE INSCRICAO DO SACADO INVALIDOS');
   INCLUI_ERRCNABR('237', '0247', '[ENTRADA CONFIRMADA] ENDERECO DO SACADO INVALIDO');
   INCLUI_ERRCNABR('237', '0248', '[ENTRADA CONFIRMADA] CEP INVALIDO');
   INCLUI_ERRCNABR('237', '0250', '[ENTRADA CONFIRMADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('237', '0253', '[ENTRADA CONFIRMADA] N INCR. SACADOR/AVALISTA INVALIDOS (CNPJ/CPF)');
   INCLUI_ERRCNABR('237', '0254', '[ENTRADA CONFIRMADA] SACADOR/AVALISTA NAO INFORMADO');
   INCLUI_ERRCNABR('237', '0267', '[ENTRADA CONFIRMADA] DEB. AUTOMATICO AGENDADO');
   INCLUI_ERRCNABR('237', '0268', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO ERRO NOS DADOS DE REMESSA');
   INCLUI_ERRCNABR('237', '0269', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - SACADO NAO CONSTA NO CAD. AUTORIZANTE');
   INCLUI_ERRCNABR('237', '0270', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - CEDENTE NAO AUTORIZADO PELO SACADO');
   INCLUI_ERRCNABR('237', '0271', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - CEDENTE NAO CADASTRADO P/ DEBITO AUTOMATICO');
   INCLUI_ERRCNABR('237', '0272', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - CODIGO DE MOEDA DIFERENTE DE R$');
   INCLUI_ERRCNABR('237', '0273', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('237', '0275', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - TIPO NUMERO DE INSCRICAO DO DEBITADO INVALIDO');
   INCLUI_ERRCNABR('237', '0286', '[ENTRADA CONFIRMADA] SEU NUMERO INVALIDO');
   INCLUI_ERRCNABR('237', '0302', '[ENTRADA REJEITADA] CODIGO DO REGISTRO DETALHE INVALIDO');
   INCLUI_ERRCNABR('237', '0303', '[ENTRADA REJEITADA] CODIGO DA OCORRENCIA INVALIDO');
   INCLUI_ERRCNABR('237', '0304', '[ENTRADA REJEITADA] COD. DA OCORR. NAO PERMITIDA P/A CARTEIRA');
   INCLUI_ERRCNABR('237', '0305', '[ENTRADA REJEITADA] COD. DA OCORRENCIA NAO NUMERICA');
   INCLUI_ERRCNABR('237', '0308', '[ENTRADA REJEITADA] NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('237', '0309', '[ENTRADA REJEITADA] NOSSO NUMERO DUPLICADO');
   INCLUI_ERRCNABR('237', '0310', '[ENTRADA REJEITADA] CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('237', '0316', '[ENTRADA REJEITADA] DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('237', '0318', '[ENTRADA REJEITADA] VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('237', '0320', '[ENTRADA REJEITADA] VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('237', '0321', '[ENTRADA REJEITADA] ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('237', '0322', '[ENTRADA REJEITADA] ESPECIE NAO PERMITIDA P/ CARTEIRA');
   INCLUI_ERRCNABR('237', '0324', '[ENTRADA REJEITADA] DATA DE EMISSAO INVALIDA');
   INCLUI_ERRCNABR('237', '0350', '[ENTRADA REJEITADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('237', '0363', '[ENTRADA REJEITADA] ENTRADA P/TITULO JA CADASTRADO');
   INCLUI_ERRCNABR('237', '0368', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - ERRO NOS DADOS DE REMESSA');
   INCLUI_ERRCNABR('237', '0369', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - SACADO NAO CONSTA NO CAD. DE AUTORIZANTE');
   INCLUI_ERRCNABR('237', '0370', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - CEDENTE NAO AUTORIZADO PELO SACADO');
   INCLUI_ERRCNABR('237', '0371', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - CEDENTE NAO CADASTRADO P/ DEBITO AUTOMATICO');
   INCLUI_ERRCNABR('237', '0372', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - CODIGO DE MOEDA DIFERENTE DE R$');
   INCLUI_ERRCNABR('237', '0373', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('237', '0374', '[ENTRADA REJEITADA] DEB. NAO AGENDADO, CONFORME SEU PEDIDO, TITULO NAO REGISTRADO');
   INCLUI_ERRCNABR('237', '0375', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - TIPO NUMERO DE INSCRICAO DO DEBITADO INVALIDO');
   INCLUI_ERRCNABR('237', '06  ', '[LIQUIDACAO NORMAL] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '0910', '[BAIXADO AUT. VIA ARQUIVO] BAIXA COMANDADA PELO CLIENTE');
   INCLUI_ERRCNABR('237', '1000', '[BAIXADO CONF. INST. AG.] BAIXA COMANDADA');
   INCLUI_ERRCNABR('237', '1014', '[BAIXADO CONF. INST. AG.] TITULO  PROTESTADO');
   INCLUI_ERRCNABR('237', '1015', '[BAIXADO CONF. INST. AG.] TITULO EXCLUIDO');
   INCLUI_ERRCNABR('237', '11  ', '[EM SER (TITULO PENDENTE)] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '12  ', '[ABATIMENTO CONCEDIDO] -SEM MOTIVO');
   INCLUI_ERRCNABR('237', '13  ', '[ABATIMENTO CANCELADO] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '14  ', '[VENCIMENTO ALTERADO] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '15  ', '[LIQUIDACAO EM CARTORIO] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '17  ', '[LIQUIDACAO APOS BAIXA] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '18  ', '[ACERTO DE DEPOSITARIA] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '19  ', '[CONF.RECEB.INST. PROTESTO ] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '20  ', '[CONF.RECEB.INST.SUST.PROT.] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '21  ', '[ACERTO CONT. PARTICIPANTE] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '23  ', '[ENTRADA TITULO EM CARTORIO] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '2448', '[ENTRADA REJEITADA] CEP INVALIDO');
   INCLUI_ERRCNABR('237', '2707', '[BAIXA REJEITADA] AGENCIA/CONTA/DV. INVALIDO');
   INCLUI_ERRCNABR('237', '2708', '[BAIXA REJEITADA] NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('237', '2710', '[BAIXA REJEITADA] CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('237', '2715', '[BAIXA REJEITADA] CARTEIRA/AG./CONTA/NUM. INVALIDOS');
   INCLUI_ERRCNABR('237', '2740', '[BAIXA REJEITADA] TITULO COM ORDEM DE PROTESTO');
   INCLUI_ERRCNABR('237', '2742', '[BAIXA REJEITADA] CODIGO P/BAIXA/DEV; VIA TELEB. INVALIDO');
   INCLUI_ERRCNABR('237', '2760', '[BAIXA REJEITADA] MOVIMENTO P/TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('237', '2803', '[DEB. DE TARIFAS/CUSTOS] TARIFA DE SUSTACAO(valor informado-posicao 176 a 188)');
   INCLUI_ERRCNABR('237', '2808', '[DEB. DE TARIFAS/CUSTOS] CUSTAS DE PROTESTO(valor informado-posicao 189 a 201)');
   INCLUI_ERRCNABR('237', '2804', '[DEB. DE TARIFAS/CUSTOS] TARIFA DE PROTESTO (valor informado-posicao 176 a 188)');
   INCLUI_ERRCNABR('237', '3001', '[ALTERACAO/DADOS REJEITADOS] CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('237', '3004', '[ALTERACAO/DADOS REJEITADOS] CODIGO DE OCORRENCIA NAO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('237', '3005', '[ALTERACAO/DADOS REJEITADOS] CODIGO DA OCORRENCIA NAO NUMERICO');
   INCLUI_ERRCNABR('237', '3008', '[ALTERACAO/DADOS REJEITADOS] NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('237', '3015', '[ALTERACAO/DADOS REJEITADOS] CARACTERISTICAS  DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('237', '3016', '[ALTERACAO/DADOS REJEITADOS] DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('237', '3017', '[ALTERACAO/DADOS REJEITADOS] DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSAO');
   INCLUI_ERRCNABR('237', '3018', '[ALTERACAO/DADOS REJEITADOS] VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('237', '3024', '[ALTERACAO/DADOS REJEITADOS] DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('237', '3029', '[ALTERACAO/DADOS REJEITADOS] VALOR DESC. MAIOR/IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('237', '3030', '[ALTERACAO/DADOS REJEITADOS] DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('237', '3031', '[ALTERACAO/DADOS REJEITADOS] CONCESSAO DE DESCONTO JA EXISTENTE - DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('237', '3033', '[ALTERACAO/DADOS REJEITADOS] VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('237', '3034', '[ALTERACAO/DADOS REJEITADOS] VALOR ABAT. MAIOR/IGUAL VALOR DO TITULO');
   INCLUI_ERRCNABR('237', '3038', '[ALTERACAO/DADOS REJEITADOS] PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('237', '3039', '[ALTERACAO/DADOS REJEITADOS] PEDIDO DE PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('237', '3040', '[ALTERACAO/DADOS REJEITADOS] TITULO COM ORDEM DE PROTESTO EMITIDO');
   INCLUI_ERRCNABR('237', '3042', '[ALTERACAO/DADOS REJEITADOS] CODIGO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('237', '3060', '[ALTERACAO/DADOS REJEITADOS] MOVIMENTO PARA TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('237', '3085', '[ALTERACAO/DADOS REJEITADOS] TITULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('237', '3201', '[INSTRUCAO REJEITADA] CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('237', '3204', '[INSTRUCAO REJEITADA] CODIGO DE OCORRENCIA NAO PERMITIDO PARA A CARTEIRA');
   INCLUI_ERRCNABR('237', '3215', '[INSTRUCAO REJEITADA] CARACTERISTICAS DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('237', '3216', '[INSTRUCAO REJEITADA] DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('237', '3217', '[INSTRUCAO REJEITADA] DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSAO');
   INCLUI_ERRCNABR('237', '3218', '[INSTRUCAO REJEITADA] VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('237', '3220', '[INSTRUCAO REJEITADA] VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('237', '3221', '[INSTRUCAO REJEITADA] ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('237', '3223', '[INSTRUCAO REJEITADA] ACEITE INVALIDO');
   INCLUI_ERRCNABR('237', '3224', '[INSTRUCAO REJEITADA] DATA DE EMISSAO INVALIDA');
   INCLUI_ERRCNABR('237', '3228', '[INSTRUCAO REJEITADA] CODIGO DO DESCONTO INVALIDO');
   INCLUI_ERRCNABR('237', '3229', '[INSTRUCAO REJEITADA] VALOR DO DESCONTO MAIOR/IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('237', '3230', '[INSTRUCAO REJEITADA] DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('237', '3231', '[INSTRUCAO REJEITADA] CONCESSAO DE DESCONTO-JA EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('237', '3233', '[INSTRUCAO REJEITADA] VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('237', '3234', '[INSTRUCAO REJEITADA] VALOR DO ABATIMENTO MAIOR/IGUAL AO VALOR ANTERIOR');
   INCLUI_ERRCNABR('237', '3236', '[INSTRUCAO REJEITADA] CONCESSAO DE ABATIMENTO-JA EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('237', '3238', '[INSTRUCAO REJEITADA] PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('237', '3239', '[INSTRUCAO REJEITADA] PEDIDO DE PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('237', '3240', '[INSTRUCAO REJEITADA] TITULO COM ORDEM DE PROTESTO EMITIDO');
   INCLUI_ERRCNABR('237', '3241', '[INSTRUCAO REJEITADA] PEDIDO DE CANCELAMENTO P/ TITULOS S/INSTRUCAO PROTESTO');
   INCLUI_ERRCNABR('237', '3242', '[INSTRUCAO REJEITADA] CODIGO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('237', '3245', '[INSTRUCAO REJEITADA] NOME DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('237', '3246', '[INSTRUCAO REJEITADA] TIPO/NUMERO DE INCRICAO DO SACADO INVALIDOS');
   INCLUI_ERRCNABR('237', '3247', '[INSTRUCAO REJEITADA] ENDERECO DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('237', '3248', '[INSTRUCAO REJEITADA] CEP INVALIDO');
   INCLUI_ERRCNABR('237', '3250', '[INSTRUCAO REJEITADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('237', '3253', '[INSTRUCAO REJEITADA] TIPO/NUMERO DE INSCRICAO DO SACADOR AVALISTA INVALIDOS');
   INCLUI_ERRCNABR('237', '3260', '[INSTRUCAO REJEITADA] MOVIMENTO PARA TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('237', '3285', '[INSTRUCAO REJEITADA] TITULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('237', '3286', '[INSTRUCAO REJEITADA] SEU NUMERO INVALIDO');
   INCLUI_ERRCNABR('237', '33  ', '[CONFIRMACAO ALTERACAO DADOS] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '34  ', '[RETIRADO CARTORIO E PENDENTE] SEM MOTIVO');
   INCLUI_ERRCNABR('237', '3581', '[CANCELAMENTO DEB. AUTOM.] TENTATIVAS ESGOTADAS, BAIXADO');
   INCLUI_ERRCNABR('237', '3582', '[CANCELAMENTO DEB. AUTOM.] TENTATIVAS ESGOTADAS, PENDENTE');
   COMMIT;
END;
/
BEGIN
-- BANCO ITAU 341

   INCLUI_ERRCNABR('341', '0303  ', '[Entradas Rejeitadas][AG. COBRADORA] NAO FOI POSSIVEL ATRIBUIR A AGENCIA  PELO CEP OU CEP INVALIDO');
   INCLUI_ERRCNABR('341', '0304  ', '[Entradas Rejeitadas][ESTADO] SIGLA DO ESTADO INVALIDA');
   INCLUI_ERRCNABR('341', '0305  ', '[Entradas Rejeitadas][DATA VENCIMENTO] PRAZO DA OPERACAO MENOR QUE PRAZO MINIMO OU MAIOR QUE O MAXIMO');
   INCLUI_ERRCNABR('341', '0307  ', '[Entradas Rejeitadas][VALOR DO TITULO] VALOR DO TITULO MAIOR QUE 10.000.000,00');
   INCLUI_ERRCNABR('341', '0308  ', '[Entradas Rejeitadas][NOME DO SACADO] NAO INFORMADO OU DESLOCADO');
   INCLUI_ERRCNABR('341', '0309  ', '[Entradas Rejeitadas][AGENCIA/CONTA] AGENCIA ENCERRADA');
   INCLUI_ERRCNABR('341', '0310  ', '[Entradas Rejeitadas][LOGRADOURO] NAO INFORMADO OU DESLOCADO');
   INCLUI_ERRCNABR('341', '0311  ', '[Entradas Rejeitadas][CEP] CEP NAO NUMERICO');
   INCLUI_ERRCNABR('341', '0312  ', '[Entradas Rejeitadas][SACADOR AVALISTA] NOME NAO INFORMADO OU DESLOCADO (BANCOS CORRESPONDENTES)');
   INCLUI_ERRCNABR('341', '0313  ', '[Entradas Rejeitadas][ESTADO/CEP] CEP INCOMPATIVEL COM A SIGLA DO ESTADO');
   INCLUI_ERRCNABR('341', '0314  ', '[Entradas Rejeitadas][NOSSO NUMERO] NOSSO NUMERO JA REGISTRADO NO CADASTRO DO BANCO OU FORA DA FAIXA');
   INCLUI_ERRCNABR('341', '0315  ', '[Entradas Rejeitadas][NOSSO NUMERO] NOSSO NUMERO EM DUPLICIDADE NO MESMO MOVIMENTO');
   INCLUI_ERRCNABR('341', '0318  ', '[Entradas Rejeitadas][DATA DE ENTRADA] DATA DE ENTRADA INVALIDA PARA O OPERAR COM ESTA CARTEIRA');
   INCLUI_ERRCNABR('341', '0319  ', '[Entradas Rejeitadas][OCORRENCIA] OCORRENCIA INVALIDA');
   INCLUI_ERRCNABR('341', '0321  ', '[Entradas Rejeitadas][AG. COBRADORA] CARTEIRA NAO ACEITA DEPOSITARIA CORRESPONDENTE / ESTADO DA AGENCIA DIFERENTE DO ESTADO DO SACADO / AG. COBRADORA NAO CONSTA NO CADASTRO OU  ENCERRANDO');
   INCLUI_ERRCNABR('341', '0322  ', '[Entradas Rejeitadas][CARTEIRA] CARTEIRA NAO PERMITIDA (NECESSARIO CADASTRAR FAIXA LIVRE)');
   INCLUI_ERRCNABR('341', '0327  ', '[Entradas Rejeitadas][CGC INAPTO] CGC DO CEDENTE INAPTO');
   INCLUI_ERRCNABR('341', '0329  ', '[Entradas Rejeitadas][CODIGO EMPRESA] CATEGORIA DA CONTA INVALIDA');
   INCLUI_ERRCNABR('341', '0335  ', '[Entradas Rejeitadas][VALOR DO IOF] IOF MAIOR QUE 5%');
   INCLUI_ERRCNABR('341', '0336  ', '[Entradas Rejeitadas][QTDADE DE MOEDA] QUANTIDADE DE MOEDA INCOMPATIVEL COM VALOR DO TITULO');
   INCLUI_ERRCNABR('341', '0337  ', '[Entradas Rejeitadas][CGC/CPF DO SACADO] NAO NUMERICO OU IGUAL A ZEROS');
   INCLUI_ERRCNABR('341', '0342  ', '[Entradas Rejeitadas][NOSSO NUMERO] NOSSO NUMERO FORA DE FAIXA');
   INCLUI_ERRCNABR('341', '0352  ', '[Entradas Rejeitadas][AG. COBRADORA] EMPRESA NAO ACEITA BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('341', '0353  ', '[Entradas Rejeitadas][AG. COBRADORA] EMPRESA NAO ACEITA BANCO CORRESPONDENTE  - COBRANCA MENSAGEM');
   INCLUI_ERRCNABR('341', '0354  ', '[Entradas Rejeitadas][DATA DE VENCTO] BANCO CORRESPONDENTE - TITULO COM VENCIMENTO INFERIOR A 15 DIAS');
   INCLUI_ERRCNABR('341', '0355  ', '[Entradas Rejeitadas][DEP/BCO CORRESP] CEP NAO PERTENCENTE A DEPOSITARIO INFORMADO');
   INCLUI_ERRCNABR('341', '0356  ', '[Entradas Rejeitadas][DT.VENCTO/BCO CORRESP] VENCTO. SUPERIOR A 180 DIAS DA DATA DE ENTRADA');
   INCLUI_ERRCNABR('341', '0357  ', '[Entradas Rejeitadas][DATA DE VENCTO] CEP SO DEPOSITARIA BCO DO BRASIL COM VENCTO INFERIOR A 8 DIAS');
   INCLUI_ERRCNABR('341', '0360  ', '[Entradas Rejeitadas][ABATIMENTO] VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('341', '0361  ', '[Entradas Rejeitadas][JUROS DE MORA] JUROS DE MORA MAIOR QUE O PERMITIDO');
   INCLUI_ERRCNABR('341', '0362  ', '[Entradas Rejeitadas][DESCONTO] VALOR DO DESCONTO MAIOR QUE O VALOR DO TITULO');
   INCLUI_ERRCNABR('341', '0363  ', '[Entradas Rejeitadas][IMPORTANCIA POR DIA DE DESCONTO] NAO PERMITIDO');
   INCLUI_ERRCNABR('341', '0364  ', '[Entradas Rejeitadas][EMISSAO DO TITULO] DATA DE EMISSAO DO TITULO INVALIDA (VENDOR)');
   INCLUI_ERRCNABR('341', '0365  ', '[Entradas Rejeitadas][TAXA FINANCTO] TAXA INVALIDA (VENDOR)');
   INCLUI_ERRCNABR('341', '0366  ', '[Entradas Rejeitadas][DATA DE VENCTO] INVALIDA/FORA DE PRAZO DE OPERACAO (MINIMO OU MAXIMO)');
   INCLUI_ERRCNABR('341', '0367  ', '[Entradas Rejeitadas][VALOR/QTIDADE] VALOR DO TITULO/QUANTIDADE DE MOEDA INVALIDO');
   INCLUI_ERRCNABR('341', '0368  ', '[Entradas Rejeitadas][CARTEIRA] CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('341', '0398  ', '[Entradas Rejeitadas][FLASH INVALIDO] REGISTRO MENSAGEM SEM FLASH CADASTRADO OU FLASH INFORMADO DIFERENTE DO CADASTRADO');
   INCLUI_ERRCNABR('341', '0399  ', '[Entradas Rejeitadas][FLASH INVALIDO] CONTA DE COBRANCA COM FLASH CADASTRADO, E SEM REGISTRO DE MENSAGEM CORRESPONDENTE');
   INCLUI_ERRCNABR('341', '0391  ', '[Entradas Rejeitadas][DAC] DAC AGENCIA / CONTA CORRENTE INVALIDO');
   INCLUI_ERRCNABR('341', '0392  ', '[Entradas Rejeitadas][DAC] DAC AGENCIA/CONTA/CARTEIRA/NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('341', '0393  ', '[Entradas Rejeitadas][ESTADO] SIGLA ESTADO INVALIDA');
   INCLUI_ERRCNABR('341', '0394  ', '[Entradas Rejeitadas][ESTADO] SIGLA ESTADO INCOMPATIVEL COM CEP DO SACADO');
   INCLUI_ERRCNABR('341', '0395  ', '[Entradas Rejeitadas][CEP] CEP DO SACADO NAO NUMERICO OU INVALIDO');
   INCLUI_ERRCNABR('341', '0396  ', '[Entradas Rejeitadas][ENDERECO] ENDERECO / NOME / CIDADE SACADO INVALIDO');
   INCLUI_ERRCNABR('341', '1702  ', '[Alteracao de dados rejeitados] AGENCIA COBRADORA INVALIDA OU COM O MESMO CONTEUDO');
   INCLUI_ERRCNABR('341', '1704  ', '[Alteracao de dados rejeitados] SIGLA DO ESTADO INVALIDA');
   INCLUI_ERRCNABR('341', '1705  ', '[Alteracao de dados rejeitados] DATA DE VENCIMENTO INVALIDA OU COM O MESMO CONTEUDO');
   INCLUI_ERRCNABR('341', '1706  ', '[Alteracao de dados rejeitados] VALOR DO TITULO COM OUTRA ALTERACAO SIMULTANEA');
   INCLUI_ERRCNABR('341', '1708  ', '[Alteracao de dados rejeitados] NOME DO SACADO COM O MESMO CONTEUDO');
   INCLUI_ERRCNABR('341', '1709  ', '[Alteracao de dados rejeitados] AGENCIA/CONTA INCORRETOS');
   INCLUI_ERRCNABR('341', '1711  ', '[Alteracao de dados rejeitados] CEP INVALIDO');
   INCLUI_ERRCNABR('341', '1713  ', '[Alteracao de dados rejeitados] SEU NUMERO COM O MESMO CONTEUDO');
   INCLUI_ERRCNABR('341', '1716  ', '[Alteracao de dados rejeitados] ABATIMENTO/ALTERACAO DO VALOR DO TITULO OU SOLICITACAO DE BAIXA BLOQUEADA');
   INCLUI_ERRCNABR('341', '1721  ', '[Alteracao de dados rejeitados] AGENCIA COBRADORA NAO CONSTA NO CADASTRO DE DEPOSITARIA OU EM ENCERRAMENTO');
   INCLUI_ERRCNABR('341', '1753  ', '[Alteracao de dados rejeitados] INSTRUCAO COM O MESMO CONTEUDO');
   INCLUI_ERRCNABR('341', '1754  ', '[Alteracao de dados rejeitados] DATA VENCIMENTO PARA BANCOS CORRESPONDENTES INFERIOR AO ACEITO PELO BANCO');
   INCLUI_ERRCNABR('341', '1755  ', '[Alteracao de dados rejeitados] ALTERACOES IGUAIS PARA O MESMO CONTROLE (AGENCIA/CONTA/CARTEIRA/NOSSO NUMERO)');
   INCLUI_ERRCNABR('341', '1756  ', '[Alteracao de dados rejeitados] CGC/CPF INVALIDO NAO NUMERICO OU ZERADO');
   INCLUI_ERRCNABR('341', '1757  ', '[Alteracao de dados rejeitados] PRAZO DE VENCIMENTO INFERIOR A 15 DIAS');
   INCLUI_ERRCNABR('341', '1760  ', '[Alteracao de dados rejeitados] VALOR DE IOF - ALTERACAO NAO PERMITIDA PARA CARTEIRAS DE N.S. - MOEDA VARIAVEL');
   INCLUI_ERRCNABR('341', '1761  ', '[Alteracao de dados rejeitados] TITULO JA BAIXADO OU LIQUIDADO OU NAO EXISTE TITULO CORRESPONDENTE NO SISTEMA');
   INCLUI_ERRCNABR('341', '1766  ', '[Alteracao de dados rejeitados] ALTERACAO NAO PERMITIDA PARA CARTEIRAS DE NOTAS DE SEGUROS - MOEDA VARIAVEL');
   INCLUI_ERRCNABR('341', '1781  ', '[Alteracao de dados rejeitados] ALTERACAO BLOQUEADA - TITULO COM PROTESTO');
   INCLUI_ERRCNABR('341', '1601  ', '[Instrucoes rejeitadas] INSTRUCAO/OCORRENCIA NAO EXISTENTE');
   INCLUI_ERRCNABR('341', '1606  ', '[Instrucoes rejeitadas] NOSSO NUMERO IGUAL A ZEROS');
   INCLUI_ERRCNABR('341', '1609  ', '[Instrucoes rejeitadas] CGC/CPF  DO SACADOR/AVALISTA INVALIDO');
   INCLUI_ERRCNABR('341', '1610  ', '[Instrucoes rejeitadas] VALOR DO ABATIMENTO IGUAL OU MAIOR QUE O VALOR DO TITULO');
   INCLUI_ERRCNABR('341', '1614  ', '[Instrucoes rejeitadas] REGISTRO EM DUPLICIDADE');
   INCLUI_ERRCNABR('341', '1615  ', '[Instrucoes rejeitadas] CGC/CPF INFORMADO SEM NOME DO SACADOR/AVALISTA');
   INCLUI_ERRCNABR('341', '1621  ', '[Instrucoes rejeitadas] TITULO NAO REGISTRADO NO SISTEMA');
   INCLUI_ERRCNABR('341', '1622  ', '[Instrucoes rejeitadas] TITULO BAIXADO OU LIQUIDADO');
   INCLUI_ERRCNABR('341', '1623  ', '[Instrucoes rejeitadas] INSTRUCAO NAO ACEITA POR TER SIDO EMITIDO ULTIMO AVISO AO SACADO');
   INCLUI_ERRCNABR('341', '1624  ', '[Instrucoes rejeitadas] INSTRUCAO INCOMPATIVEL - EXISTE INSTRUCAO DE PROTESTO PARA O TITULO');
   INCLUI_ERRCNABR('341', '1625  ', '[Instrucoes rejeitadas] INSTRUCAO INCOMPATIVEL - NAO EXISTE INSTRUCAO DE PROTESTO PARA O TITULO');
   INCLUI_ERRCNABR('341', '1626  ', '[Instrucoes rejeitadas] INSTRUCAO NAO ACEITA POR TER SIDO EMITIDO ULTIMO AVISO AO SACADO');
   INCLUI_ERRCNABR('341', '1627  ', '[Instrucoes rejeitadas] INSTRUCAO NAO ACEITA POR NAO TER SIDO EMITIDA A ORDEM DE PROTESTO AO CARTORIO');
   INCLUI_ERRCNABR('341', '1628  ', '[Instrucoes rejeitadas] JA EXISTE UMA MESMA INSTRUCAO CADASTRADA ANTERIORMENTE PARA O TITULO');
   INCLUI_ERRCNABR('341', '1629  ', '[Instrucoes rejeitadas] VALOR LIQUIDO + VALOR DO ABATIMENTO DIFERENTE DO VALOR DO TITULO REGISTRADO');
   INCLUI_ERRCNABR('341', '1630  ', '[Instrucoes rejeitadas] EXISTE UMA INSTRUCAO DE NAO PROTESTAR ATIVA PARA O TITULO');
   INCLUI_ERRCNABR('341', '1631  ', '[Instrucoes rejeitadas] EXISTE UMA OCORRENCIA DO SACADO QUE BLOQUEIA A INSTRUCAO');
   INCLUI_ERRCNABR('341', '1632  ', '[Instrucoes rejeitadas] DEPOSITARIA DO TITULO = 9999 OU CARTEIRA NAO ACEITA PROTESTO');
   INCLUI_ERRCNABR('341', '1633  ', '[Instrucoes rejeitadas] ALTERACAO DE VENCIMENTO IGUAL A REGISTRADA NO SISTEMA OU QUE TORNA O TITULO VENCIDO');
   INCLUI_ERRCNABR('341', '1634  ', '[Instrucoes rejeitadas] INSTRUCAO DE EMISSAO DE AVISO DE COBRANCA PARA TITULO VENCIDO ANTES DO VENCIMENTO');
   INCLUI_ERRCNABR('341', '1635  ', '[Instrucoes rejeitadas] SOLICITACAO DE CANCELAMENTO DE INSTRUCAO INEXISTENTE');
   INCLUI_ERRCNABR('341', '1636  ', '[Instrucoes rejeitadas] TITULO SOFRENDO ALTERACAO DE CONTROLE (AGENCIA/CONTA/CARTEIRA/NOSSO NUMERO)');
   INCLUI_ERRCNABR('341', '1637  ', '[Instrucoes rejeitadas] INSTRUCAO NAO PERMITIDA PARA A CARTEIRA');
   INCLUI_ERRCNABR('341', '1501  ', '[Baixas rejeitadas] CARTEIRA/N NUMERO NAO NUMERICO');
   INCLUI_ERRCNABR('341', '1504  ', '[Baixas rejeitadas] NOSSO NUMERO EM DUPLICIDADE NUM MESMO MOVIMENTO');
   INCLUI_ERRCNABR('341', '1505  ', '[Baixas rejeitadas] SOLICITACAO DE BAIXA PARA TITULO JA BAIXADO OU LIQUIDADO');
   INCLUI_ERRCNABR('341', '1506  ', '[Baixas rejeitadas] SOLICITACAO DE BAIXA PARA TITULO NAO REGISTRADO NO SISTEMA');
   INCLUI_ERRCNABR('341', '1507  ', '[Baixas rejeitadas] COBRANCA PRAZO CURTO - SOLICITACAO DE BAIXA P/ TITULO NAO REGISTRADO NO SISTEMA');
   INCLUI_ERRCNABR('341', '1508  ', '[Baixas rejeitadas] SOLICITACAO DE BAIXA PARA TITULO EM FLOATING');
   INCLUI_ERRCNABR('341', '1816  ', '[Alteracao dados cobranca contratual rejeitada] ABATIMENTO/ALTERACAO DO VALOR DO TITULO OU SOLICITACAO DE BAIXAS BLOQUEADOS');
   INCLUI_ERRCNABR('341', '251313', '[Alegacoes do sacado] SACADO SOLICITA A PRORROGACAO DO VENCIMENTO PARA:');
   INCLUI_ERRCNABR('341', '251321', '[Alegacoes do sacado] SACADO SOLICITA A DISPENSA DOS JUROS DE MORA');
   INCLUI_ERRCNABR('341', '251339', '[Alegacoes do sacado] SACADO ALEGA QUE NAO RECEBEU A MERCADORIA');
   INCLUI_ERRCNABR('341', '251347', '[Alegacoes do sacado] SACADO ALEGA QUE A MERCADORIA CHEGOU ATRASADA');
   INCLUI_ERRCNABR('341', '251354', '[Alegacoes do sacado] SACADO ALEGA QUE A MERCADORIA CHEGOU AVARIADA');
   INCLUI_ERRCNABR('341', '251362', '[Alegacoes do sacado] SACADO ALEGA QUE A MERCADORIA CHEGOU INCOMPLETA');
   INCLUI_ERRCNABR('341', '251370', '[Alegacoes do sacado] SACADO ALEGA QUE A MERCADORIA NAO CONFERE COM O PEDIDO');
   INCLUI_ERRCNABR('341', '251388', '[Alegacoes do sacado] SACADO ALEGA QUE A MERCADORIA ESTA A DISPOSICAO');
   INCLUI_ERRCNABR('341', '251396', '[Alegacoes do sacado] SACADO ALEGA QUE DEVOLVEU A MERCADORIA');
   INCLUI_ERRCNABR('341', '251404', '[Alegacoes do sacado] SACADO ALEGA QUE NAO RECEBEU A FATURA');
   INCLUI_ERRCNABR('341', '251412', '[Alegacoes do sacado] SACADO ALEGA QUE A FATURA ESTA EM DESACORDO COM A NOTA FISCAL');
   INCLUI_ERRCNABR('341', '251420', '[Alegacoes do sacado] SACADO ALEGA QUE O PEDIDO DE COMPRA FOI CANCELADO');
   INCLUI_ERRCNABR('341', '251438', '[Alegacoes do sacado] SACADO ALEGA QUE A DUPLICATA FOI CANCELADA');
   INCLUI_ERRCNABR('341', '251446', '[Alegacoes do sacado] SACADO ALEGA QUE NADA DEVE OU COMPROU');
   INCLUI_ERRCNABR('341', '251453', '[Alegacoes do sacado] SACADO ALEGA QUE MANTEM ENTENDIMENTOS COM O SACADOR');
   INCLUI_ERRCNABR('341', '251461', '[Alegacoes do sacado] SACADO ALEGA QUE PAGARA O TITULO EM:');
   INCLUI_ERRCNABR('341', '251479', '[Alegacoes do sacado] SACADO ALEGA QUE PAGOU O TITULO DIRETAMENTE AO CEDENTE EM:');
   INCLUI_ERRCNABR('341', '251487', '[Alegacoes do sacado] SACADO ALEGA QUE PAGARA O TITULO DIRETAMENTE AO CEDENTE EM:');
   INCLUI_ERRCNABR('341', '251495', '[Alegacoes do sacado] SACADO ALEGA QUE O VENCIMENTO CORRETO E:');
   INCLUI_ERRCNABR('341', '251503', '[Alegacoes do sacado] SACADO ALEGA QUE TEM DESCONTO OU ABATIMENTO DE:');
   INCLUI_ERRCNABR('341', '251719', '[Alegacoes do sacado] SACADO NAO FOI LOCALIZADO; CONFIRMAR ENDERECO');
   INCLUI_ERRCNABR('341', '251727', '[Alegacoes do sacado] SACADO ESTA EM REGIME DE CONCORDATA');
   INCLUI_ERRCNABR('341', '251735', '[Alegacoes do sacado] SACADO ESTA EM REGIME DE FALENCIA');
   INCLUI_ERRCNABR('341', '251750', '[Alegacoes do sacado] SACADO SE RECUSA A PAGAR JUROS BANCARIOS');
   INCLUI_ERRCNABR('341', '251768', '[Alegacoes do sacado] SACADO SE RECUSA A PAGAR COMISSAO DE PERMANENCIA');
   INCLUI_ERRCNABR('341', '251776', '[Alegacoes do sacado] NAO FOI POSSIVEL A ENTREGA DO BLOQUETO AO SACADO');
   INCLUI_ERRCNABR('341', '251784', '[Alegacoes do sacado] BLOQUETO NAO ENTREGUE, MUDOU-SE/DESCONHECIDO');
   INCLUI_ERRCNABR('341', '251792', '[Alegacoes do sacado] BLOQUETO NAO ENTREGUE, CEP ERRADO/INCOMPLETO');
   INCLUI_ERRCNABR('341', '251800', '[Alegacoes do sacado] BLOQUETO NAO ENTREGUE, NUMERO NAO EXISTE/ENDERECO INCOMPLETO');
   INCLUI_ERRCNABR('341', '243111', '[Ordem de protesto sustada] SUSTACAO SOLICITADA AG. CEDENTE');
   INCLUI_ERRCNABR('341', '243228', '[Ordem de protesto sustada] ATOS DA CORREGEDORIA ESTADUAL');
   INCLUI_ERRCNABR('341', '243301', '[Ordem de protesto sustada] CGC/CPF DO SACADO INVALIDO/INCORRETO');
   INCLUI_ERRCNABR('341', '243319', '[Ordem de protesto sustada] SACADOR/AVALISTA E PESSOA FISICA');
   INCLUI_ERRCNABR('341', '243327', '[Ordem de protesto sustada] CEP DO SACADO INCORRETO');
   INCLUI_ERRCNABR('341', '243335', '[Ordem de protesto sustada] DEPOSITARIA INCOMPATIVEL COM CEP DO SACADO');
   INCLUI_ERRCNABR('341', '243343', '[Ordem de protesto sustada] CGC/CPF SACADOR INVALIDO/INCORRETO');
   INCLUI_ERRCNABR('341', '243350', '[Ordem de protesto sustada] ENDERECO DO SACADO INSUFICIENTE');
   INCLUI_ERRCNABR('341', '243368', '[Ordem de protesto sustada] PRACA PAGTO INCOMPATIVEL COM ENDERECO');
   INCLUI_ERRCNABR('341', '243376', '[Ordem de protesto sustada] FALTA NUMERO/ESPECIE DO TITULO');
   INCLUI_ERRCNABR('341', '243384', '[Ordem de protesto sustada] TITULO ACEITO S/ ASSINATURA DO SACADOR');
   INCLUI_ERRCNABR('341', '243392', '[Ordem de protesto sustada] TITULO ACEITO S/ ENDOSSO CEDENTE OU IRREGULAR');
   INCLUI_ERRCNABR('341', '243400', '[Ordem de protesto sustada] TITULO SEM LOCAL OU DATA DE EMISSAO');
   INCLUI_ERRCNABR('341', '243418', '[Ordem de protesto sustada] TITULO ACEITO VALOR EXTENSO DIFERENTE DO NUMERICO');
   INCLUI_ERRCNABR('341', '243426', '[Ordem de protesto sustada] TITULO ACEITO DEFINIR ESPECIE DA DUPLICATA');
   INCLUI_ERRCNABR('341', '243434', '[Ordem de protesto sustada] DATA EMISSAO POSTERIOR AO VENCIMENTO');
   INCLUI_ERRCNABR('341', '243442', '[Ordem de protesto sustada] TITULO ACEITO DOCUMENTO NAO PROSTESTAVEL');
   INCLUI_ERRCNABR('341', '243459', '[Ordem de protesto sustada] TITULO ACEITO EXTENSO VENCIMENTO IRREGULAR');
   INCLUI_ERRCNABR('341', '243467', '[Ordem de protesto sustada] TITULO ACEITO FALTA NOME FAVORECIDO');
   INCLUI_ERRCNABR('341', '243475', '[Ordem de protesto sustada] TITULO ACEITO FALTA PRACA DE PAGAMENTO');
   INCLUI_ERRCNABR('341', '243483', '[Ordem de protesto sustada] TITULO ACEITO FALTA CPF ASSINANTE CHEQUE');
   COMMIT;
END;
/
BEGIN
-- BANCO HSBC 399

   INCLUI_ERRCNABR('399', '0301', '[ENTRADA REJEITADA] CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('399', '0302', '[ENTRADA REJEITADA] CODIGO DO REGISTRO DETALHE INVALIDO');
   INCLUI_ERRCNABR('399', '0303', '[ENTRADA REJEITADA] CODIGO DO SEGMENTO INVALIDO');
   INCLUI_ERRCNABR('399', '0304', '[ENTRADA REJEITADA] CODIGO DO MOVIMENTO NAO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('399', '0305', '[ENTRADA REJEITADA] CODIGO DE MOVIMENTO INVALIDO');
   INCLUI_ERRCNABR('399', '0306', '[ENTRADA REJEITADA] TIPO/NUMERO DE INSCRICAO DO CEDENTE INVALIDOS');
   INCLUI_ERRCNABR('399', '0307', '[ENTRADA REJEITADA] CODIGO DE CONVENIO INVALIDO OU NAO CADASTRADO');
   INCLUI_ERRCNABR('399', '0308', '[ENTRADA REJEITADA] NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('399', '0309', '[ENTRADA REJEITADA] NOSSO NUMERO DUPLICADO');
   INCLUI_ERRCNABR('399', '0310', '[ENTRADA REJEITADA] CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('399', '0311', '[ENTRADA REJEITADA] FORMA DE CADASTRAMENTO DO TITULO INVALIDO');
   INCLUI_ERRCNABR('399', '0312', '[ENTRADA REJEITADA] TIPO DE DOCUMENTO INVALIDO');
   INCLUI_ERRCNABR('399', '0313', '[ENTRADA REJEITADA] IDENTIFICACAO DA EMISSAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('399', '0314', '[ENTRADA REJEITADA] IDENTIFICACAO DA DISTRIBUICAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('399', '0315', '[ENTRADA REJEITADA] CARACTERISTICAS DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('399', '0316', '[ENTRADA REJEITADA] DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('399', '0320', '[ENTRADA REJEITADA] VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('399', '0321', '[ENTRADA REJEITADA] ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('399', '0323', '[ENTRADA REJEITADA] ACEITE INVALIDO');
   INCLUI_ERRCNABR('399', '0324', '[ENTRADA REJEITADA] DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('399', '0326', '[ENTRADA REJEITADA] CODIGO DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('399', '0327', '[ENTRADA REJEITADA] VALOR/TAXA DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('399', '0328', '[ENTRADA REJEITADA] CODIGO DO DESCONTO INVALIDO');
   INCLUI_ERRCNABR('399', '0330', '[ENTRADA REJEITADA] DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('399', '0333', '[ENTRADA REJEITADA] VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('399', '0335', '[ENTRADA REJEITADA] ABATIMENTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('399', '0337', '[ENTRADA REJEITADA] CODIGO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('399', '0338', '[ENTRADA REJEITADA] PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('399', '0342', '[ENTRADA REJEITADA] CODIGO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('399', '0343', '[ENTRADA REJEITADA] PRAZO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('399', '0344', '[ENTRADA REJEITADA] CODIGO DA MOEDA INVALIDO');
   INCLUI_ERRCNABR('399', '0345', '[ENTRADA REJEITADA] NOME DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('399', '0346', '[ENTRADA REJEITADA] TIPO/NUMERO DE INSCRICAO DO SACADO INVALIDOS');
   INCLUI_ERRCNABR('399', '0347', '[ENTRADA REJEITADA] ENDERECO DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('399', '0348', '[ENTRADA REJEITADA] CEP INVALIDO');
   INCLUI_ERRCNABR('399', '0349', '[ENTRADA REJEITADA] CEP SEM PRACA DE COBRANCA (NAO LOCALIZADO)');
   INCLUI_ERRCNABR('399', '0350', '[ENTRADA REJEITADA] CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('399', '0352', '[ENTRADA REJEITADA] UNIDADE DA FEDERACAO INVALIDA');
   INCLUI_ERRCNABR('399', '0357', '[ENTRADA REJEITADA] CODIGO DA MULTA INVALIDO');
   INCLUI_ERRCNABR('399', '0358', '[ENTRADA REJEITADA] DATA DA MULTA INVALIDA');
   INCLUI_ERRCNABR('399', '0359', '[ENTRADA REJEITADA] VALOR/PERCENTUAL DA MULTA INVALIDO');
   INCLUI_ERRCNABR('399', '0362', '[ENTRADA REJEITADA] TIPO DE IMPRESSAO INVALIDO');
   INCLUI_ERRCNABR('399', '0363', '[ENTRADA REJEITADA] ENTRADA PARA TITULO JA CADASTRADO');
   INCLUI_ERRCNABR('399', '2601', '[ENTRADA REJEITADA] CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('399', '2602', '[ENTRADA REJEITADA] CODIGO DO REGISTRO DETALHE INVALIDO');
   INCLUI_ERRCNABR('399', '2603', '[ENTRADA REJEITADA] CODIGO DO SEGMENTO INVALIDO');
   INCLUI_ERRCNABR('399', '2604', '[ENTRADA REJEITADA] CODIGO DO MOVIMENTO NAO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('399', '2605', '[ENTRADA REJEITADA] CODIGO DE MOVIMENTO INVALIDO');
   INCLUI_ERRCNABR('399', '2606', '[ENTRADA REJEITADA] TIPO/NUMERO DE INSCRICAO DO CEDENTE INVALIDOS');
   INCLUI_ERRCNABR('399', '2607', '[ENTRADA REJEITADA] CODIGO DE CONVENIO INVALIDO OU NAO CADASTRADO');
   INCLUI_ERRCNABR('399', '2608', '[ENTRADA REJEITADA] NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('399', '2609', '[ENTRADA REJEITADA] NOSSO NUMERO DUPLICADO');
   INCLUI_ERRCNABR('399', '2610', '[ENTRADA REJEITADA] CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('399', '2611', '[ENTRADA REJEITADA] FORMA DE CADASTRAMENTO DO TITULO INVALIDO');
   INCLUI_ERRCNABR('399', '2612', '[ENTRADA REJEITADA] TIPO DE DOCUMENTO INVALIDO');
   INCLUI_ERRCNABR('399', '2613', '[ENTRADA REJEITADA] IDENTIFICACAO DA EMISSAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('399', '2614', '[ENTRADA REJEITADA] IDENTIFICACAO DA DISTRIBUICAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('399', '2615', '[ENTRADA REJEITADA] CARACTERISTICAS DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('399', '2616', '[ENTRADA REJEITADA] DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('399', '2620', '[ENTRADA REJEITADA] VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('399', '2621', '[ENTRADA REJEITADA] ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('399', '2623', '[ENTRADA REJEITADA] ACEITE INVALIDO');
   INCLUI_ERRCNABR('399', '2624', '[ENTRADA REJEITADA] DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('399', '2626', '[ENTRADA REJEITADA] CODIGO DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('399', '2627', '[ENTRADA REJEITADA] VALOR/TAXA DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('399', '2628', '[ENTRADA REJEITADA] CODIGO DO DESCONTO INVALIDO');
   INCLUI_ERRCNABR('399', '2630', '[ENTRADA REJEITADA] DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('399', '2633', '[ENTRADA REJEITADA] VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('399', '2635', '[ENTRADA REJEITADA] ABATIMENTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('399', '2637', '[ENTRADA REJEITADA] CODIGO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('399', '2638', '[ENTRADA REJEITADA] PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('399', '2642', '[ENTRADA REJEITADA] CODIGO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('399', '2643', '[ENTRADA REJEITADA] PRAZO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('399', '2644', '[ENTRADA REJEITADA] CODIGO DA MOEDA INVALIDO');
   INCLUI_ERRCNABR('399', '2645', '[ENTRADA REJEITADA] NOME DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('399', '2646', '[ENTRADA REJEITADA] TIPO/NUMERO DE INSCRICAO DO SACADO INVALIDOS');
   INCLUI_ERRCNABR('399', '2647', '[ENTRADA REJEITADA] ENDERECO DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('399', '2648', '[ENTRADA REJEITADA] CEP INVALIDO');
   INCLUI_ERRCNABR('399', '2649', '[ENTRADA REJEITADA] CEP SEM PRACA DE COBRANCA (NAO LOCALIZADO)');
   INCLUI_ERRCNABR('399', '2650', '[ENTRADA REJEITADA] CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('399', '2652', '[ENTRADA REJEITADA] UNIDADE DA FEDERACAO INVALIDA');
   INCLUI_ERRCNABR('399', '2657', '[ENTRADA REJEITADA] CODIGO DA MULTA INVALIDO');
   INCLUI_ERRCNABR('399', '2658', '[ENTRADA REJEITADA] DATA DA MULTA INVALIDA');
   INCLUI_ERRCNABR('399', '2659', '[ENTRADA REJEITADA] VALOR/PERCENTUAL DA MULTA INVALIDO');
   INCLUI_ERRCNABR('399', '2662', '[ENTRADA REJEITADA] TIPO DE IMPRESSAO INVALIDO');
   INCLUI_ERRCNABR('399', '2663', '[ENTRADA REJEITADA] ENTRADA PARA TITULO JA CADASTRADO');
   INCLUI_ERRCNABR('399', '3001', '[ENTRADA REJEITADA] CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('399', '3002', '[ENTRADA REJEITADA] CODIGO DO REGISTRO DETALHE INVALIDO');
   INCLUI_ERRCNABR('399', '3003', '[ENTRADA REJEITADA] CODIGO DO SEGMENTO INVALIDO');
   INCLUI_ERRCNABR('399', '3004', '[ENTRADA REJEITADA] CODIGO DO MOVIMENTO NAO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('399', '3005', '[ENTRADA REJEITADA] CODIGO DE MOVIMENTO INVALIDO');
   INCLUI_ERRCNABR('399', '3006', '[ENTRADA REJEITADA] TIPO/NUMERO DE INSCRICAO DO CEDENTE INVALIDOS');
   INCLUI_ERRCNABR('399', '3007', '[ENTRADA REJEITADA] CODIGO DE CONVENIO INVALIDO OU NAO CADASTRADO');
   INCLUI_ERRCNABR('399', '3008', '[ENTRADA REJEITADA] NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('399', '3009', '[ENTRADA REJEITADA] NOSSO NUMERO DUPLICADO');
   INCLUI_ERRCNABR('399', '3010', '[ENTRADA REJEITADA] CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('399', '3011', '[ENTRADA REJEITADA] FORMA DE CADASTRAMENTO DO TITULO INVALIDO');
   INCLUI_ERRCNABR('399', '3012', '[ENTRADA REJEITADA] TIPO DE DOCUMENTO INVALIDO');
   INCLUI_ERRCNABR('399', '3013', '[ENTRADA REJEITADA] IDENTIFICACAO DA EMISSAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('399', '3014', '[ENTRADA REJEITADA] IDENTIFICACAO DA DISTRIBUICAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('399', '3015', '[ENTRADA REJEITADA] CARACTERISTICAS DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('399', '3016', '[ENTRADA REJEITADA] DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('399', '3020', '[ENTRADA REJEITADA] VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('399', '3021', '[ENTRADA REJEITADA] ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('399', '3023', '[ENTRADA REJEITADA] ACEITE INVALIDO');
   INCLUI_ERRCNABR('399', '3024', '[ENTRADA REJEITADA] DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('399', '3026', '[ENTRADA REJEITADA] CODIGO DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('399', '3027', '[ENTRADA REJEITADA] VALOR/TAXA DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('399', '3028', '[ENTRADA REJEITADA] CODIGO DO DESCONTO INVALIDO');
   INCLUI_ERRCNABR('399', '3030', '[ENTRADA REJEITADA] DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('399', '3033', '[ENTRADA REJEITADA] VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('399', '3035', '[ENTRADA REJEITADA] ABATIMENTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('399', '3037', '[ENTRADA REJEITADA] CODIGO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('399', '3038', '[ENTRADA REJEITADA] PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('399', '3042', '[ENTRADA REJEITADA] CODIGO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('399', '3043', '[ENTRADA REJEITADA] PRAZO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('399', '3044', '[ENTRADA REJEITADA] CODIGO DA MOEDA INVALIDO');
   INCLUI_ERRCNABR('399', '3045', '[ENTRADA REJEITADA] NOME DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('399', '3046', '[ENTRADA REJEITADA] TIPO/NUMERO DE INSCRICAO DO SACADO INVALIDOS');
   INCLUI_ERRCNABR('399', '3047', '[ENTRADA REJEITADA] ENDERECO DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('399', '3048', '[ENTRADA REJEITADA] CEP INVALIDO');
   INCLUI_ERRCNABR('399', '3049', '[ENTRADA REJEITADA] CEP SEM PRACA DE COBRANCA (NAO LOCALIZADO)');
   INCLUI_ERRCNABR('399', '3050', '[ENTRADA REJEITADA] CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('399', '3052', '[ENTRADA REJEITADA] UNIDADE DA FEDERACAO INVALIDA');
   INCLUI_ERRCNABR('399', '3057', '[ENTRADA REJEITADA] CODIGO DA MULTA INVALIDO');
   INCLUI_ERRCNABR('399', '3058', '[ENTRADA REJEITADA] DATA DA MULTA INVALIDA');
   INCLUI_ERRCNABR('399', '3059', '[ENTRADA REJEITADA] VALOR/PERCENTUAL DA MULTA INVALIDO');
   INCLUI_ERRCNABR('399', '3062', '[ENTRADA REJEITADA] TIPO DE IMPRESSAO INVALIDO');
   INCLUI_ERRCNABR('399', '3063', '[ENTRADA REJEITADA] ENTRADA PARA TITULO JA CADASTRADO');
   COMMIT;
END;
/
BEGIN
-- BANCO SAFRA 422

   INCLUI_ERRCNABR('422', '001', 'MOEDA INVALIDA');
   INCLUI_ERRCNABR('422', '002', 'MOEDA INVALIDA PARA CARTEIRA');
   INCLUI_ERRCNABR('422', '003', 'CARTEIRA 3 INVALIDA PARA TIPO DE MOEDA');
   INCLUI_ERRCNABR('422', '004', 'TIPO DE IOF INVALIDO PARA COBRACA DE SEGUROS');
   INCLUI_ERRCNABR('422', '005', 'TIPO DE IOF INVALIDO PARA VALOR DE IOF(SEGUROS)');
   INCLUI_ERRCNABR('422', '006', 'VALOR DE IOF INVALIDO(SEGUROS)');
   INCLUI_ERRCNABR('422', '007', 'CEP NAO CORRESPONDENDE UF');
   INCLUI_ERRCNABR('422', '008', 'VALOR JUROS MAIOR QUE 5% DO VALOR DO TITULO');
   INCLUI_ERRCNABR('422', '009', 'SEU NUMERO - NAO NUMERICO PARA CHEQUE');
   INCLUI_ERRCNABR('422', '010', 'USO EXCLUSIVO NAO NUMERICO PARA COBRANCA EXPRESS');
   INCLUI_ERRCNABR('422', '011', 'NOSSO NUMERO FORA DA CAIXA');
   INCLUI_ERRCNABR('422', '012', 'CEP DE CIDADE INEXISTENTE');
   INCLUI_ERRCNABR('422', '013', 'CEP FORA DE FAIXA DA CIDADE');
   INCLUI_ERRCNABR('422', '014', 'UF INVALIDO PARA CEP DA CIDADE');
   INCLUI_ERRCNABR('422', '015', 'CEP ZERADO');
   INCLUI_ERRCNABR('422', '016', 'CEP NAO CONSTA NA TABELA SAFRA');
   INCLUI_ERRCNABR('422', '017', 'CEP NAO CONSTA TABELA BCO CORRESPONDENTE');
   INCLUI_ERRCNABR('422', '018', 'DADOS DO CHEQUE NAO NUMERICO');
   INCLUI_ERRCNABR('422', '019', 'PROTESTO IMPRATICAVEL');
   INCLUI_ERRCNABR('422', '020', 'PRIMEIRA INSTRUCAO DE COBRANCA INVALIDA');
   INCLUI_ERRCNABR('422', '021', 'SEGUNDA INSTRUCAO DE COBRANCA INVALIDA');
   INCLUI_ERRCNABR('422', '022', 'SEGUNDA INSTR(10) E TERCEIRA INSTR INVALIDA');
   INCLUI_ERRCNABR('422', '023', 'TERCEIRA INTRUCAO DE COBRANCA INVALIDA ');
   INCLUI_ERRCNABR('422', '024', 'DIGITO VERIFICADOR C1 INVALIDO');
   INCLUI_ERRCNABR('422', '025', 'DIGITO VERIFICADOR C2 INVALIDO');
   INCLUI_ERRCNABR('422', '026', 'CODIGO DE OPERACAO/ OCORRENCIA INVALIDO');
   INCLUI_ERRCNABR('422', '027', 'OPERACAO INVALIDA PARA O CLIENTE');
   INCLUI_ERRCNABR('422', '028', 'NOSSO NUMERO NAO NUMERICO OU ZERADO');
   INCLUI_ERRCNABR('422', '029', 'NOSSO NUMERO COM DIGITO DE CONTROLE ERRADO');
   INCLUI_ERRCNABR('422', '030', 'VALOR DE ABATIMENTO NAO NUMERICO OU ZERADO');
   INCLUI_ERRCNABR('422', '031', 'SEU NUMERO EM BRANCO');
   INCLUI_ERRCNABR('422', '032', 'CODIGO DA CARTEIRA INVALIDO');
   INCLUI_ERRCNABR('422', '033', 'DIGITO VERIFICADOR C3 INVALIDO');
   INCLUI_ERRCNABR('422', '034', 'CODIGO DO TITULO INVALIDO');
   INCLUI_ERRCNABR('422', '035', 'DATA DE MOVIMENTO INVALIDA');
   INCLUI_ERRCNABR('422', '036', 'DATA DE EMISSAO');
   INCLUI_ERRCNABR('422', '037', 'DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('422', '038', 'DEPOSITARIA INVALIDA');
   INCLUI_ERRCNABR('422', '039', 'DEPOSITARIA INVALIDA PARA O CLIENTE');
   INCLUI_ERRCNABR('422', '040', 'DEPOSITARIA NAO CADASTRADA NO BANCO');
   INCLUI_ERRCNABR('422', '041', 'CODIGO DE ACEITE INVALIDO');
   INCLUI_ERRCNABR('422', '042', 'ESPECIE DE TITULO INVALIDO');
   INCLUI_ERRCNABR('422', '043', 'INSTRUCAO DE COBRANCA INVALIDA');
   INCLUI_ERRCNABR('422', '044', 'VALOR DO TITULO NAO NUMERICO OU ZERADO');
   INCLUI_ERRCNABR('422', '045', 'DATA DE OPERACAO');
   INCLUI_ERRCNABR('422', '046', 'VALOR DE JUROS NAO NUMERICO OU ZERADO');
   INCLUI_ERRCNABR('422', '047', 'DATA LIMITE PARA DESCONTO INVALIDA');
   INCLUI_ERRCNABR('422', '048', 'VALOR DO DESCONTO INVALIDO');
   INCLUI_ERRCNABR('422', '049', 'VALOR IOF NAO NUMERICO OU ZERADO(SEGUROS)');
   INCLUI_ERRCNABR('422', '050', 'ABATIMENTO COM VALOR PARA OPERACAO "01"(ENTRADA DE TITULO)');
   INCLUI_ERRCNABR('422', '051', 'CODIGO DE INSCRICAO DO SACADO INVALIDO');
   INCLUI_ERRCNABR('422', '052', 'CODIGO DE INSCRICAO / NUMERO DE INSCRICAO DO SACADO INVALIDO');
   INCLUI_ERRCNABR('422', '053', 'NUMERO DE INSCRICAO DO SACADO NAO NUMERICO OU DIGITO ERRADO');
   INCLUI_ERRCNABR('422', '054', 'NOME DO SACADO EM BRANCO');
   INCLUI_ERRCNABR('422', '055', 'ENDERECO DO SACADO EM BRANCO');
   INCLUI_ERRCNABR('422', '056', 'CLIENTE NAO RECADASTRADO');
   INCLUI_ERRCNABR('422', '057', 'CLIENTE BLOQUEADO');
   INCLUI_ERRCNABR('422', '058', 'PROCESSO DE CARTORIO INVALIDO');
   INCLUI_ERRCNABR('422', '059', 'ESTADO DO SACADO INVALIDO');
   INCLUI_ERRCNABR('422', '060', 'CEP / ENDERECO DIVERGEM DO CORREIO');
   INCLUI_ERRCNABR('422', '061', 'INSTRUCAO AGENDADA PARA AGENCIA');
   INCLUI_ERRCNABR('422', '062', 'OPERACAO INVALIDA PARA A CARTEIRA');
   INCLUI_ERRCNABR('422', '063', 'CODIGO NAO PREVISTO');
   INCLUI_ERRCNABR('422', '064', 'TITULO INEXISTENTE(TFC)');
   INCLUI_ERRCNABR('422', '065', 'OPERACAO EXISTENTE PARA O TITULO');
   INCLUI_ERRCNABR('422', '066', 'TITULO JA EXISTE (TFC)');
   INCLUI_ERRCNABR('422', '067', 'DATA DE VENCIMENTO INVALIDA PARA PROTESTO');
   INCLUI_ERRCNABR('422', '068', 'CEP DO SACADO NAO CONSTA NA TABELA');
   INCLUI_ERRCNABR('422', '069', 'PRACA NAO ATENDIA PELO SERVICO CARTORIO');
   INCLUI_ERRCNABR('422', '070', 'AGENCIA INVALIDA');
   INCLUI_ERRCNABR('422', '071', 'CLIENTE NAO CADSATRADO');
   INCLUI_ERRCNABR('422', '072', 'TITULO JA EXISTE (COB)');
   INCLUI_ERRCNABR('422', '073', 'TAXA OPERACAO NAO NUMERICA OU ZERADA (VENDOR)');
   INCLUI_ERRCNABR('422', '074', 'TITULO FORA DA SEQUEENCIA');
   INCLUI_ERRCNABR('422', '075', 'TAXA DE OPERACAO ZERADA (VENDOR)');
   INCLUI_ERRCNABR('422', '076', 'EQUALIZACAO NAO NUMERICA OU INVALIDA (VENDOR)');
   INCLUI_ERRCNABR('422', '077', 'TAXA NEGOCIADA NAO NUMERICA OU ZERDA (VENDOR)');
   INCLUI_ERRCNABR('422', '078', 'TITULO INEXISTENTE (COB)');
   INCLUI_ERRCNABR('422', '079', 'OPERACAO NAO CONCLUIDA');
   INCLUI_ERRCNABR('422', '080', 'TITULO JA CADASTRADO');
   INCLUI_ERRCNABR('422', '081', 'TITULO NAO DESCONTADO');
   INCLUI_ERRCNABR('422', '082', 'INTERVALO ENTRE DATA DE OPRERACAO E DATA VCTO MENOR QUE UM DIA');
   INCLUI_ERRCNABR('422', '083', 'PRORROGACAO / ALTERACAO DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('422', '084', 'MOVIMENTO IGUAL AO CADASTRADO DE EXISTENCIA DO COB');
   INCLUI_ERRCNABR('422', '085', 'CODIGO OPERACAO COM PCB INVALIDO (OPREACAO INVALIDA P/ CARTEIRA)');
   INCLUI_ERRCNABR('422', '086', 'ABATIMENTO MAIOR QUE O VALOR DO TITULO');
   INCLUI_ERRCNABR('422', '087', 'ALTERACAO DE CATORIO INVALIDA');
   INCLUI_ERRCNABR('422', '088', 'TITULO RECUSADO COMO GARANTIA');
   INCLUI_ERRCNABR('422', '089', 'ALTERACAO DE DATA DE PROTESTO INVALIDA');
   INCLUI_ERRCNABR('422', '090', 'MODALIDADE DE VENDOR INVALIDO');
   INCLUI_ERRCNABR('422', '091', 'PCB CTO INVALIDA');
   INCLUI_ERRCNABR('422', '092', 'DATA DE OPERACAO CTO INVALIDA');
   INCLUI_ERRCNABR('422', '093', 'BAIXA DE TITULO DE OUTRA AGENCIA');
   INCLUI_ERRCNABR('422', '094', 'ENTRADA TITULO COBRANCA DIRETA INVALIDA');
   INCLUI_ERRCNABR('422', '095', 'BAIXA DO TITULO INVALIDO');
   INCLUI_ERRCNABR('422', '096', 'VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('422', '097', 'MOEDA INVALIDA PARA BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('422', '098', 'PCB DO TFC DIVERGEMDA PCB DO COB');
   INCLUI_ERRCNABR('422', '099', 'INCLUSAO DE TERCEIRA MOEDA INVALIDA');
   COMMIT;
END;
/
BEGIN
-- Banco UNIBANCO 409

   INCLUI_ERRCNABR('409', '05', 'TIPO DE TRANSACAO / CODIGO DO MOVIMENTO INVALIDO');
   INCLUI_ERRCNABR('409', '07', 'AGENCIA / CONTA E DIGITO INVALIDO');
   INCLUI_ERRCNABR('409', '08', 'NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('409', '09', 'NOSSO NUMERO DUPLICADO');
   INCLUI_ERRCNABR('409', '10', 'CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('409', '11', 'FORMA DE CADASTRAMENTO DO TITULO INVALIDA(CLIENTE NAO E TROCA DE FITAS)');
   INCLUI_ERRCNABR('409', '12', 'TIPO DE DOCUMENTO INVALIDO');
   INCLUI_ERRCNABR('409', '13', 'IDENTIFICACAO DE EMISSAO DE BLOQUETO INVALIDO');
   INCLUI_ERRCNABR('409', '15', 'CARACTERISTICA COBRANCA INCOMPATIVEL');
   INCLUI_ERRCNABR('409', '16', 'DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('409', '18', 'VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('409', '20', 'VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('409', '21', 'ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('409', '23', 'ACEITE INVALIDO');
   INCLUI_ERRCNABR('409', '24', 'DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('409', '26', 'CODIGO DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('409', '27', 'VALOR/TAXA JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('409', '30', 'DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('409', '32', 'VALOR DO IOF INVALIDO');
   INCLUI_ERRCNABR('409', '33', 'VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('409', '34', 'VALOR DO ABATIMENTO MAIOR OU IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('409', '35', 'ABATIMENTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('409', '36', 'ABATIMENTO JA CONCEDIDO');
   INCLUI_ERRCNABR('409', '37', 'CODIGO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('409', '38', 'PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('409', '39', 'PEDIDO DE PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('409', '41', 'PEDIDO DE CANCELAMENTO/SITUACAO DE PROTESTO PARA TITULOS SEM INSTRUCAO DE PROTESTO');
   INCLUI_ERRCNABR('409', '42', 'CODIGO PARA BAIXA/DEVOLUCAO INVALIDA');
   INCLUI_ERRCNABR('409', '43', 'PRAZO PARA BAIXA/DEVOLUCAO INVALIDA ');
   INCLUI_ERRCNABR('409', '44', 'CODIGO DA MOEDA INVALIDA');
   INCLUI_ERRCNABR('409', '46', 'TIPO/NUMERO DE INSCRICAO INVALIDO');
   INCLUI_ERRCNABR('409', '48', 'CEP INVALIDO');
   INCLUI_ERRCNABR('409', '53', 'TIPO/NUMERO DE INCRICAO DO SACADOR/AVALISTA INVALIDOS');
   INCLUI_ERRCNABR('409', '57', 'CODIGO DA MULTA INVALIDO');
   INCLUI_ERRCNABR('409', '58', 'DATA DA MULTA INVALIDA');
   INCLUI_ERRCNABR('409', '60', 'MOVIMENTO PARA TITULO NAO CADSTRADO');
   INCLUI_ERRCNABR('409', '61', 'AGENCIA ENCARREGADA DA COBRANCA INVALIDA / BANCO DEPOSITARIO E BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('409', '99', 'OUTROS');
   COMMIT;
END;
/
BEGIN
-- Banco de Boston 479

   INCLUI_ERRCNABR('479','101','DATA DE EMISSAO INVALIDA');
   INCLUI_ERRCNABR('479','102','DATA DE EMISSAO MAIOR QUE A DATA DA OPERACAO');
   INCLUI_ERRCNABR('479','103','DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('479','105','PREMIO LIQUIDO NAO NUMERICO');
   INCLUI_ERRCNABR('479','106','PREMIO LIQUIDO INCOMPATIVEL COM ESPECIE');
   INCLUI_ERRCNABR('479','107','PREMIO LIQUIDO NAO INFORMADO');
   INCLUI_ERRCNABR('479','108','IOF NAO NUMERICO');
   INCLUI_ERRCNABR('479','109','IOF INCOMPATIVEL COM ESPECIE');
   INCLUI_ERRCNABR('479','110','VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('479','111','ACEITE INVALIDO');
   INCLUI_ERRCNABR('479','112','ACEITE NAO PERMITIDO PARA ESPECIE');
   INCLUI_ERRCNABR('479','113','VALORES DE DESCONTOS NAO NUMERICOS');
   INCLUI_ERRCNABR('479','114','ORDEM DO VALORES DESCONTOS INCOMPATIVEIS');
   INCLUI_ERRCNABR('479','115','DATA DE VENCIMENTO MAIOR QUE DATA NEGOC. PARA DESCONTO');
   INCLUI_ERRCNABR('479','116','PERCENTUAL NAO PERMITE VALOR ABATIMENTO');
   INCLUI_ERRCNABR('479','117','PERCENTUAL EXIGE DATA LIMITE');
   INCLUI_ERRCNABR('479','118','DATA DE DESCONTO INVALIDA');
   INCLUI_ERRCNABR('479','119','DATA DE DESCONTO MAIOR QUE DATA DE VENCIMENTO');
   INCLUI_ERRCNABR('479','120','DATA DE DESCONTO MENOR QUE DATA DE NEGOCIACAO');
   INCLUI_ERRCNABR('479','121','DATA DESCONTO EXIGE ALGUM VALOR OU PERCENTUAL');
   INCLUI_ERRCNABR('479','122','VALOR BASE NAO PERMITE VALOR DE ABATIMENTO');
   INCLUI_ERRCNABR('479','123','VALOE BASE EXIGE VALOR PERCENTUAL');
   INCLUI_ERRCNABR('479','124','VALOR BASE EXIGE DATA LIMITE');
   INCLUI_ERRCNABR('479','125','VALOR DO DESCONTO EXIGE DATA LIMITE');
   INCLUI_ERRCNABR('479','126','VALOR DO ABATIMENTO DEVE SER MENOR QUE O VALOR DO TITULO');
   INCLUI_ERRCNABR('479','127','VALOR DO ABATIMENTO NAO PERMITE PERCENTUAL E VALOR BASE');
   INCLUI_ERRCNABR('479','128','NOME DO SACADO OBRIGATORIO');
   INCLUI_ERRCNABR('479','132','NOME DO SACADO NAO DEVE SER INFORMADO PARA NOTA DE SEGURO');
   INCLUI_ERRCNABR('479','134','ENDERECO DO SACADO INVALIDO');
   INCLUI_ERRCNABR('479','137','CEP DO SACADO INVALIDO');
   INCLUI_ERRCNABR('479','138','IDENTIFICADOR DE REGISTRO INVALIDO');
   INCLUI_ERRCNABR('479','139','DIAS JURO/MULTA 1 MAIOR QUE DIAS JURO/MULTA 2');
   INCLUI_ERRCNABR('479','140','DIAS JURO/MULTA 2 MAIOR QUE DIAS JURO/MULTA 3');
   INCLUI_ERRCNABR('479','145','INSTRUCAO NA ENTRADA DO TITULO INVALIDA');
   INCLUI_ERRCNABR('479','146','NUMERO DE DIAS NA ENTRADA INVALIDO');
   INCLUI_ERRCNABR('479','147','VALOR DE ABATIMENTO ENTRADA INVALIDO');
   INCLUI_ERRCNABR('479','148','VALOR DE ABATIMENTO ENTRADA TEM QUE SER MENOR QUE VALOR TITULO');
   INCLUI_ERRCNABR('479','156','TITULO DESCONTO A VISTA OU CONTRA APRESENTACAO');
   INCLUI_ERRCNABR('479','158','NAO EXISTE COTACAO PARA MOEDA NA DATA DE EMISSAO');
   INCLUI_ERRCNABR('479','159','DIGITO DO NOSSO NUMERO NAO CONFERE');
   INCLUI_ERRCNABR('479','160','INTRUCAO INVALIDA - TITULO COM INSTRUCAO PROTESTAR');
   INCLUI_ERRCNABR('479','166','CEP NAO PERTENCE AO BOSTON');
   INCLUI_ERRCNABR('479','181','MOEDA OU FATOR INVALIDO');
   INCLUI_ERRCNABR('479','187','CORR N/ TRAB C/ MOEDA FATOR OU CONTA N/ CAD CORRESPONDENTE');
   INCLUI_ERRCNABR('479','200','NOSSO NUMERO NAO RESERVADO PARA COBRANCA RAPIDA');
   INCLUI_ERRCNABR('479','202','CEP NAO CADASTRADO');
   INCLUI_ERRCNABR('479','204','DATA DE NEGOCIACAO NAO E DIA UTIL');
   INCLUI_ERRCNABR('479','205','ESPECIE TITULO PARA DESCONTO FUNC. ALTERADO PARA NP');
   INCLUI_ERRCNABR('479','207','TAXA DE DESCONTO INFORMADA PARA BORDERO DE COBRANCA/CAUCAO');
   INCLUI_ERRCNABR('479','208','CONTRATO NAO LIGADO A CLIENTE');
   INCLUI_ERRCNABR('479','209','CONTRATO NAO PERTENCE AO CLIENTE BORDERO');
   INCLUI_ERRCNABR('479','210','TIPO DE BEM(FINANCIADO) NAO CADASTRADO');
   INCLUI_ERRCNABR('479','213','NAO FOI POSSIVEL ENCONTRAR AG COBRADORA');
   INCLUI_ERRCNABR('479','214','NAO EXISTE ESTADO-MUNICIPIO PARA O CEP');
   INCLUI_ERRCNABR('479','300','CODIGO DE MOVIMENTO INVALIDO');
   INCLUI_ERRCNABR('479','301','NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('479','302','VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('479','303','DESCONTO/ABATIMENTO INVALIDO ');
   INCLUI_ERRCNABR('479','304','OUTRAS REDUCOES INVALIDA');
   INCLUI_ERRCNABR('479','305','LIQUIDACAO / BAIXA / INSTRUCAO INIBIDA');
   INCLUI_ERRCNABR('479','306','RESSARCIMENTO INVALIDO');
   INCLUI_ERRCNABR('479','307','VALOR LIQUIDO INVALIDO');
   INCLUI_ERRCNABR('479','308','JUROS / MULTA INVALIDO');
   INCLUI_ERRCNABR('479','309','OUTROS ACRESCIMOS INVALIDO');
   INCLUI_ERRCNABR('479','310','CODIGO DE MOVIMENTO DIFERENTE DE 0407');
   INCLUI_ERRCNABR('479','311','SEU NUMERO OBRIGATORIO');
   INCLUI_ERRCNABR('479','312','INSTRUCAO VIA FITA INVALIDA');
   INCLUI_ERRCNABR('479','313','VALOR DA INSTRUCAO INVALIDO');
   INCLUI_ERRCNABR('479','314','DATA DE VENCIMENTO INSTRUCAO INVALIDA');
   INCLUI_ERRCNABR('479','315','SEU NUMERO DA ISNTRUCAO OBRIGATORIO');
   INCLUI_ERRCNABR('479','316','USO DA EMPRESA OBRIGATORIO');
   INCLUI_ERRCNABR('479','317','CALCULO DIGITO MODULO 11 NAO REALIZADO');
   INCLUI_ERRCNABR('479','318','BAIXA / LIQUIDACAO DE TITULO INEXISTENTE');
   INCLUI_ERRCNABR('479','319','INSTRUCAO PARA TITULO INEXISTENTE');
   INCLUI_ERRCNABR('479','321','INSTRUCAO PRORROGACAO DE VENCTO. P/ TITULO LIQUIDADO');
   INCLUI_ERRCNABR('479','322','TITULO JA CADASTRADO');
   INCLUI_ERRCNABR('479','324','INSTRUCAO PRORROGACAO DE VENCTO. P/ TITULO BAIXADO');
   INCLUI_ERRCNABR('479','325','INSTRUCAO PRORROGACAO DE VENCTO. P/ TITULO PROTESTADO');
   INCLUI_ERRCNABR('479','326','INSTRUCAO PRORROGACAO DE VENCTO. P/ TITULO EM CARTORIO');
   INCLUI_ERRCNABR('479','332','VALOR DESCONTO/ABATIMENTO NAO CONFERE COM O SISTEMA');
   INCLUI_ERRCNABR('479','333','BAIXA CREDITO DIRETO NAO PERMITIDO PARA DESCONTO');
   INCLUI_ERRCNABR('479','334','INSTRUCAO NAO PERMITIDA PARA BATCH-USE ONLINE');
   INCLUI_ERRCNABR('479','335','DESCONTO/ABATIMENTO NAO PERMITINDO PARA LIQ. PARCIAL');
   INCLUI_ERRCNABR('479','336','JUROS/MULTA NAO PERMITIDO P/ LIQUIDACAO PARCIAL');
   INCLUI_ERRCNABR('479','338','INSTRUCAO NAO ACATADA');
   INCLUI_ERRCNABR('479','340','VALOR LIQUIDO DIFERE DP PAGAMENTO PARCIAL');
   INCLUI_ERRCNABR('479','341','TITULO NAO ESTA EM CARTORIO');
   INCLUI_ERRCNABR('479','342','TITULO ESTA EM CARTORIO');
   INCLUI_ERRCNABR('479','343','TITULO JA LIQUIDADO');
   INCLUI_ERRCNABR('479','344','TITULO JA LIQUIDADO NESTE MOVIMENTO');
   INCLUI_ERRCNABR('479','345','CODIGO DE AVALISTA (1 OU 2) NAO NUMERICO');
   INCLUI_ERRCNABR('479','346','AVALISTA NAO EXISTE COMO CLIENTE');
   INCLUI_ERRCNABR('479','347','AVALISTA NAO CADASTRADO COMO CLIENTE');
   INCLUI_ERRCNABR('479','352','VALOR DO TITULO INFORMADO NAO BATE COM SALDO DEVEDOR');
   INCLUI_ERRCNABR('479','355','VERIFICAR DATA DE VENCIMENTO/TAXA TIT. S/ CRED. CED.');
   INCLUI_ERRCNABR('479','356','MOME DO SACADO CONTEM CARACTER INVALIDO');
   INCLUI_ERRCNABR('479','357','ENTARDA TITULO FITA/MICRO P/ CEP NAO BKB');
   INCLUI_ERRCNABR('479','358','PRODUTO NAO EXISTE NO CORRESPONDENTE');
   INCLUI_ERRCNABR('479','360','FILIAL NAO CADASTRADA P/ CORRESPONDENTE INFORMADO');
   INCLUI_ERRCNABR('479','361','TITULO NAO PERTENCE AP CONVENIO INFORMADO');
   INCLUI_ERRCNABR('479','366','DATA DE EMISSAO MAIOR QUE A DATA DE VENCIMENTO');
   COMMIT;
END;
/

BEGIN
-- Banco Brasil 001

   INCLUI_ERRCNABR('001','01','CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('001','02','CODIGO DO REGISTRO DETALHE INVALIDO');
   INCLUI_ERRCNABR('001','03','CODIGO DO SEGMENTO INVALIDO');
   INCLUI_ERRCNABR('001','04','CODIGO DO MOVIMENTO NAO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('001','05','CODIGO DE MOVIMENTO INVALIDO.');
   INCLUI_ERRCNABR('001','06','TIPO/NUMERO DE INSCRICAO DO CEDENTE INVALIDOS');
   INCLUI_ERRCNABR('001','07','AGENCIA/CONTA/DV INVALIDO.');
   INCLUI_ERRCNABR('001','08','NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('001','09','NOSSO NUMERO DUPLICADO');
   INCLUI_ERRCNABR('001','10','CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('001','11','FORMA DE CADASTRAMENTO DO TITULO INVALIDO');
   INCLUI_ERRCNABR('001','12','TIPO DE DOCUMENTO INVALIDO');
   INCLUI_ERRCNABR('001','13','IDENTIFICACAO DA EMISSAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('001','14','IDENTIFICACAO DA DISTRIBUICAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('001','15','CARACTERISTICAS DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('001','16','DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('001','17','DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSAO');
   INCLUI_ERRCNABR('001','18','VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('001','19','TITULO A CARGO DE BANCOS CORRESPONDENTES COM VENCIMENTO INFERIOR XX DIAS');
   INCLUI_ERRCNABR('001','20','VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('001','21','ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('001','22','ESPECIE NAO PERMITIDA PARA A CARTEIRA.');
   INCLUI_ERRCNABR('001','23','ACEITE INVALIDO');
   INCLUI_ERRCNABR('001','24','DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('001','25','DATA DA EMISSAO POSTERIOR A DATA');
   INCLUI_ERRCNABR('001','26','CODIGO DE JUROS DE MORA INVALIDO.');
   INCLUI_ERRCNABR('001','27','VALOR/TAXA DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('001','28','CODIGO DO DESCONTO INVALIDO');
   INCLUI_ERRCNABR('001','29','VALOR DO DESCONTO MAIOR OU IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('001','30','DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('001','31','CONCESSAO DE DESCONTO - JA EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('001','32','VALOR DO IOF INVALIDO');
   INCLUI_ERRCNABR('001','33','VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('001','34','VALOR DO ABATIMENTO MAIOR OU IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('001','35','ABATIMENTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('001','36','CONCESSAO DE ABATIMENTO - JA EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('001','37','CODIGO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('001','38','PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('001','39','PEDIDO DE PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('001','40','TITULO COM ORDEM DE PROTESTO EMITIDA');
   INCLUI_ERRCNABR('001','41','PEDIDO DE CANCELAMENTO/SUSTACAO PARA TITULOS SEM INSTRUCAO DE PROTESTO');
   INCLUI_ERRCNABR('001','42','CODIGO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('001','43','PRAZO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('001','44','CODIGO DA MOEDA INVALIDO');
   INCLUI_ERRCNABR('001','45','NOME DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('001','46','TIPO/NUMERO DE INSCRICAO DO SACADO INVALIDOS');
   INCLUI_ERRCNABR('001','47','ENDERECO DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('001','48','CEP INVALIDO');
   INCLUI_ERRCNABR('001','49','CEP SEM PRACA DE COBRANCA /NAO LOCALIZADO');
   INCLUI_ERRCNABR('001','50','CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('001','51','CEP INCOMPATIVEL COM A UNIDADE DA FEDERACCAO');
   INCLUI_ERRCNABR('001','52','UNIDADE DA FEDERACAO INVALIDA');
   INCLUI_ERRCNABR('001','53','TIPO/NUMERO DE INSCRICAO DO SACADOR/AVALISTA INVALIDOS');
   INCLUI_ERRCNABR('001','54','SACADOR/AVALISTA NAO INFORMADO');
   INCLUI_ERRCNABR('001','55','NOSSO NUMERO NO BANCO CORRESPONDENTE NAO INFORMADO');
   INCLUI_ERRCNABR('001','56','CODIGO DO BANCO CORRESPONDENTE NAO INFORMADO');
   INCLUI_ERRCNABR('001','57','CODIGO DA MULTA INVALIDO');
   INCLUI_ERRCNABR('001','58','DATA DA MULTA INVALIDA.');
   INCLUI_ERRCNABR('001','59','VALOR/PERCENTUAL DA MULTA INVALIDO');
   INCLUI_ERRCNABR('001','60','MOVIMENTO PARA TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('001','61','ALTERACAO DA AGENCIA COBRADORA/DV INVALIDA');
   INCLUI_ERRCNABR('001','62','TIPO DE IMPRESSAO INVALIDO');
   INCLUI_ERRCNABR('001','63','ENTRADA PARA TITULO JA CADASTRADO');
   INCLUI_ERRCNABR('001','64','NUMERO DA LINHA INVALIDO');
   INCLUI_ERRCNABR('001','65','CODIGO DO BANCO PARA DEBITO INVALIDO');
   INCLUI_ERRCNABR('001','66','AGENCIA/CONTA/DV PARA DEBITO INVALIDO');
   INCLUI_ERRCNABR('001','67','DADOS PARA DEBITO INCOMPATIVEL COM A IDENTIFICACAO DA EMISSAO DO BLOQUETO');
   INCLUI_ERRCNABR('001','88','ARQUIVO EM DUPLICIDADE');
   INCLUI_ERRCNABR('001','99','CONTRATO INEXISTENTE');
   COMMIT;
END;
/

BEGIN
-- Banco Mercantil 389

   INCLUI_ERRCNABR('389','01','CODIGO CLIENTE INVALIDO');
   INCLUI_ERRCNABR('389','02','NOSSO NUMERO INVALIDO OU FAIXA INVALIDA');
   INCLUI_ERRCNABR('389','03','CGC/CPF DO CEDENTE INVALIDO');
   INCLUI_ERRCNABR('389','04','QUANTIDADE DE MOEDA INVALIDO');
   INCLUI_ERRCNABR('389','05','CODIGO DA OPERACAO INVALIDO OU DIVERGE DO CONTRATO');
   INCLUI_ERRCNABR('389','06','CODIGO DO MOVIMENTO INVALIDO');
   INCLUI_ERRCNABR('389','07','DATA VENCIMENTO INVALIDO');
   INCLUI_ERRCNABR('389','08','VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('389','09','CODIGO DE ESPECIE INVALIDO');
   INCLUI_ERRCNABR('389','10','DATA DE EMISSAO INVALIDA OU MAIOR QUE MOVIMENTO');
   INCLUI_ERRCNABR('389','11','INSTRUCAO INVALIDA');
   INCLUI_ERRCNABR('389','12','JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('389','13','DESCONTO ATE INVALIDO, MAIOR VENCIMENTO OU MENOR EMISSAO');
   INCLUI_ERRCNABR('389','14','VALOR DESCONTO INVALIDO OU MAIOR QUE VALOR DO TITULO');
   INCLUI_ERRCNABR('389','15','VALOR IOF INVALIDO OU MAIOR QUE VALOR DO TITULO');
   INCLUI_ERRCNABR('389','16','VALOR DO ABATIMENTO INVALIDO OU MAIOR QUE VALOR DO TITULO');
   INCLUI_ERRCNABR('389','17','NOME DO SACADO INVALIDO');
   INCLUI_ERRCNABR('389','18','ENDERECO DO SACADO INVALIDO');
   INCLUI_ERRCNABR('389','19','CEP NAO CONTIDO NA TABELA');
   INCLUI_ERRCNABR('389','20','CODIGO DA MOEDA INVALIDO');
   INCLUI_ERRCNABR('389','21','SEU NUMERO INVALIDO');
   INCLUI_ERRCNABR('389','22','JA EXISTE NO CADASTRO DE TITULO');
   INCLUI_ERRCNABR('389','23','TITULO JA BAIXADO');
   INCLUI_ERRCNABR('389','24','CODIGO MOEDA INVALIDO PARA DATA EMISSAO');
   INCLUI_ERRCNABR('389','25','REJEITADO PELO GERENTE');
   INCLUI_ERRCNABR('389','40','AGENCIA/CONTRATO/CGC INVALIDO');
   INCLUI_ERRCNABR('389','41','TIPO DE FORMULARIO DO CONTRATO INVALIDO');
   INCLUI_ERRCNABR('389','42','CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('389','43','REGISTRO DO SACADO INVALIDO');
   INCLUI_ERRCNABR('389','44','NUMERO PARCELA CARNE INVALIDO');
   INCLUI_ERRCNABR('389','45','INTERVALO CARNE INVALIDO');
   INCLUI_ERRCNABR('389','46','ERRO CPF/CGC INVALIDO DO SACADO (CARNE)');
   INCLUI_ERRCNABR('389','47','ERRO QTDE. ALUNOS INFORMADOS');
   INCLUI_ERRCNABR('389','48','NOME DO SOCIO DEVE SER INFORMADO');
   INCLUI_ERRCNABR('389','49','NUMERO DO SOCIO NAO PODE SER ZEROS');
   INCLUI_ERRCNABR('389','50','CEP INVALIDO');
   INCLUI_ERRCNABR('389','51','NUMERO DO DOCUMENTO INVALIDO');
   COMMIT;
END;
/

BEGIN
-- Banco Nossa Caixa 151

   INCLUI_ERRCNABR('151','01','CODIGO BANCO INVALIDO');
   INCLUI_ERRCNABR('151','02','CODIGO DO REGISTRO DETALHE INVALIDO');
   INCLUI_ERRCNABR('151','03','CODIGO SEGMENTO INVALIDO');
   INCLUI_ERRCNABR('151','04','CODIGO MOVIMENTO NAO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('151','05','CODIGO MOVIMENTO INVALIDO');
   INCLUI_ERRCNABR('151','06','AGENCIA/CONTA/DV INVALIDO');
   INCLUI_ERRCNABR('151','07','NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('151','08','NOSSO NUMERO DUPLICADO');
   INCLUI_ERRCNABR('151','09','CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('151','12','IDENTIFICACAO DA EMISSAO DO BLOQUETE INVALIDA');
   INCLUI_ERRCNABR('151','14','CARACTERISTICAS DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('151','15','DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('151','16','DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSAO');
   INCLUI_ERRCNABR('151','17','TITULO A CARGO DE BANCOS CORRESPONDENTES COM VENCIMENTO INFERIOR A 2 DIAS');
   INCLUI_ERRCNABR('151','18','VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('151','19','ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('151','20','ESPECIE NAO PERMITIDA PARA A CARTEIRA');
   INCLUI_ERRCNABR('151','21','ACEITE INVALIDO');
   INCLUI_ERRCNABR('151','22','DATA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('151','23','DATA EMISSAO POSTERIOR A DATA DE ENTRADA');
   INCLUI_ERRCNABR('151','24','CODIGO JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('151','25','VALOR/TAXA DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('151','26','CODIGO DESCONTO INVALIDO');
   INCLUI_ERRCNABR('151','27','VALOR DO DESCONTO MAIOR OU IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('151','28','DATA DESCONTO INVALIDA');
   INCLUI_ERRCNABR('151','32','PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('151','33','PEDIDO DE PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('151','34','PEDIDO DE CANCELAMENTO/SUSTACAO POR TITULO SEM INSTRUCAO DE PROTESTO');
   INCLUI_ERRCNABR('151','37','CODIGO DA MOEDA INVALIDO');
   INCLUI_ERRCNABR('151','38','NOME DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('151','39','ENDERECO DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('151','40','CEP INVALIDO');
   INCLUI_ERRCNABR('151','41','CEP SEM PRACA DE COBRANCA (NAO LOCALIZADO)');
   INCLUI_ERRCNABR('151','42','CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('151','43','CEP INCOMPATIVEL COM A UNIDADE DA FEDERACAO');
   INCLUI_ERRCNABR('151','44','UNIDADE DA FEDERACAO INVALIDA');
   INCLUI_ERRCNABR('151','45','SACADOR/AVALISTA NAO INFORMADO');
   INCLUI_ERRCNABR('151','50','TAXA DE MULTA INVALIDA');
   INCLUI_ERRCNABR('151','51','MOVIMENTO PARA TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('151','53','ENTRADA PARA TITULO JA CADASTRADO');
   INCLUI_ERRCNABR('151','54','CONTA MOVIMENTO INEXISTENTE/INVALIDA');
   INCLUI_ERRCNABR('151','55','PERCENTUAL CONTA MOVIMENTO INVALIDO');
   INCLUI_ERRCNABR('151','56','CPF/CNPJ DO SACADO INVALIDO');
   INCLUI_ERRCNABR('151','57','DATA DE VENCIMENTO FORA DE PARAMETRO');
   INCLUI_ERRCNABR('151','58','PRAZO DE PROTESTO FORA DO LIMITE');
   INCLUI_ERRCNABR('151','59','EXCLUSAO PARA TITULO EM CARTORIO');
   INCLUI_ERRCNABR('151','60','EXCLUSAO PARA TITULO LIQUIDADO OU EXCLUIDO');
   INCLUI_ERRCNABR('151','61','BANDA MAGNETICA INVALIDA');
   INCLUI_ERRCNABR('151','63','AUSENCIA DE "SEU NUMERO"');
   INCLUI_ERRCNABR('151','84','BAIXA DE TITULO A PEDIDO/AUTOMATICA');
   INCLUI_ERRCNABR('151','85','TARIFA DE LIQUIDACAO DE TITULO');
   INCLUI_ERRCNABR('151','86','TARIFA DE EMISSAO DE BLOQUETES DA COBRANCA DIRETA');
   INCLUI_ERRCNABR('151','87','TARIFA DE CUSTODIA DE TITULOS');
   INCLUI_ERRCNABR('151','88','TARIFA DE ENTRADA DE TITULOS');
   INCLUI_ERRCNABR('151','89','TARIFA DE EXTRATO DE POSICAO');
   INCLUI_ERRCNABR('151','90','TARIFA DE MANUTENCAO DE TITULO VENCIDO');
   INCLUI_ERRCNABR('151','91','TARIFA DE SUSTACAO');
   INCLUI_ERRCNABR('151','92','TARIFA DE PROTESTO');
   INCLUI_ERRCNABR('151','93','TARIFA DE OUTRAS INSTRUCAO');
   INCLUI_ERRCNABR('151','94','TARIFA DE OUTRAS OCORRENCIAS');
   INCLUI_ERRCNABR('151','96','CUSTAS DE PROTESTO');
   INCLUI_ERRCNABR('151','97','CUSTAS DE SUSTACAO DO PROTESTO');
   INCLUI_ERRCNABR('151','98','CUSTAS DE CARTORIO DISTRIBUIDOR');
   INCLUI_ERRCNABR('151','99','CUSTAS DO EDITAL');
   COMMIT;
END;
/

BEGIN
-- Banco Real 275

   INCLUI_ERRCNABR('275','01','CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('275','02','CODIGO DO REGISTRO DETALHE INVALIDO');
   INCLUI_ERRCNABR('275','03','CODIGO DO SEGMENTO INVALIDO');
   INCLUI_ERRCNABR('275','04','CODIGO DE MOVIMENTO NAO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('275','05','CODIGO DE MOVIMENTO INVALIDO');
   INCLUI_ERRCNABR('275','06','TIPO/NUMERO DE INSCRICAO DO CEDENTE INVALIDOS');
   INCLUI_ERRCNABR('275','07','AGENCIA/CONTA/DV INVALIDO');
   INCLUI_ERRCNABR('275','08','NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('275','09','NOSSO NUMERO DUPLICADO');
   INCLUI_ERRCNABR('275','10','CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('275','11','FORMA DE CADASTRAMENTO DO TITULO INVALIDO');
   INCLUI_ERRCNABR('275','12','TIPO DE DOCUMENTO INVALIDO');
   INCLUI_ERRCNABR('275','13','IDENTIFICACAO DA EMISSAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('275','14','IDENTIFICACAO DA DISTRIBUICAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('275','15','CARACTERISTICAS DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('275','16','DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('275','17','DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSAO');
   INCLUI_ERRCNABR('275','18','VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('275','19','TITULO A CARGO DE BANCOS CORRESPONDENTES COM VENCIMENTO INFERIOR A XX DIAS');
   INCLUI_ERRCNABR('275','20','VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('275','21','ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('275','22','ESPECIE DO TITULO NAO PERMITIDA PARA A CARTEIRA');
   INCLUI_ERRCNABR('275','23','ACEITE INVALIDO');
   INCLUI_ERRCNABR('275','24','DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('275','25','DATA DA EMISSAO POSTERIOR A DATA DE ENTRADA');
   INCLUI_ERRCNABR('275','26','CODIGO DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('275','27','VALOR/TAXA DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('275','28','CODIGO DO DESCONTO INVALIDO');
   INCLUI_ERRCNABR('275','29','VALOR DO DESCONTO MAIOR OU IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('275','30','DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('275','31','CONCESSAO DE DESCONTO - JA EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('275','32','VALOR DO IOF INVALIDO');
   INCLUI_ERRCNABR('275','33','VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('275','34','VALOR DO ABATIMENTO MAIOR OU IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('275','35','VALOR A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('275','36','CONCESSAO DE ABATIMENTO - JA EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('275','37','CODIGO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('275','38','PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('275','39','PEDIDO DE PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('275','40','TITULO COM ORDEM DE PROTESTO EMITIDA');
   INCLUI_ERRCNABR('275','41','PEDIDO DE CANCELAMENTO/SUSTACAO PARA TITULOS SEM INSTRUCAO DE PROTESTO');
   INCLUI_ERRCNABR('275','42','CODIGO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('275','43','PRAZO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('275','44','CODIGO DA MOEDA INVALIDO ');
   INCLUI_ERRCNABR('275','45','NOME DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('275','46','TIPO/NUMERO DE INSCRICAO DO SACADO INVALIDOS');
   INCLUI_ERRCNABR('275','47','ENDERECO DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('275','48','CEP INVALIDO');
   INCLUI_ERRCNABR('275','49','CEP SEM PRACA DE COBRANCA (NAO LOCALIZADO)');
   INCLUI_ERRCNABR('275','50','CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('275','51','CEP INCOMPATIVEL COM A UNIDADE DA FEDERACAO');
   INCLUI_ERRCNABR('275','52','UNIDADE DA FEDERACAO INVALIDA');
   INCLUI_ERRCNABR('275','53','TIPO/NUMERO DE INSCRICAO DO SACADOR/AVALISTA INVALIDOS');
   INCLUI_ERRCNABR('275','54','SACADOR/AVALISTA NAO INFORMADO');
   INCLUI_ERRCNABR('275','55','NOSSO NUMERO NO BANCO CORRESPONDENTE NAO INFORMADO');
   INCLUI_ERRCNABR('275','56','CODIGO DO BANCO CORRESPONDENTE NAO INFORMADO');
   INCLUI_ERRCNABR('275','57','CODIGO DA MULTA INVALIDO');
   INCLUI_ERRCNABR('275','58','DATA DA MULTA INVALIDA');
   INCLUI_ERRCNABR('275','59','VALOR/PERCENTUAL DA MULTA INVALIDO');
   INCLUI_ERRCNABR('275','60','MOVIMENTO PARA TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('275','61','ALTERACAO DA AGENCIA COBRADORA/DV INVALIDA');
   INCLUI_ERRCNABR('275','62','TIPO DE IMPRESSAO INVALIDO');
   INCLUI_ERRCNABR('275','63','ENTRADA PARA TITULO JA CADASTRADO');
   INCLUI_ERRCNABR('275','64','NUMERO DA LINHA INVALIDO');
   INCLUI_ERRCNABR('275','65','CODIGO DO BANCO PARA DEBITO INVALIDO');
   INCLUI_ERRCNABR('275','66','AGENCIA/CONTA/DV PARA DEBITO INVALIDO');
   INCLUI_ERRCNABR('275','67','DADOS PARA DEBITO INCOMPATIVEL COM A IDENTIFICACAO DA EMISSAO DO BLOQUETO');
   INCLUI_ERRCNABR('275','68','DEBITO AUTOMATICO AGENDADO');
   INCLUI_ERRCNABR('275','69','DEBITO NAO AGENDADO - ERRO NOS DADOS DA REMESSA');
   INCLUI_ERRCNABR('275','70','DEBITO NAO AGENDADO - SACADO NAO CONSTA DO CADASTRO DE AUTORIZANTE');
   INCLUI_ERRCNABR('275','71','DEBITO NAO AGENDADO - CEDENTE NAO AUTORIZADO PELO SACADO ');
   INCLUI_ERRCNABR('275','72','DEBITO NAO AGENDADO - CEDENTE NAO PARTICIPA DA MODALIDADE DEBITO AUTOMATICO');
   INCLUI_ERRCNABR('275','73','DEBITO NAO AGENDADO - CODIGO DE MOEDA DIFERENTE DE REAL (R$)');
   INCLUI_ERRCNABR('275','74','DEBITO NAO AGENDADO - DATA VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('275','75','DEBITO NAO AGENDADO, CONFORME SEU PEDIDO, TITULO NAO REGISTRADO');
   INCLUI_ERRCNABR('275','76','DEBITO NAO AGENDADO, TIPO/NUM. INSCRICAO DO DEBITADO, INVALIDO');
   INCLUI_ERRCNABR('275','77','TRANSFERENCIA PARA DESCONTO NAO PERMITIDA PARA A CARTEIRA DO TITULO');
   INCLUI_ERRCNABR('275','78','DATA INFERIOR OU IGUAL AO VENCIMENTO PARA DEBITO AUTOMATICO');
   INCLUI_ERRCNABR('275','79','DATA JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('275','80','DATA DO DESCONTO INVALIDA');
   INCLUI_ERRCNABR('275','81','TENTATIVAS DE DEBITO ESGOTADAS - BAIXADO');
   INCLUI_ERRCNABR('275','82','TENTATIVAS DE DEBITO ESGOTADAS - PENDENTE');
   INCLUI_ERRCNABR('275','83','LIMITE EXCEDIDO');
   INCLUI_ERRCNABR('275','84','NUMERO AUTORIZACAO INEXISTENTE');
   INCLUI_ERRCNABR('275','85','TITULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('275','86','SEU NUMERO INVALIDO');
   COMMIT;
END;
/

BEGIN
-- Banco Real 356

   INCLUI_ERRCNABR('356','01','CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('356','02','CODIGO DO REGISTRO DETALHE INVALIDO');
   INCLUI_ERRCNABR('356','03','CODIGO DO SEGMENTO INVALIDO');
   INCLUI_ERRCNABR('356','04','CODIGO DE MOVIMENTO NAO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('356','05','CODIGO DE MOVIMENTO INVALIDO');
   INCLUI_ERRCNABR('356','06','TIPO/NUMERO DE INSCRICAO DO CEDENTE INVALIDOS');
   INCLUI_ERRCNABR('356','07','AGENCIA/CONTA/DV INVALIDO');
   INCLUI_ERRCNABR('356','08','NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('356','09','NOSSO NUMERO DUPLICADO');
   INCLUI_ERRCNABR('356','10','CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('356','11','FORMA DE CADASTRAMENTO DO TITULO INVALIDO');
   INCLUI_ERRCNABR('356','12','TIPO DE DOCUMENTO INVALIDO');
   INCLUI_ERRCNABR('356','13','IDENTIFICACAO DA EMISSAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('356','14','IDENTIFICACAO DA DISTRIBUICAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('356','15','CARACTERISTICAS DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('356','16','DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('356','17','DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSAO');
   INCLUI_ERRCNABR('356','18','VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('356','19','TITULO A CARGO DE BANCOS CORRESPONDENTES COM VENCIMENTO INFERIOR A XX DIAS');
   INCLUI_ERRCNABR('356','20','VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('356','21','ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('356','22','ESPECIE DO TITULO NAO PERMITIDA PARA A CARTEIRA');
   INCLUI_ERRCNABR('356','23','ACEITE INVALIDO');
   INCLUI_ERRCNABR('356','24','DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('356','25','DATA DA EMISSAO POSTERIOR A DATA DE ENTRADA');
   INCLUI_ERRCNABR('356','26','CODIGO DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('356','27','VALOR/TAXA DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('356','28','CODIGO DO DESCONTO INVALIDO');
   INCLUI_ERRCNABR('356','29','VALOR DO DESCONTO MAIOR OU IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('356','30','DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('356','31','CONCESSAO DE DESCONTO - JA EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('356','32','VALOR DO IOF INVALIDO');
   INCLUI_ERRCNABR('356','33','VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('356','34','VALOR DO ABATIMENTO MAIOR OU IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('356','35','VALOR A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('356','36','CONCESSAO DE ABATIMENTO - JA EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('356','37','CODIGO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('356','38','PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('356','39','PEDIDO DE PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('356','40','TITULO COM ORDEM DE PROTESTO EMITIDA');
   INCLUI_ERRCNABR('356','41','PEDIDO DE CANCELAMENTO/SUSTACAO PARA TITULOS SEM INSTRUCAO DE PROTESTO');
   INCLUI_ERRCNABR('356','42','CODIGO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('356','43','PRAZO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('356','44','CODIGO DA MOEDA INVALIDO ');
   INCLUI_ERRCNABR('356','45','NOME DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('356','46','TIPO/NUMERO DE INSCRICAO DO SACADO INVALIDOS');
   INCLUI_ERRCNABR('356','47','ENDERECO DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('356','48','CEP INVALIDO');
   INCLUI_ERRCNABR('356','49','CEP SEM PRACA DE COBRANCA (NAO LOCALIZADO)');
   INCLUI_ERRCNABR('356','50','CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('356','51','CEP INCOMPATIVEL COM A UNIDADE DA FEDERACAO');
   INCLUI_ERRCNABR('356','52','UNIDADE DA FEDERACAO INVALIDA');
   INCLUI_ERRCNABR('356','53','TIPO/NUMERO DE INSCRICAO DO SACADOR/AVALISTA INVALIDOS');
   INCLUI_ERRCNABR('356','54','SACADOR/AVALISTA NAO INFORMADO');
   INCLUI_ERRCNABR('356','55','NOSSO NUMERO NO BANCO CORRESPONDENTE NAO INFORMADO');
   INCLUI_ERRCNABR('356','56','CODIGO DO BANCO CORRESPONDENTE NAO INFORMADO');
   INCLUI_ERRCNABR('356','57','CODIGO DA MULTA INVALIDO');
   INCLUI_ERRCNABR('356','58','DATA DA MULTA INVALIDA');
   INCLUI_ERRCNABR('356','59','VALOR/PERCENTUAL DA MULTA INVALIDO');
   INCLUI_ERRCNABR('356','60','MOVIMENTO PARA TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('356','61','ALTERACAO DA AGENCIA COBRADORA/DV INVALIDA');
   INCLUI_ERRCNABR('356','62','TIPO DE IMPRESSAO INVALIDO');
   INCLUI_ERRCNABR('356','63','ENTRADA PARA TITULO JA CADASTRADO');
   INCLUI_ERRCNABR('356','64','NUMERO DA LINHA INVALIDO');
   INCLUI_ERRCNABR('356','65','CODIGO DO BANCO PARA DEBITO INVALIDO');
   INCLUI_ERRCNABR('356','66','AGENCIA/CONTA/DV PARA DEBITO INVALIDO');
   INCLUI_ERRCNABR('356','67','DADOS PARA DEBITO INCOMPATIVEL COM A IDENTIFICACAO DA EMISSAO DO BLOQUETO');
   INCLUI_ERRCNABR('356','68','DEBITO AUTOMATICO AGENDADO');
   INCLUI_ERRCNABR('356','69','DEBITO NAO AGENDADO - ERRO NOS DADOS DA REMESSA');
   INCLUI_ERRCNABR('356','70','DEBITO NAO AGENDADO - SACADO NAO CONSTA DO CADASTRO DE AUTORIZANTE');
   INCLUI_ERRCNABR('356','71','DEBITO NAO AGENDADO - CEDENTE NAO AUTORIZADO PELO SACADO ');
   INCLUI_ERRCNABR('356','72','DEBITO NAO AGENDADO - CEDENTE NAO PARTICIPA DA MODALIDADE DEBITO AUTOMATICO');
   INCLUI_ERRCNABR('356','73','DEBITO NAO AGENDADO - CODIGO DE MOEDA DIFERENTE DE REAL (R$)');
   INCLUI_ERRCNABR('356','74','DEBITO NAO AGENDADO - DATA VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('356','75','DEBITO NAO AGENDADO, CONFORME SEU PEDIDO, TITULO NAO REGISTRADO');
   INCLUI_ERRCNABR('356','76','DEBITO NAO AGENDADO, TIPO/NUM. INSCRICAO DO DEBITADO, INVALIDO');
   INCLUI_ERRCNABR('356','77','TRANSFERENCIA PARA DESCONTO NAO PERMITIDA PARA A CARTEIRA DO TITULO');
   INCLUI_ERRCNABR('356','78','DATA INFERIOR OU IGUAL AO VENCIMENTO PARA DEBITO AUTOMATICO');
   INCLUI_ERRCNABR('356','79','DATA JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('356','80','DATA DO DESCONTO INVALIDA');
   INCLUI_ERRCNABR('356','81','TENTATIVAS DE DEBITO ESGOTADAS - BAIXADO');
   INCLUI_ERRCNABR('356','82','TENTATIVAS DE DEBITO ESGOTADAS - PENDENTE');
   INCLUI_ERRCNABR('356','83','LIMITE EXCEDIDO');
   INCLUI_ERRCNABR('356','84','NUMERO AUTORIZACAO INEXISTENTE');
   INCLUI_ERRCNABR('356','85','TITULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('356','86','SEU NUMERO INVALIDO');
   COMMIT;
END;
/

BEGIN
-- Banco Banestes 021

   INCLUI_ERRCNABR('021','01','CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('021','02','CODIGO DO REGISTRO DETALHE INVALIDO');
   INCLUI_ERRCNABR('021','03','CODIGO DO SEGMENTO INVALIDO');
   INCLUI_ERRCNABR('021','04','CODIGO DE MOVIMENTO NAO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('021','05','CODIGO DE MOVIMENTO INVALIDO');
   INCLUI_ERRCNABR('021','06','TIPO/NUMERO DE INSCRICAO DO CEDENTE INVALIDOS');
   INCLUI_ERRCNABR('021','07','AGENCIA/CONTA/DV INVALIDO');
   INCLUI_ERRCNABR('021','08','NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('021','09','NOSSO NUMERO DUPLICADO');
   INCLUI_ERRCNABR('021','10','CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('021','11','FORMA DE CADASTRAMENTO DO TITULO INVALIDO');
   INCLUI_ERRCNABR('021','12','TIPO DE DOCUMENTO INVALIDO');
   INCLUI_ERRCNABR('021','13','IDENTIFICACAO DA EMISSAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('021','14','IDENTIFICACAO DA DISTRIBUICAO (POSTAGEM) DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('021','15','CARACTERISTICAS DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('021','16','DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('021','17','DATA DE VENCIMENTO ANTERIOR ADATA DE EMISSAO ');
   INCLUI_ERRCNABR('021','18','VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('021','19','TITULO A CARGO DE BANCOS CORRESPONDENTES COM VENCIMENTO INFERIOR A XX DIAS');
   INCLUI_ERRCNABR('021','20','VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('021','21','ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('021','22','ESPECIE DO TITULO NAO PERMITIDA PARA A CARTEIRA');
   INCLUI_ERRCNABR('021','23','ACEITE INVALIDO');
   INCLUI_ERRCNABR('021','24','DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('021','25','DATA DA EMISSAO POSTERIOR A DATA DE ENTRADA');
   INCLUI_ERRCNABR('021','26','CODIGO DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('021','27','VALOR/TAXA DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('021','28','CODIGO DO DESCONTO INVALIDO');
   INCLUI_ERRCNABR('021','29','VALOR DO DESCONTO MAIOR OU IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('021','30','DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('021','31','CONCESSAO DE DESCONTO - JA EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('021','32','VALOR DO IOF INVALIDO');
   INCLUI_ERRCNABR('021','33','VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('021','34','VALOR DO ABATIMENTO MAIOR OU IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('021','35','VALOR A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('021','36','CONCESSAO DE ABATIMENTO - JA EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('021','37','CODIGO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('021','38','PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('021','39','PEDIDO DE PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('021','40','TITULO COM ORDEM DE PROTESTO EMITIDA');
   INCLUI_ERRCNABR('021','41','PEDIDO DE CANCELAMENTO / SUSTACAO PARA TITULOS SEM INSTRUCAO DE PROTESTO');
   INCLUI_ERRCNABR('021','42','CODIGO PARA BAIXA / DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('021','43','PRAZO PARA BAIXA / DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('021','44','CODIGO DA MOEDA INVALIDO');
   INCLUI_ERRCNABR('021','45','NOME DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('021','46','TIPO / NUMERO DE INSCRICAO DO SACADO INVALIDOS');
   INCLUI_ERRCNABR('021','47','ENDERECO DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('021','48','CEP INVALIDO');
   INCLUI_ERRCNABR('021','49','CEP SEM PRACA DE COBRANCA (NAO LOCALIZADO)');
   INCLUI_ERRCNABR('021','50','CEP REFERENTE A UM BANCOCORRESPONDENTE');
   INCLUI_ERRCNABR('021','51','CEP INCOMPATIVEL COM A UNIDADE DA FEDERACAO');
   INCLUI_ERRCNABR('021','52','UNIDADE DA FEDERACAO INVALIDA');
   INCLUI_ERRCNABR('021','53','TIPO / NUMERO DE INSCRICAO DO SACADOR / AVALISTA INVALIDOS');
   INCLUI_ERRCNABR('021','54','SACADOR / AVALISTA NAO INFORMADO');
   INCLUI_ERRCNABR('021','55','NOSSO NUMERO NO BANCO CORRESPONDENTE NAO INFORMADO');
   INCLUI_ERRCNABR('021','56','CODIGO DO BANCO CORRESPONDENTE NAO INFORMADO');
   INCLUI_ERRCNABR('021','57','CODIGO DA MULTA INVALIDO');
   INCLUI_ERRCNABR('021','58','DATA DA MULTA INVALIDA');
   INCLUI_ERRCNABR('021','59','VALOR / PERCENTUAL DA MULTA INVALIDO');
   INCLUI_ERRCNABR('021','60','MOVIMENTO PARA TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('021','61','ALTERACAO DA AGENCIA COBRADORA / DV INVALIDA');
   INCLUI_ERRCNABR('021','62','TIPO DE IMPRESSAO INVALIDO');
   INCLUI_ERRCNABR('021','63','ENTRADA PARA TITULO JA CADASTRADO');
   INCLUI_ERRCNABR('021','64','NUMERO DA LINHA INVALIDO');
   INCLUI_ERRCNABR('021','65','CODIGO DO BANCO PARA DEBITO INVALIDO');
   INCLUI_ERRCNABR('021','66','AGENCIA / CONTA / DV PARA DEBITO INVALIDO');
   INCLUI_ERRCNABR('021','67','DADOS PARA DEBITO INCOMPATIVEL COM A IDENTIFICACAO DA EMISSAO DO BLOQUETO');
   INCLUI_ERRCNABR('021','68','DEBITO AUTOMATICO AGENDADO');
   INCLUI_ERRCNABR('021','69','DEBITO NAO AGENDADO - ERRO NOS DADOS DA REMESSA');
   INCLUI_ERRCNABR('021','70','DEBITO NAO AGENDADO - SACADO NAO CONSTA DO CADASTRO DE AUTORIZANTE');
   INCLUI_ERRCNABR('021','71','DEBITO NAO SGENDADO - CEDENTE NAO AUTORIZADO PELO SACADO');
   INCLUI_ERRCNABR('021','72','DEBITO NAO AGENDADO - CEDENTE NAO PARTICIPA DA MODALIDADE DEBITO AUTOMATICO');
   INCLUI_ERRCNABR('021','73','DEBITO NAO AGENDADO - CODIGO DE MOEDA DIFERENTE DE REAL (R$)');
   INCLUI_ERRCNABR('021','74','DEBITO NAO AGENDADO - DATA VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('021','75','DEBITO NAO AGENDADO, CONFORME SEU PEDIDO, TITULO NAO REGISTRADO');
   INCLUI_ERRCNABR('021','76','DEBITO NAO AGENDADO, TIPO / NUM. INSCRICAO DO DEBITADO, INVALIDO');
   INCLUI_ERRCNABR('021','77','TRANSFERENCIA PARA DESCONTO NAO PERMITIDA PARA A CARTEIRA DO TITULO');
   INCLUI_ERRCNABR('021','78','DATA INFERIOR OU IGUAL AO VENCIMENTO PARA DEBITO AUTOMATICO');
   INCLUI_ERRCNABR('021','79','DATA DO JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('021','80','DATA DO DESCONTO INVALIDA');
   INCLUI_ERRCNABR('021','81','TENTATIVAS DE DEBITO ESGOTADAS - BAIXADO');
   INCLUI_ERRCNABR('021','82','TENTATIVAS DE DEBITO ESGOTADAS - PENDENTE');
   INCLUI_ERRCNABR('021','83','LIMITE EXCEDIDO');
   INCLUI_ERRCNABR('021','84','NUMERO AUTORIZACAO INEXISTENTE');
   INCLUI_ERRCNABR('021','85','TITULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('021','86','SEU NUMERO INVALIDO');
   INCLUI_ERRCNABR('021','98','ERRO NA FORMACAO DO CARNE');
   INCLUI_ERRCNABR('021','0199','[REMESSA REJEITADA] REMESSA EM DUPLICIDADE');
   INCLUI_ERRCNABR('021','0299','[REMESSA REJEITADA] ERRO NA SEQUEENCIA DO REGISTRO');
   INCLUI_ERRCNABR('021','0399','[REMESSA REJEITADA] CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('021','0499','[REMESSA REJEITADA] CEDENTE NAO CADASTRADO');
   INCLUI_ERRCNABR('021','0599','[REMESSA REJEITADA] REGISTRO NAO E "HEADER"');
   INCLUI_ERRCNABR('021','0699','[REMESSA REJEITADA] ARQUIVO NAO E REMESSA');
   INCLUI_ERRCNABR('021','0799','[REMESSA REJEITADA] SERVICO NAO E COBRANCA');
   INCLUI_ERRCNABR('021','0899','[REMESSA REJEITADA] CONTA CORRENTE DIFERENTE DO REGISTRO "HEADER"');
   INCLUI_ERRCNABR('021','0999','[REMESSA REJEITADA] CODIGO DE OCORRENCIA INVALIDO');
   INCLUI_ERRCNABR('021','1099','[REMESSA REJEITADA] ERRO NA SEQUEENCIA DO LOTE');
   INCLUI_ERRCNABR('021','1199','[REMESSA REJEITADA] NUMERO DO LOTE DO REGISTRO "DETALHES"DIFERE DO REGISTRO DE "HEADER"');
   INCLUI_ERRCNABR('021','1299','[REMESSA REJEITADA] FALTA REGISTRO DE "TRAILLER" DO ARQUIVO');
   INCLUI_ERRCNABR('021','1399','[REMESSA REJEITADA] NUMERO DO LOTE DO REGISTRO "TRAILLER" DIFERE DO REGISTRO DE "HEADER"');
   INCLUI_ERRCNABR('021','1499','[REMESSA REJEITADA] ERRO NA QUANTIDADE DE REGISTRO DO LOTE');
   INCLUI_ERRCNABR('021','1599','[REMESSA REJEITADA] NUMERO DO LOTE DO REGISTRO "TRAILLER" INVALIDO');
   INCLUI_ERRCNABR('021','1699','[REMESSA REJEITADA] ERRO NA QUANTIDADE DE LOTES DO ARQUIVO');
   INCLUI_ERRCNABR('021','1799','[REMESSA REJEITADA] CODIGO DO SEGMENTO FORA DE ORDEM');
   INCLUI_ERRCNABR('021','1899','[REMESSA REJEITADA] CODIGO DO REGISTRO FORA DE ORDEM');
   INCLUI_ERRCNABR('021','1999','[REMESSA REJEITADA] CODIGO DO REGISTRO INVALIDO');
   INCLUI_ERRCNABR('021','9999','[REMESSA REJEITADA] OUTROS MOTIVOS');
   COMMIT;
END;
/

BEGIN
--Banco Caixa Economica Federal
  INCLUI_ERRCNABR('104','01','CODIGO DO BANCO INVALIDO');
  INCLUI_ERRCNABR('104','02','CODIGO DO REGISTRO DETALHE INVALIDO');
  INCLUI_ERRCNABR('104','03','CODIGO DO SEGMENTO INVALIDO');
  INCLUI_ERRCNABR('104','05','CODIGO DE MOVIMENTO INVALIDO.');
  INCLUI_ERRCNABR('104','06','TIPO/NUMERO DE INSCRICAO DO CEDENTE INVALIDOS.');
  INCLUI_ERRCNABR('104','07','AGENCIA/CONTA/DV INVALIDO.');
  INCLUI_ERRCNABR('104','08','NOSSO NUMERO INVALIDO.');
  INCLUI_ERRCNABR('104','09','NOSSO NUMERO DUPLICADO.');
  INCLUI_ERRCNABR('104','10','CARTEIRA INVALIDA.');
  INCLUI_ERRCNABR('104','11','FORMA DE CADASTRAMENTO DO TITULO INVALIDO.');
  INCLUI_ERRCNABR('104','12','TIPO DE DOCUMENTO INVALIDO.');
  INCLUI_ERRCNABR('104','13','IDENTIFICACAO DA EMISSAO DO BLOQUETO INVALIDA.');
  INCLUI_ERRCNABR('104','14','IDENTIFICACAO DA DISTRIBUICAO DO BLOQUETO INVALIDA.');
  INCLUI_ERRCNABR('104','15','CARACTERISTICAS DE COBRANCA INCOMPATIVEIS.');
  INCLUI_ERRCNABR('104','16','DATA DE VENCIMENTO INVALIDA.');
  INCLUI_ERRCNABR('104','20','VALOR DO TITULO INVALID0.');
  INCLUI_ERRCNABR('104','21','ESPECIE DE TITULO INVALIDA.');
  INCLUI_ERRCNABR('104','23','ACEITE INVALIDO.');
  INCLUI_ERRCNABR('104','24','DATA DE EMISSAO INVALIDA.');
  INCLUI_ERRCNABR('104','26','CODIGO DE JUROS DE MORA INVALIDO.');
  INCLUI_ERRCNABR('104','27','VALOR/TAXA DE JUROS DE MORA INVALIDO.');
  INCLUI_ERRCNABR('104','28','CODIGO DE DESCONTO INVALIDO.');
  INCLUI_ERRCNABR('104','29','VALOR DE DESCONTO MAIOR OU IGUAL AO VALOR DO TITULO.');
  INCLUI_ERRCNABR('104','30','DESCONTO A CONCEDER NAO CONFERE.');
  INCLUI_ERRCNABR('104','32','VALOR DO IOF INVALIDO.');
  INCLUI_ERRCNABR('104','33','VALOR DO ABATIMENTO INVALIDO.');
  INCLUI_ERRCNABR('104','37','CODIGO PARA PROTESTO INVALIDO.');
  INCLUI_ERRCNABR('104','38','PRAZO PARA PROTESTO INVALIDO.');
  INCLUI_ERRCNABR('104','40','TITULO COM ORDEM DE PROTESTO EMITIDA.');
  INCLUI_ERRCNABR('104','42','CODIGO PARA BAIXA/DEVOLUCAO INVALIDO.');
  INCLUI_ERRCNABR('104','43','PRAZO PARA BAIXA/DEVOLUCAO INVALIDO.');
  INCLUI_ERRCNABR('104','44','CODIGO DA MOEDA INVALIDO.');
  INCLUI_ERRCNABR('104','45','NOME DO SACADO NAO INFORMADO.');
  INCLUI_ERRCNABR('104','46','TIPO/NUMERO DE INSCRICAO DO SACADO INVALIDOS.');
  INCLUI_ERRCNABR('104','47','ENDERECO DO SACADO NAO INFORMADO.');
  INCLUI_ERRCNABR('104','48','CEP INVALIDO.');
  INCLUI_ERRCNABR('104','49','CEP SEM PRACA DE COBRANCA (NAO LOCALIZADO).');
  INCLUI_ERRCNABR('104','52','UNIDADE DA FEDERACAO INVALIDA.');
  INCLUI_ERRCNABR('104','53','TIPO/NUMERO DE INSCRICAO DO SACADOR/AVALISTA INVALIDOS.');
  INCLUI_ERRCNABR('104','57','CODIGO DA MULTA INVALIDO.');
  INCLUI_ERRCNABR('104','58','DATA DA MULTA INVALIDA.');
  INCLUI_ERRCNABR('104','59','VALOR/PERCENTUAL DA MULTA INVALIDO.');
  INCLUI_ERRCNABR('104','60','MOVIMENTO PARA TITULO NAO CADASTRADO.');
  INCLUI_ERRCNABR('104','61','AGENCIA COBRADORA INVALIDA.');
  INCLUI_ERRCNABR('104','62','TIPO DE IMPRESSAO INVALIDO.');
  INCLUI_ERRCNABR('104','63','ENTRADA PARA TITULO JA CADASTRADO.');
  INCLUI_ERRCNABR('104','68','MOVIMENTACAO INVALIDA PARA O TITULO.');
  INCLUI_ERRCNABR('104','69','ALTERACAO DE DADOS INVALIDA.');
  INCLUI_ERRCNABR('104','70','APELIDO DO CLIENTE NAO CADASTRADO.');
  INCLUI_ERRCNABR('104','71','ERRO NA COMPOSICAO DO ARQUIVO.');
  INCLUI_ERRCNABR('104','72','LOTE DE SERVICO INVALIDO.');
  INCLUI_ERRCNABR('104','73','CODIGO DO CEDENTE INVALIDO.');
  INCLUI_ERRCNABR('104','74','CEDENTE NAO PERTENCE A COBRANCA  ELETRONICA/APELIDO NAO CONFERE COM CEDENTE.');
  INCLUI_ERRCNABR('104','75','NOME DA EMPRESA INVALIDO.');
  INCLUI_ERRCNABR('104','76','NOME DO BANCO INVALIDO.');
  INCLUI_ERRCNABR('104','77','CODIGO DA REMESSA INVALIDO.');
  INCLUI_ERRCNABR('104','78','DATA/HORA DA GERACAO DO ARQUIVO INVALIDA.');
  INCLUI_ERRCNABR('104','79','NUMERO SEQUENCIAL DO ARQUIVO INVALIDO.');
  INCLUI_ERRCNABR('104','80','NUMERO DA VERSAO DO LAYOUT DO ARQUIVO/LOTE INVALIDO.');
  INCLUI_ERRCNABR('104','81','LITERAL REMESSA-TESTE VALIDA SOMENTE PARA FASE DE TESTES.');
  INCLUI_ERRCNABR('104','82','LITERAL REMESSA-TESTE OBRIGATORIO PARA FASE DE TESTES.');
  INCLUI_ERRCNABR('104','83','TIPO/NUMERO DA INSCRICAO DA EMPRESA INVALIDOS.');
  INCLUI_ERRCNABR('104','84','TIPO DE OPERACAO INVALIDO.');
  INCLUI_ERRCNABR('104','85','TIPO DE SERVICO INVALIDO.');
  INCLUI_ERRCNABR('104','86','FORMA DE LANCAMENTO INVALIDO.');
  INCLUI_ERRCNABR('104','87','NUMERO DA REMESSA INVALIDO.');
  INCLUI_ERRCNABR('104','88','NUMERO DA REMESSA MENOR/IGUAL QUE DA REMESSA ANTERIOR.');
  INCLUI_ERRCNABR('104','89','LOTE DE SERVICO DIVERGENTE.');
  INCLUI_ERRCNABR('104','90','NUMERO SEQUENCIAL DO REGISTRO INVALIDO.');
  INCLUI_ERRCNABR('104','91','ERRO NA SEQUENCIAL DO SEGMENTO DO REGISTRO DETALHE.');
  INCLUI_ERRCNABR('104','92','CODIGO DE MOVIMENTO DIVERGENTE ENTRE GRUPO DE SEGMENTOS INVALIDO.');
  COMMIT;
END;
/
BEGIN
-- BANCO PORTUGUES 069
   INCLUI_ERRCNABR('069', '001', 'Codigo do Banco invalido');
   INCLUI_ERRCNABR('069', '002', 'Codigo do registro detalhe invalido');
   INCLUI_ERRCNABR('069', '004', 'Codigo de ocorrencia nao permitido para a carteira');
   INCLUI_ERRCNABR('069', '005', 'Codigo de ocorrencia nao numerico');
   INCLUI_ERRCNABR('069', '007', 'Agencia/Conta/digito invalidos');
   INCLUI_ERRCNABR('069', '008', 'Nosso numero invalido');
   INCLUI_ERRCNABR('069', '009', 'Banco Agencia Conta beneficiario nao numerico');
   INCLUI_ERRCNABR('069', '010', 'Carteira invalida');
   INCLUI_ERRCNABR('069', '015', 'Caracteristicas da cobranca incompativeis');
   INCLUI_ERRCNABR('069', '016', 'Data de vencimento invalida');
   INCLUI_ERRCNABR('069', '017', 'Data de vencimento anterior a data de emissao');
   INCLUI_ERRCNABR('069', '018', 'Vencimento fora do prazo de operacao');
   INCLUI_ERRCNABR('069', '020', 'Valor do titulo invalido');
   INCLUI_ERRCNABR('069', '021', 'Especie do Titulo invalida');
   INCLUI_ERRCNABR('069', '022', 'Especie nao permitida para a carteira');
   INCLUI_ERRCNABR('069', '024', 'Data de emissao invalida');
   INCLUI_ERRCNABR('069', '028', 'Codigo de desconto via TeleBpn invalido');
   INCLUI_ERRCNABR('069', '029', 'Valor do desconto maior/igual ao valor do Titulo');
   INCLUI_ERRCNABR('069', '030', 'Desconto a conceder nao confere');
   INCLUI_ERRCNABR('069', '031', 'Concessao de desconto - Ja existe desconto anterior');
   INCLUI_ERRCNABR('069', '033', 'Valor do abatimento invalido');
   INCLUI_ERRCNABR('069', '034', 'Valor do abatimento maior/igual ao valor do Titulo');
   INCLUI_ERRCNABR('069', '036', 'Concessao abatimento - Ja existe abatimento anterior');
   INCLUI_ERRCNABR('069', '038', 'Prazo para protesto invalido');
   INCLUI_ERRCNABR('069', '039', 'Pedido de protesto nao permitido para o Titulo');
   INCLUI_ERRCNABR('069', '040', 'Titulo com ordem de protesto emitido');
   INCLUI_ERRCNABR('069', '041', 'Pedido cancelamento/sustacao para Titulo sem instrucao de protesto');
   INCLUI_ERRCNABR('069', '042', 'Codigo para baixa/devolucao invalido');
   INCLUI_ERRCNABR('069', '045', 'Nome do Sacado nao informado');
   INCLUI_ERRCNABR('069', '046', 'Tipo/numero de inscricao do Sacado invalidos');
   INCLUI_ERRCNABR('069', '047', 'Endereco do Sacado nao informado');
   INCLUI_ERRCNABR('069', '048', 'CEP Invalido');
   INCLUI_ERRCNABR('069', '050', 'CEP referente a um Banco correspondente');
   INCLUI_ERRCNABR('069', '053', 'Tipo de inscricao do sacador avalista invalidos');
   INCLUI_ERRCNABR('069', '060', 'Movimento para Titulo nao cadastrado');
   INCLUI_ERRCNABR('069', '077', 'Transferencia para desconto nao permitido para a carteira');
   INCLUI_ERRCNABR('069', '085', 'Titulo com pagamento vinculado');
   INCLUI_ERRCNABR('069', '086', 'Seu numero invalido');
   COMMIT;
END;
/
BEGIN
-- BANCO BANRISUL 041
   INCLUI_ERRCNABR('041', '01', 'Codigo do Banco invalido');
   INCLUI_ERRCNABR('041', '02', 'Codigo de registro detalhe invalido');
   INCLUI_ERRCNABR('041', '03', 'Codigo do Segmento invalido');
   INCLUI_ERRCNABR('041', '04', 'Codigo do movimento nao permitido para a carteira');
   INCLUI_ERRCNABR('041', '05', 'Codigo do movimento invalido');
   INCLUI_ERRCNABR('041', '06', 'Tipo/Numero de inscricao do cedente invalido ');
   INCLUI_ERRCNABR('041', '07', 'Agencia/conta/DV invalido');
   INCLUI_ERRCNABR('041', '08', 'Nosso Numero invalido');
   INCLUI_ERRCNABR('041', '09', 'Nosso numero duplicado');
   INCLUI_ERRCNABR('041', '10', 'Carteira invalida');
   INCLUI_ERRCNABR('041', '11', 'Forma de cadastramento do titulo invalido');
   INCLUI_ERRCNABR('041', '12', 'Tipo de documento invalido');
   INCLUI_ERRCNABR('041', '13', 'Identificacao da emissao do bloqueto invalido');
   INCLUI_ERRCNABR('041', '14', 'Identificacao da distribuicao do bloqueto invalido');
   INCLUI_ERRCNABR('041', '15', 'Caracteristicas da cobranca incompativeis - carteira/moeda:');
   INCLUI_ERRCNABR('041', '16', 'Data de vencimento invalida:');
   INCLUI_ERRCNABR('041', '17', 'Data de vencimento anterior a data de emissao');
   INCLUI_ERRCNABR('041', '18', 'Vencimento fora do prazo de operacao');
   INCLUI_ERRCNABR('041', '19', 'Titulo a cargo de Bancos Correspondentes com vencimento inferior a XX dias');
   INCLUI_ERRCNABR('041', '20', 'Valor do titulo invalido (nao numerico)');
   INCLUI_ERRCNABR('041', '21', 'Especie do titulo invalida (arquivo de registro)');
   INCLUI_ERRCNABR('041', '22', 'Especie nao permetida para a carteira');
   INCLUI_ERRCNABR('041', '23', 'Aceite invalido - verifica conteudo valido');
   INCLUI_ERRCNABR('041', '24', 'Data de emissao invalida - verifica se a data e numerica e se esta no formato valido');
   INCLUI_ERRCNABR('041', '25', 'Data de emissao posterior a data de processamento');
   INCLUI_ERRCNABR('041', '26', 'Codigo de juros de mora invalido');
   INCLUI_ERRCNABR('041', '27', 'Valor/taxa de juros de mora invalido');
   INCLUI_ERRCNABR('041', '28', 'Codigo do desconto invalido');
   INCLUI_ERRCNABR('041', '29', 'Valor do desconto maior ou igual ao valor do titulo');
   INCLUI_ERRCNABR('041', '30', 'Desconto a conceder nao confere:');
   INCLUI_ERRCNABR('041', '32', 'Valor do IOF invalido');
   INCLUI_ERRCNABR('041', '33', 'Valor do abatimento invalido');
   INCLUI_ERRCNABR('041', '34', 'Valor do abatimento maior ou igual ao valor do titulo');
   INCLUI_ERRCNABR('041', '35', 'Abatimento a conceder nao confere');
   INCLUI_ERRCNABR('041', '36', 'Concessao de abatimento - ja existe abatimento anterior');
   INCLUI_ERRCNABR('041', '37', 'Codigo para protesto invalido - rejeita o titulo se o campo for diferente de branco, 0, 1 ou 3');
   INCLUI_ERRCNABR('041', '38', 'Prazo para protesto invalido - se o codigo for 1 verifica se o campo e numerico');
   INCLUI_ERRCNABR('041', '39', 'Pedido de protesto nao permitido para o titulo - nao permite protesto para as carteiras R, S e N');
   INCLUI_ERRCNABR('041', '40', 'Titulo com ordem de protesto emitida (para retorno de alteracao)');
   INCLUI_ERRCNABR('041', '41', 'Pedido de cancelamento/sustacao de protesto invalido');
   INCLUI_ERRCNABR('041', '42', 'Codigo para baixa/devolucao ou instrucao invalido - verifica se o codigo e branco, 0, 1 ou 2');
   INCLUI_ERRCNABR('041', '43', 'Prazo para baixa/devolucao invalido - se o codigo e 1 verifica se o campo prazo e numerico');
   INCLUI_ERRCNABR('041', '44', 'Codigo da moeda invalido');
   INCLUI_ERRCNABR('041', '45', 'Nome do sacado invalido ou alteracao do sacado nao permitida');
   INCLUI_ERRCNABR('041', '46', 'Tipo/numero de inscricao do sacado invalido');
   INCLUI_ERRCNABR('041', '47', 'Endereco nao informado ou alteracao de endereco nao permitida');
   INCLUI_ERRCNABR('041', '48', 'CEP invalido ou alteracao de CEP nao permitida');
   INCLUI_ERRCNABR('041', '49', 'CEP sem praca de cobranca ou alteracao de cidade nao permitida');
   INCLUI_ERRCNABR('041', '50', 'CEP referente a um Banco Correspondente');
   INCLUI_ERRCNABR('041', '51', 'CEP incompativel com a unidade da federacao');
   INCLUI_ERRCNABR('041', '52', 'Unidade de Federacao invalida ou alteracao de UF nao permitida');
   INCLUI_ERRCNABR('041', '53', 'Tipo/Numero de inscricao do Sacador/Avalista invalido');
   INCLUI_ERRCNABR('041', '54', 'Sacador/Avalista nao informado - para especie AD o nome do Sacador e obrigatorio');
   INCLUI_ERRCNABR('041', '57', 'Codigo da multa invalido');
   INCLUI_ERRCNABR('041', '58', 'Data da multa invalida');
   INCLUI_ERRCNABR('041', '59', 'Valor/percentual da multa invalido');
   INCLUI_ERRCNABR('041', '60', 'Movimento para titulo nao cadastrado - alteracao ou devolucao');
   INCLUI_ERRCNABR('041', '62', 'Tipo de impressao invalido - Segmento 3S ');
   INCLUI_ERRCNABR('041', '63', 'Entrada para titulo ja cadastrado');
   INCLUI_ERRCNABR('041', '79', 'Data de juros de mora invalido - valida data ou prazo na instrucao de juros');
   INCLUI_ERRCNABR('041', '80', 'Data do desconto invalida - valida data ou prazo da instrucao de desconto');
   INCLUI_ERRCNABR('041', '86', 'Seu numero invalido (para retorno de alteracao)');
   COMMIT;
END;
/
BEGIN
-- BANCO SANTANDER 033

   INCLUI_ERRCNABR('033','01','CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('033','02','CODIGO DO REGISTRO DETALHE INVALIDO');
   INCLUI_ERRCNABR('033','03','CODIGO DO SEGMENTO INVALIDO');
   INCLUI_ERRCNABR('033','04','CODIGO DE MOVIMENTO NAO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('033','05','CODIGO DE MOVIMENTO INVALIDO');
   INCLUI_ERRCNABR('033','06','TIPO/NUMERO DE INSCRICAO DO CEDENTE INVALIDOS');
   INCLUI_ERRCNABR('033','07','AGENCIA/CONTA/DV INVALIDO');
   INCLUI_ERRCNABR('033','08','NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('033','09','NOSSO NUMERO DUPLICADO');
   INCLUI_ERRCNABR('033','10','CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('033','11','FORMA DE CADASTRAMENTO DO TITULO INVALIDO');
   INCLUI_ERRCNABR('033','12','TIPO DE DOCUMENTO INVALIDO');
   INCLUI_ERRCNABR('033','13','IDENTIFICACAO DA EMISSAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('033','14','IDENTIFICACAO DA DISTRIBUICAO DO BLOQUETO INVALIDA');
   INCLUI_ERRCNABR('033','15','CARACTERISTICAS DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('033','16','DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('033','17','DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSAO');
   INCLUI_ERRCNABR('033','18','VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('033','19','TITULO A CARGO DE BANCOS CORRESPONDENTES COM VENCIMENTO INFERIOR A XX DIAS');
   INCLUI_ERRCNABR('033','20','VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('033','21','ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('033','22','ESPECIE DO TITULO NAO PERMITIDA PARA A CARTEIRA');
   INCLUI_ERRCNABR('033','23','ACEITE INVALIDO');
   INCLUI_ERRCNABR('033','24','DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('033','25','DATA DA EMISSAO POSTERIOR A DATA DE ENTRADA');
   INCLUI_ERRCNABR('033','26','CODIGO DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('033','27','VALOR/TAXA DE JUROS DE MORA INVALIDO');
   INCLUI_ERRCNABR('033','28','CODIGO DO DESCONTO INVALIDO');
   INCLUI_ERRCNABR('033','29','VALOR DO DESCONTO MAIOR OU IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('033','30','DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('033','31','CONCESSAO DE DESCONTO - JA EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('033','32','VALOR DO IOF INVALIDO');
   INCLUI_ERRCNABR('033','33','VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('033','34','VALOR DO ABATIMENTO MAIOR OU IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('033','35','VALOR A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('033','36','CONCESSAO DE ABATIMENTO - JA EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('033','37','CODIGO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('033','38','PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('033','39','PEDIDO DE PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('033','40','TITULO COM ORDEM DE PROTESTO EMITIDA');
   INCLUI_ERRCNABR('033','41','PEDIDO DE CANCELAMENTO/SUSTACAO PARA TITULOS SEM INSTRUCAO DE PROTESTO');
   INCLUI_ERRCNABR('033','42','CODIGO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('033','43','PRAZO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('033','44','CODIGO DA MOEDA INVALIDO ');
   INCLUI_ERRCNABR('033','45','NOME DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('033','46','TIPO/NUMERO DE INSCRICAO DO SACADO INVALIDOS');
   INCLUI_ERRCNABR('033','47','ENDERECO DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('033','48','CEP INVALIDO');
   INCLUI_ERRCNABR('033','49','CEP SEM PRACA DE COBRANCA (NAO LOCALIZADO)');
   INCLUI_ERRCNABR('033','50','CEP REFERENTE A UM BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('033','51','CEP INCOMPATIVEL COM A UNIDADE DA FEDERACAO');
   INCLUI_ERRCNABR('033','52','UNIDADE DA FEDERACAO INVALIDA');
   INCLUI_ERRCNABR('033','53','TIPO/NUMERO DE INSCRICAO DO SACADOR/AVALISTA INVALIDOS');
   INCLUI_ERRCNABR('033','54','SACADOR/AVALISTA NAO INFORMADO');
   INCLUI_ERRCNABR('033','55','NOSSO NUMERO NO BANCO CORRESPONDENTE NAO INFORMADO');
   INCLUI_ERRCNABR('033','56','CODIGO DO BANCO CORRESPONDENTE NAO INFORMADO');
   INCLUI_ERRCNABR('033','57','CODIGO DA MULTA INVALIDO');
   INCLUI_ERRCNABR('033','58','DATA DA MULTA INVALIDA');
   INCLUI_ERRCNABR('033','59','VALOR/PERCENTUAL DA MULTA INVALIDO');
   INCLUI_ERRCNABR('033','60','MOVIMENTO PARA TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('033','61','ALTERACAO DA AGENCIA COBRADORA/DV INVALIDA');
   INCLUI_ERRCNABR('033','62','TIPO DE IMPRESSAO INVALIDO');
   INCLUI_ERRCNABR('033','63','ENTRADA PARA TITULO JA CADASTRADO');
   INCLUI_ERRCNABR('033','64','NUMERO DA LINHA INVALIDO');
   INCLUI_ERRCNABR('033','A4','SACADO DDA');
   COMMIT;
END;
/
BEGIN
-- BANCO SOFISA
   INCLUI_ERRCNABR('637', '03', 'CEP invalido  Nao temos cobrador  Cobrador nao Localizado');
   INCLUI_ERRCNABR('637', '04', 'Sigla do Estado invalida');
   INCLUI_ERRCNABR('637', '05', 'Data de Vencimento invalida ou fora do prazo minimo');
   INCLUI_ERRCNABR('637', '06', 'Codigo do Banco invalido');
   INCLUI_ERRCNABR('637', '08', 'Nome do sacado nao informado');
   INCLUI_ERRCNABR('637', '10', 'Logradouro nao informado');
   INCLUI_ERRCNABR('637', '14', 'Registro em duplicidade');
   INCLUI_ERRCNABR('637', '19', 'Data de desconto invalida ou maior que a data de vencimento');
   INCLUI_ERRCNABR('637', '20', 'Valor de IOF nao numerico');
   INCLUI_ERRCNABR('637', '22', 'Valor de desconto + abatimento maior que o valor do titulo');
   INCLUI_ERRCNABR('637','25', 'CGC ou CPF do sacado invalido (aceito com restricoes)');
   INCLUI_ERRCNABR('637','26', 'Especies de documento invalida (difere de 01...10,13 e 99)');
   INCLUI_ERRCNABR('637','27', 'Data de emissao do titulo invalida');
   INCLUI_ERRCNABR('637','28', 'Seu numero nao informado');
   INCLUI_ERRCNABR('637','29', 'CEP e igual a espaco ou zeros; ou nao numerico');
   INCLUI_ERRCNABR('637','30', 'Valor do titulo nao numerico ou invalido');
   INCLUI_ERRCNABR('637','36', 'Valor de permanencia nao numerico');
   INCLUI_ERRCNABR('637','37', 'Valor de permanencia inconsistente, pois, dentro de um mes, sera maior que o valor do titulo');
   INCLUI_ERRCNABR('637','38', 'Valor de desconto/abatimento nao numerico ou invalido');
   INCLUI_ERRCNABR('637','39', 'Valor de abatimento nao numerico');
   INCLUI_ERRCNABR('637','42', 'Titulo ja existente em nossos registros. Nosso numero nao aceito');
   INCLUI_ERRCNABR('637','43', 'Titulo enviado em duplicidade nesse movimento');
   INCLUI_ERRCNABR('637','44', 'Titulo zerado ou em branco; ou nao numerico na remessa');
   INCLUI_ERRCNABR('637','46', 'Titulo enviado fora da faixa de Nosso Numero, estipulada para o cliente.');
   INCLUI_ERRCNABR('637','53', 'Prazo de vencimento do titulo excede ao da contratacao');
   INCLUI_ERRCNABR('637','54', 'Banco informado nao e nosso correspondente 140-142');
   INCLUI_ERRCNABR('637','55', 'Banco correspondente informado nao cobra este CEP ou nao possui faixas de CEP cadastradas');
   INCLUI_ERRCNABR('637','56', 'Nosso numero no correspondente nao foi informado');
   INCLUI_ERRCNABR('637','57', 'Remessa contendo duas instrucoes incompativeis  nao protestar e dias de protesto ou prazo para protesto invalido.');
   INCLUI_ERRCNABR('637','58', 'Entradas Rejeitadas  Reprovado no Represamento para Analise');
   INCLUI_ERRCNABR('637','60', 'CGC/CPF do sacado invalido  titulo recusado');
   INCLUI_ERRCNABR('637','87', 'Excede Prazo maximo entre emissao e vencimento');
   INCLUI_ERRCNABR('637','AG', 'Movimento nao permitido  Titulo a vista ou contra apresentacao');
   INCLUI_ERRCNABR('637','AK', 'Titulo pertence a outro cliente');
   INCLUI_ERRCNABR('637','AL', 'Sacado impedido de entrar nesta cobranca');
   INCLUI_ERRCNABR('637','AY', 'Titulo deve estar em aberto e vencido para acatar protesto');
   INCLUI_ERRCNABR('637','BC', 'Analise gerencial-sacado invalido p/operacao credito');
   INCLUI_ERRCNABR('637','BD', 'Analise gerencial-sacado inadimplente');
   INCLUI_ERRCNABR('637','BE', 'Analise gerencial-sacado difere do exigido');
   INCLUI_ERRCNABR('637','BF', 'Analise gerencial-vencto excede vencto da operacao de credito');
   INCLUI_ERRCNABR('637','BG', 'Analise gerencial-sacado com baixa liquidez');
   INCLUI_ERRCNABR('637','BH', 'Analise gerencial-sacado excede concentracao');
   INCLUI_ERRCNABR('637','CB', 'Titulo possui protesto efetivado/a efetivar hoje');
   INCLUI_ERRCNABR('637','CC', 'Valor de iof incompativel com a especie documento');
   INCLUI_ERRCNABR('637','CD', 'Efetivacao de protesto sem agenda valida');
   INCLUI_ERRCNABR('637','CE', 'Titulo nao aceito - pessoa fisica');
   INCLUI_ERRCNABR('637','CF', 'Excede prazo maximo da entrada ao vencimento');
   INCLUI_ERRCNABR('637','CG', 'Titulo nao aceito  por analise gerencial');
   INCLUI_ERRCNABR('637','CH', 'Titulo em espera  em analise pelo banco');
   COMMIT;
END;
/

BEGIN
-- BANCO SICREDI
   INCLUI_ERRCNABR('748', '01', 'Codigo do Banco invalido');
   INCLUI_ERRCNABR('748', '02', 'Codigo do registro detalhe invalido');
   INCLUI_ERRCNABR('748', '03', 'Codigo da Ocorrencia invalido');
   INCLUI_ERRCNABR('748', '04', 'Codigo da Ocorrencia nao permitido para a carteira');
   INCLUI_ERRCNABR('748', '05', 'Codigo de Ocorrencia nao numerico');
   INCLUI_ERRCNABR('748', '07', 'Cooperativa/agencia/conta/digito invalidos');
   INCLUI_ERRCNABR('748', '08', 'Nosso numero invalido');
   INCLUI_ERRCNABR('748', '09', 'Nosso numero duplicado');
   INCLUI_ERRCNABR('748', '10', 'Carteira invalida');
   INCLUI_ERRCNABR('748', '14', 'Titulo Protestado');
   INCLUI_ERRCNABR('748', '15', 'Cooperativa/agencia/conta/nosso numero invalidos');
   INCLUI_ERRCNABR('748', '16', 'Data de vencimento invalida');
   INCLUI_ERRCNABR('748', '17', 'Data de vencimento anterior a data de emissao');
   INCLUI_ERRCNABR('748', '18', 'Vencimento fora do prazo de operacao');
   INCLUI_ERRCNABR('748', '20', 'Valor do titulo invalido');
   INCLUI_ERRCNABR('748', '21', 'Especie do titulo invalida');
   INCLUI_ERRCNABR('748', '22', 'Especie nao permitida para a carteira');
   INCLUI_ERRCNABR('748', '24', 'Data de emissao invalida');
   INCLUI_ERRCNABR('748', '29', 'Valor de desconto maior/igual ao valor do titulo');
   INCLUI_ERRCNABR('748', '31', 'Concessao de desconto - existe desconto anterior');
   INCLUI_ERRCNABR('748', '33', 'Valor do abatimento invalido');
   INCLUI_ERRCNABR('748', '34', 'Valor do abatimento maior/igual ao valor do titulo');
   INCLUI_ERRCNABR('748', '36', 'Concessao de abatimento - existe abatimento anterior');
   INCLUI_ERRCNABR('748', '38', 'Prazo para protesto invalido');
   INCLUI_ERRCNABR('748', '39', 'Pedido para protesto nao permitido para o titulo');
   INCLUI_ERRCNABR('748', '40', 'Titulo com ordem de protesto emitida');
   INCLUI_ERRCNABR('748', '41', 'Pedido cancelamento/sustacao sem instrucao de de protesto');
   INCLUI_ERRCNABR('748', '44', 'Cooperativa de credito/agencia cedente nao prevista');
   INCLUI_ERRCNABR('748', '45', 'Nome do sacado invalido');
   INCLUI_ERRCNABR('748', '46', 'Tipo/numero de inscricao do sacado invalidos');
   INCLUI_ERRCNABR('748', '47', 'Endereco do sacado nao informado');
   INCLUI_ERRCNABR('748', '48', 'CEP irregular');
   INCLUI_ERRCNABR('748', '49', 'Numero de inscricao do sacador/avalista invalido');
   INCLUI_ERRCNABR('748', '50', 'Sacador/avalista nao informado');
   INCLUI_ERRCNABR('748', '60', 'Movimento para titulo nao cadastrado');
   INCLUI_ERRCNABR('748', '63', 'Entrada para titulo ja cadastrado');
   INCLUI_ERRCNABR('748', 'A',  'Aceito');
   INCLUI_ERRCNABR('748', 'D', ' Desprezado');
   INCLUI_ERRCNABR('748', 'A1', 'Praca do Sacado nao cadastrada');
   INCLUI_ERRCNABR('748', 'A2', 'Tipo de cobranca do titulo divergente com a praca do sacado');
   INCLUI_ERRCNABR('748', 'A3', 'Cooperativa/agencia depositaria divergente: atualiza o cadastro de pracas da Coop./agencia cedente');
   INCLUI_ERRCNABR('748', 'A4', 'Cedente nao cadastrado ou possui CGC/CIC invalido');
   INCLUI_ERRCNABR('748', 'A5', 'Sacado nao cadastrado');
   INCLUI_ERRCNABR('748', 'A6', 'Data da instrucao/ocorrencia invalida');
   INCLUI_ERRCNABR('748', 'A7', 'Ocorrencia nao pode ser comandada');
   INCLUI_ERRCNABR('748', 'A8', 'Recebimento da liquidacao fora do SICREDI - via compensacao eletronica');
   INCLUI_ERRCNABR('748', 'B4', 'Tipo de moeda invalido');
   INCLUI_ERRCNABR('748', 'B5', 'Tipo de desconto/juros invalido');
   INCLUI_ERRCNABR('748', 'B6', 'Mensagem padrao nao cadastrada');
   INCLUI_ERRCNABR('748', 'B7', 'Seu numero invalido');
   INCLUI_ERRCNABR('748', 'B8', 'Percentual de multa invalido');
   INCLUI_ERRCNABR('748', 'B9', 'Valor ou percentual de juros invalido');
   INCLUI_ERRCNABR('748', 'C1', 'Data limite para concessao de desconto invalida');
   INCLUI_ERRCNABR('748', 'C2', 'Aceite do titulo invalido');
   INCLUI_ERRCNABR('748', 'C3', 'Campo alterado na instrucao: 31 - Alteracao de outros dados, invalido');
   INCLUI_ERRCNABR('748', 'C4', 'Titulo ainda nao foi confirmado pela centralizadora');
   INCLUI_ERRCNABR('748', 'C5', 'Titulo rejeitado pela centralizadora');
   INCLUI_ERRCNABR('748', 'C6', 'Titulo ja liquidado');
   INCLUI_ERRCNABR('748', 'C7', 'Titulo ja baixado');
   INCLUI_ERRCNABR('748', 'C8', 'Existe mesma instrucao pendente de confirmacao para este titulo');
   INCLUI_ERRCNABR('748', 'C9', 'Instrucao previa de concessao de abatimento nao existe ou nao confirmada');
   INCLUI_ERRCNABR('748', 'D1', 'Titulo dentro do prazo de vencimentos (em dia)');
   INCLUI_ERRCNABR('748', 'D2', 'Especie de documento nao permite protesto de titulo');
   INCLUI_ERRCNABR('748', 'D3', 'Titulo possui instrucao de baixa pendente de confirmacao');
   INCLUI_ERRCNABR('748', 'D4', 'Quantidade de mensagens padrao excede o limite permitido');
   INCLUI_ERRCNABR('748', 'D5', 'Quantidade invalida no pedido de bloquetos pre-impressos da cobranca sem registro');
   INCLUI_ERRCNABR('748', 'D6', 'Tipo de impressao invalida para cobranca sem registro');
   INCLUI_ERRCNABR('748', 'D7', 'Cidade ou Estado do sacado nao informado');
   INCLUI_ERRCNABR('748', 'D8', 'Sequencia para composicao do nosso numero do ano atual esgotada');
   INCLUI_ERRCNABR('748', 'D9', 'Registro mensagem para titulo nao cadastrado');
   INCLUI_ERRCNABR('748', 'E2', 'Registro complementar ao cadastro do titulo da cobranca com e sem registro nao cadastrado');
   INCLUI_ERRCNABR('748', 'E3', 'Tipo de postagem invalido, diferente de S, N e branco');
   INCLUI_ERRCNABR('748', 'E4', 'Pedido de bloquetos pre-impressos');
   INCLUI_ERRCNABR('748', 'E5', 'Confirmacao/rejeicao para pedidos de bloquetos nao cadastrado');
   INCLUI_ERRCNABR('748', 'E6', 'Sacador/avalista nao cadastrado');
   INCLUI_ERRCNABR('748', 'E7', 'Informacao para atualizacao do valor do titulo para protesto invalido');
   INCLUI_ERRCNABR('748', 'E8', 'Tipo de impressao invalido, diferente de A, B e branco');
   INCLUI_ERRCNABR('748', 'E9', 'Codigo do sacado do titulo divergente com o codigo da cooperativa de credito');
   INCLUI_ERRCNABR('748', 'F1', 'Liquidado no sistema do cliente');
   INCLUI_ERRCNABR('748', 'F2', 'Baixado no sistema do cliente');
   INCLUI_ERRCNABR('748', 'F3', 'Instrucao invalida, este titulo esta caucionado/descontado');
   INCLUI_ERRCNABR('748', 'F4', 'Instrucao fixa com caracteres invalidos');
   INCLUI_ERRCNABR('748', 'F6', 'Nosso numero / numero da parcela fora de sequencia - total de parcelas invalido');
   INCLUI_ERRCNABR('748', 'F7', 'Falta de comprovante de prestacao de servicos');
   INCLUI_ERRCNABR('748', 'F8', 'Nome do cedente incompleto/incorreto');
   INCLUI_ERRCNABR('748', 'F9', 'CNPJ/CPF incompativel com o nome do sacado / sacador avalista');
   INCLUI_ERRCNABR('748', 'G1', 'CNPJ/CPF do sacador incompativel com a especie');
   INCLUI_ERRCNABR('748', 'G2', 'Titulo aceito: sem a assinatura do sacado');
   INCLUI_ERRCNABR('748', 'G3', 'Titulo aceito: rasurado ou rasgado');
   INCLUI_ERRCNABR('748', 'G4', 'Titulo aceito: falta titulo (cooperativa/ag. cedente devera envia-lo');
   INCLUI_ERRCNABR('748', 'G5', 'Praca de pagamento incompativel com o endereco');
   INCLUI_ERRCNABR('748', 'G6', 'Titulo aceito: sem endosso ou cedente irregular');
   INCLUI_ERRCNABR('748', 'G7', 'Titulo aceito: valor por extenso diferente do valor numerico');
   INCLUI_ERRCNABR('748', 'G8', 'Saldo maior que o valor do titulo');
   INCLUI_ERRCNABR('748', 'G9', 'Tipo de endosso invalido');
   INCLUI_ERRCNABR('748', 'H1', 'Nome sacador incompleto/incorreto');
   INCLUI_ERRCNABR('748', 'H2', 'Sustacao judicial');
   INCLUI_ERRCNABR('748', 'H3', 'Sacado nao encontrado');
   INCLUI_ERRCNABR('748', 'H4', 'Alteracao da carteira');
   INCLUI_ERRCNABR('748', 'H5', 'Recebimento da liquidacao fora da rede SICREDI - VLB inferior - Via compensacao');
   INCLUI_ERRCNABR('748', 'H6', 'Recebimento da liquidacao fora da rede SICREDI - VLB superior - Via compensacao');
   INCLUI_ERRCNABR('748', 'H7', 'Especie de documento necessita cedente ou avalista PJ');
   INCLUI_ERRCNABR('748', 'H8', 'Recebimento da liquidacao fora da rede SICREDI - Contingencia Via Compe');
   INCLUI_ERRCNABR('748', 'H9', 'Dados do titulo nao conferem com disquete');
   INCLUI_ERRCNABR('748', 'I1', 'Sacado e sacador avalista sao a mesma pessoa');
   INCLUI_ERRCNABR('748', 'I2', 'Aguardar um dia util apos o vencimento para protestar');
   INCLUI_ERRCNABR('748', 'I3', 'Data do vencimento rasurada');
   INCLUI_ERRCNABR('748', 'I4', 'Vencimento - extenso nao confere com numero');
   INCLUI_ERRCNABR('748', 'I5', 'Falta data de vencimento no titulo');
   INCLUI_ERRCNABR('748', 'I6', 'DM/DMI sem comprovante autenticado ou declaracao');
   INCLUI_ERRCNABR('748', 'I7', 'Comprovante ilegivel para conferencia e microfilmagem');
   INCLUI_ERRCNABR('748', 'I8', 'Nome solicitado nao confere com emitente ou sacado');
   INCLUI_ERRCNABR('748', 'I9', 'Confirmar se sao 2 emitentes. Se sim, indicar os dados dos 2');
   INCLUI_ERRCNABR('748', 'J1', 'Endereco do sacado igual ao do sacador ou do portador');
   INCLUI_ERRCNABR('748', 'J2', 'Endereco do apresentante incompleto ou nao informado');
   INCLUI_ERRCNABR('748', 'J3', 'Rua/numero inexistente no endereco');
   INCLUI_ERRCNABR('748', 'J4', 'Falta endosso do favorecido para o apresentante');
   INCLUI_ERRCNABR('748', 'J5', 'Data de emissao rasurada');
   INCLUI_ERRCNABR('748', 'J6', 'Falta assinatura do sacador no titulo');
   INCLUI_ERRCNABR('748', 'J7', 'Nome do apresentante nao informado/incompleto/incorreto');
   INCLUI_ERRCNABR('748', 'J8', 'Erro de preenchimento de titulo');
   INCLUI_ERRCNABR('748', 'J9', 'Titulo com direito de regresso vencido');
   INCLUI_ERRCNABR('748', 'K1', 'Titulo apresentado em duplicidade');
   INCLUI_ERRCNABR('748', 'K2', 'Titulo ja protestado');
   INCLUI_ERRCNABR('748', 'K3', 'Letra de cambio vencida - falta aceite do sacado');
   INCLUI_ERRCNABR('748', 'K4', 'Falta declaracao de saldo assinada no titulo');
   INCLUI_ERRCNABR('748', 'K5', 'Contrato de cambio - Falta conta grafica');
   INCLUI_ERRCNABR('748', 'K6', 'Ausencia do documento fisico');
   INCLUI_ERRCNABR('748', 'K7', 'Sacado falecido');
   INCLUI_ERRCNABR('748', 'K8', 'Sacado apresentou quitacao do titulo');
   INCLUI_ERRCNABR('748', 'K9', 'Titulo de outra jurisdicao territorial');
   INCLUI_ERRCNABR('748', 'L1', 'Titulo com emissao anterior a concordata do sacado');
   INCLUI_ERRCNABR('748', 'L2', 'Sacado consta na lista de falencia');
   INCLUI_ERRCNABR('748', 'L3', 'Apresentante nao aceita publicacao de edital');
   INCLUI_ERRCNABR('748', 'L4', 'Dados do Sacado em Branco ou invalido');
   INCLUI_ERRCNABR('748', 'L5', 'Codigo do Sacado na agencia cedente esta duplicado');
   INCLUI_ERRCNABR('748', 'M1', 'Reconhecimento da divida pelo Sacado');
   INCLUI_ERRCNABR('748', 'M2', 'Nao reconhecimento da divida pelo Sacado');
   INCLUI_ERRCNABR('748', 'X1', 'Regularizacao Centralizadora - Rede SICREDI');
   INCLUI_ERRCNABR('748', 'X2', 'Regularizacao Centralizadora - Compensacao');
   INCLUI_ERRCNABR('748', 'X3', 'Regularizacao Centralizadora - Banco correspondente');
   INCLUI_ERRCNABR('748', 'X4', 'Regularizacao Centralizadora - VLB Inferior - via compensacao');
   INCLUI_ERRCNABR('748', 'X5', 'Regularizacao Centralizadora - VLB Inferior - via compensacao');
   INCLUI_ERRCNABR('748', 'X0', 'Pago com cheque');
   INCLUI_ERRCNABR('748', 'X6', 'Pago com cheque - bloqueado 24 horas');
   INCLUI_ERRCNABR('748', 'X7', 'Pago com cheque - bloqueado 48 horas');
   INCLUI_ERRCNABR('748', 'X8', 'Pago com cheque - bloqueado 72 horas');
   INCLUI_ERRCNABR('748', 'X9', 'Pago com cheque - bloqueado 96 horas');
   INCLUI_ERRCNABR('748', 'XA', 'Pago com cheque - bloqueado 120 horas');
   INCLUI_ERRCNABR('748', 'XB', 'Pago com cheque - bloqueado 144 horas');
   COMMIT;
END;
/
BEGIN
-- BANCO SICOOB
   INCLUI_ERRCNABR('756', '0200', '[Entrada confirmada] Ocorrencia aceita');
   INCLUI_ERRCNABR('756', '0217', '[Entrada confirmada] Data de vencimento anterior a data de emissao');
   INCLUI_ERRCNABR('756', '0221', '[Entrada confirmada] Especie do Titulo invalido');
   INCLUI_ERRCNABR('756', '0224', '[Entrada confirmada] Data da emissao invalida');
   INCLUI_ERRCNABR('756', '0238', '[Entrada confirmada] Prazo para protesto invalido');
   INCLUI_ERRCNABR('756', '0239', '[Entrada confirmada] Pedido para protesto nao permitido para titulo');
   INCLUI_ERRCNABR('756', '0243', '[Entrada confirmada] Prazo para baixa e devolucao invalido');
   INCLUI_ERRCNABR('756', '0245', '[Entrada confirmada] Nome do Sacado invalido');
   INCLUI_ERRCNABR('756', '0246', '[Entrada confirmada] Tipo/num. de inscricao do Sacado invalidos');
   INCLUI_ERRCNABR('756', '0247', '[Entrada confirmada] Endereco do Sacado nao informado');
   INCLUI_ERRCNABR('756', '0248', '[Entrada confirmada] CEP irregular');
   INCLUI_ERRCNABR('756', '0250', '[Entrada confirmada] CEP referente a Banco correspondente');
   INCLUI_ERRCNABR('756', '0253', '[Entrada confirmada] N de inscricao do Sacador/avalista invalidos (CPF/CGC)');
   INCLUI_ERRCNABR('756', '0254', '[Entrada confirmada] Sacador/avalista nao informado');
   INCLUI_ERRCNABR('756', '0267', '[Entrada confirmada] Debito automatico agendado');
   INCLUI_ERRCNABR('756', '0268', '[Entrada confirmada] Debito nao agendado  Erro nos dados de remessa');
   INCLUI_ERRCNABR('756', '0269', '[Entrada confirmada] Debito nao agendado  Sacado nao consta no cadastro de autorizante');
   INCLUI_ERRCNABR('756', '0270', '[Entrada confirmada] Debito nao agendado  Cedente nao autorizado pelo Sacado');
   INCLUI_ERRCNABR('756', '0271', '[Entrada confirmada] Debito nao agendado  Cedente nao participa da modalidade de debito automatico');
   INCLUI_ERRCNABR('756', '0272', '[Entrada confirmada] Debito nao agendado  Codigo de moeda diferente de R$');
   INCLUI_ERRCNABR('756', '0273', '[Entrada confirmada] Debito nao agendado  Data de vencimento invalida');
   INCLUI_ERRCNABR('756', '0275', '[Entrada confirmada] Debito nao agendado  Tipo do numero de inscricao do sacado debitado invalido');
   INCLUI_ERRCNABR('756', '0286', '[Entrada confirmada] Seu numero do documento invalido');
   INCLUI_ERRCNABR('756', '0302', '[Entrada Rejeitada] Codigo do registro detalhe invalido');
   INCLUI_ERRCNABR('756', '0303', '[Entrada Rejeitada] Codigo da ocorrencia invalida');
   INCLUI_ERRCNABR('756', '0304', '[Entrada Rejeitada] Codigo de ocorrencia nao permitida para a carteira');
   INCLUI_ERRCNABR('756', '0305', '[Entrada Rejeitada] Codigo de ocorrencia nao numerico');
   INCLUI_ERRCNABR('756', '0307', '[Entrada Rejeitada] Agencia/conta/Digito  Invalido');
   INCLUI_ERRCNABR('756', '0308', '[Entrada Rejeitada] Nosso numero invalido');
   INCLUI_ERRCNABR('756', '0309', '[Entrada Rejeitada] Nosso numero duplicado');
   INCLUI_ERRCNABR('756', '0310', '[Entrada Rejeitada] Carteira invalida');
   INCLUI_ERRCNABR('756', '0316', '[Entrada Rejeitada] Data de vencimento invalida');
   INCLUI_ERRCNABR('756', '0318', '[Entrada Rejeitada] Vencimento fora do prazo de operacao');
   INCLUI_ERRCNABR('756', '0320', '[Entrada Rejeitada] Valor do Titulo invalido');
   INCLUI_ERRCNABR('756', '0321', '[Entrada Rejeitada] Especie do Titulo invalida');
   INCLUI_ERRCNABR('756', '0322', '[Entrada Rejeitada] Especie nao permitida para a carteira');
   INCLUI_ERRCNABR('756', '0324', '[Entrada Rejeitada] Data de emissao invalida');
   INCLUI_ERRCNABR('756', '0338', '[Entrada Rejeitada] Prazo para protesto invalido');
   INCLUI_ERRCNABR('756', '0344', '[Entrada Rejeitada] Agencia Cedente nao prevista');
   INCLUI_ERRCNABR('756', '0350', '[Entrada Rejeitada] CEP irregular  Banco Correspondente');
   INCLUI_ERRCNABR('756', '0363', '[Entrada Rejeitada] Entrada para Titulo ja cadastrado');
   INCLUI_ERRCNABR('756', '0368', '[Entrada Rejeitada] Debito nao agendado  Erro nos dados de remessa');
   INCLUI_ERRCNABR('756', '0369', '[Entrada Rejeitada] Debito nao agendado  Sacado nao consta no cadastro de autorizante');
   INCLUI_ERRCNABR('756', '0370', '[Entrada Rejeitada] Debito nao agendado  Cedente nao autorizado pelo Sacado');
   INCLUI_ERRCNABR('756', '0371', '[Entrada Rejeitada] Debito nao agendado  Cedente nao participa da modalidade de debito automatico');
   INCLUI_ERRCNABR('756', '0372', '[Entrada Rejeitada] Debito nao agendado  Codigo de moeda diferente de R$');
   INCLUI_ERRCNABR('756', '0373', '[Entrada Rejeitada] Debito nao agendado  Data de vencimento invalida');
   INCLUI_ERRCNABR('756', '0374', '[Entrada Rejeitada] Debito nao agendado  Conforme seu pedido, Titulo nao registrado');
   INCLUI_ERRCNABR('756', '0375', '[Entrada Rejeitada] Debito nao agendado  Tipo de numero de inscricao do debitado invalido');
   INCLUI_ERRCNABR('756', '0910', '[Baixado Automaticamente via Arquivo] Baixa comandada pelo cliente');
   INCLUI_ERRCNABR('756', '1000', '[Baixado Conforme Instrucoes da Agencia] Baixa Comandada');
   INCLUI_ERRCNABR('756', '1014', '[Baixado Conforme Instrucoes da Agencia] Titulo Protestado');
   INCLUI_ERRCNABR('756', '1015', '[Baixado Conforme Instrucoes da Agencia] Titulo excluido');
   INCLUI_ERRCNABR('756', '2448', '[Entrada Rejeitada por CEP irregular] CEP invalido');
   INCLUI_ERRCNABR('756', '2704', '[Baixa Rejeitada] Codigo de ocorrencia nao permitido para a carteira');
   INCLUI_ERRCNABR('756', '2707', '[Baixa Rejeitada] Agencia/Conta/digito invalidos');
   INCLUI_ERRCNABR('756', '2708', '[Baixa Rejeitada] Nosso numero invalido');
   INCLUI_ERRCNABR('756', '2710', '[Baixa Rejeitada] Carteira invalida');
   INCLUI_ERRCNABR('756', '2715', '[Baixa Rejeitada] Carteira/Agencia/Conta/nosso numero invalidos');
   INCLUI_ERRCNABR('756', '2740', '[Baixa Rejeitada] Titulo com ordem de protesto emitido');
   INCLUI_ERRCNABR('756', '2742', '[Baixa Rejeitada] Codigo para baixa/devolucao via Telebradesco invalido');
   INCLUI_ERRCNABR('756', '2760', '[Baixa Rejeitada] Movimento para Titulo nao cadastrado');
   INCLUI_ERRCNABR('756', '2777', '[Baixa Rejeitada] Transferencia para desconto nao permitido para a carteira');
   INCLUI_ERRCNABR('756', '2785', '[Baixa Rejeitada] Titulo com pagamento vinculado');
   INCLUI_ERRCNABR('756', '2803', '[Debito de Tarifas/Custas] Tarifa de sustacao');
   INCLUI_ERRCNABR('756', '2804', '[Debito de Tarifas/Custas] Tarifa de protesto');
   INCLUI_ERRCNABR('756', '2808', '[Debito de Tarifas/Custas] Custas de protesto');
   INCLUI_ERRCNABR('756', '3001', '[Alteracao de Outros Dados Rejeitados] Codigo do Banco invalido');
   INCLUI_ERRCNABR('756', '3004', '[Alteracao de Outros Dados Rejeitados] Codigo de ocorrencia nao permitido para a carteira');
   INCLUI_ERRCNABR('756', '3005', '[Alteracao de Outros Dados Rejeitados] Codigo da ocorrencia nao numerico');
   INCLUI_ERRCNABR('756', '3008', '[Alteracao de Outros Dados Rejeitados] Nosso numero invalido');
   INCLUI_ERRCNABR('756', '3015', '[Alteracao de Outros Dados Rejeitados] Caracteristica da cobranca imcopativel');
   INCLUI_ERRCNABR('756', '3016', '[Alteracao de Outros Dados Rejeitados] Data de vencimento invalido');
   INCLUI_ERRCNABR('756', '3017', '[Alteracao de Outros Dados Rejeitados] Data de vencimento anterior a data de emissao');
   INCLUI_ERRCNABR('756', '3018', '[Alteracao de Outros Dados Rejeitados] Vencimento fora do prazo de operacao');
   INCLUI_ERRCNABR('756', '3024', '[Alteracao de Outros Dados Rejeitados] Data de emissao Invalida');
   INCLUI_ERRCNABR('756', '3029', '[Alteracao de Outros Dados Rejeitados] Valor do desconto maior/igual ao valor do Titulo');
   INCLUI_ERRCNABR('756', '3030', '[Alteracao de Outros Dados Rejeitados] Desconto a conceder nao confere');
   INCLUI_ERRCNABR('756', '3031', '[Alteracao de Outros Dados Rejeitados] Concessao de desconto ja existente (Desconto anterior)');
   INCLUI_ERRCNABR('756', '3033', '[Alteracao de Outros Dados Rejeitados] Valor do abatimento invalido');
   INCLUI_ERRCNABR('756', '3034', '[Alteracao de Outros Dados Rejeitados] Valor do abatimento maior/igual ao valor do Titulo');
   INCLUI_ERRCNABR('756', '3038', '[Alteracao de Outros Dados Rejeitados] Prazo para protesto invalido');
   INCLUI_ERRCNABR('756', '3039', '[Alteracao de Outros Dados Rejeitados] Pedido de protesto nao permitido para o Titulo');
   INCLUI_ERRCNABR('756', '3040', '[Alteracao de Outros Dados Rejeitados] Titulo com ordem de protesto emitido');
   INCLUI_ERRCNABR('756', '3042', '[Alteracao de Outros Dados Rejeitados] Codigo para baixa/devolucao invalido');
   INCLUI_ERRCNABR('756', '3060', '[Alteracao de Outros Dados Rejeitados] Movimento para Titulo nao cadastrado');
   INCLUI_ERRCNABR('756', '3085', '[Alteracao de Outros Dados Rejeitados] Titulo com Pagamento Vinculado');
   INCLUI_ERRCNABR('756', '3201', '[Instrucao Rejeitada] Codigo do Banco invalido');
   INCLUI_ERRCNABR('756', '3202', '[Instrucao Rejeitada] Codigo do registro detalhe invalido');
   INCLUI_ERRCNABR('756', '3204', '[Instrucao Rejeitada] Codigo de ocorrencia nao permitido para a carteira');
   INCLUI_ERRCNABR('756', '3205', '[Instrucao Rejeitada] Codigo de ocorrencia nao numerico');
   INCLUI_ERRCNABR('756', '3207', '[Instrucao Rejeitada] Agencia/Conta/digito invalidos');
   INCLUI_ERRCNABR('756', '3208', '[Instrucao Rejeitada] Nosso numero invalido');
   INCLUI_ERRCNABR('756', '3210', '[Instrucao Rejeitada] Carteira invalida');
   INCLUI_ERRCNABR('756', '3215', '[Instrucao Rejeitada] Caracteristicas da cobranca incompativeis');
   INCLUI_ERRCNABR('756', '3216', '[Instrucao Rejeitada] Data de vencimento invalida');
   INCLUI_ERRCNABR('756', '3217', '[Instrucao Rejeitada] Data de vencimento anterior a data de emissao');
   INCLUI_ERRCNABR('756', '3218', '[Instrucao Rejeitada] Vencimento fora do prazo de operacao');
   INCLUI_ERRCNABR('756', '3220', '[Instrucao Rejeitada] Valor do titulo invalido');
   INCLUI_ERRCNABR('756', '3221', '[Instrucao Rejeitada] Especie do Titulo invalida');
   INCLUI_ERRCNABR('756', '3222', '[Instrucao Rejeitada] Especie nao permitida para a carteira');
   INCLUI_ERRCNABR('756', '3224', '[Instrucao Rejeitada] Data de emissao invalida');
   INCLUI_ERRCNABR('756', '3228', '[Instrucao Rejeitada] Codigo de desconto via Telebradesco invalido');
   INCLUI_ERRCNABR('756', '3229', '[Instrucao Rejeitada] Valor do desconto maior/igual ao valor do Titulo');
   INCLUI_ERRCNABR('756', '3230', '[Instrucao Rejeitada] Desconto a conceder nao confere');
   INCLUI_ERRCNABR('756', '3231', '[Instrucao Rejeitada] Concessao de desconto  Ja existe desconto anterior');
   INCLUI_ERRCNABR('756', '3233', '[Instrucao Rejeitada] Valor do abatimento invalido');
   INCLUI_ERRCNABR('756', '3234', '[Instrucao Rejeitada] Valor do abatimento maior/igual ao valor do Titulo');
   INCLUI_ERRCNABR('756', '3236', '[Instrucao Rejeitada] Concessao abatimento  Ja existe abatimento anterior');
   INCLUI_ERRCNABR('756', '3238', '[Instrucao Rejeitada] Prazo para protesto invalido');
   INCLUI_ERRCNABR('756', '3239', '[Instrucao Rejeitada] Pedido de protesto nao permitido para o Titulo');
   INCLUI_ERRCNABR('756', '3240', '[Instrucao Rejeitada] Titulo com ordem de protesto emitido');
   INCLUI_ERRCNABR('756', '3241', '[Instrucao Rejeitada] Pedido cancelamento/sustacao para Titulo sem instrucao de protesto');
   INCLUI_ERRCNABR('756', '3242', '[Instrucao Rejeitada] Codigo para baixa/devolucao invalido');
   INCLUI_ERRCNABR('756', '3245', '[Instrucao Rejeitada] Nome do Sacado nao informado');
   INCLUI_ERRCNABR('756', '3246', '[Instrucao Rejeitada] Tipo/numero de inscricao do Sacado invalidos');
   INCLUI_ERRCNABR('756', '3247', '[Instrucao Rejeitada] Endereco do Sacado nao informado');
   INCLUI_ERRCNABR('756', '3248', '[Instrucao Rejeitada] CEP Invalido');
   INCLUI_ERRCNABR('756', '3250', '[Instrucao Rejeitada] CEP referente a um Banco correspondente');
   INCLUI_ERRCNABR('756', '3253', '[Instrucao Rejeitada] Tipo de inscricao do sacador avalista invalidos');
   INCLUI_ERRCNABR('756', '3260', '[Instrucao Rejeitada] Movimento para Titulo nao cadastrado');
   INCLUI_ERRCNABR('756', '3285', '[Instrucao Rejeitada] Titulo com pagamento vinculado');
   INCLUI_ERRCNABR('756', '3286', '[Instrucao Rejeitada] Seu numero invalido');
   INCLUI_ERRCNABR('756', '3581', '[Desagendamento do Debito Automatico] Tentativas esgotadas, baixado');
   INCLUI_ERRCNABR('756', '3582', '[Desagendamento do Debito Automatico] Tentativas esgotadas, pendente');
   COMMIT;
END;
/
BEGIN
   --Banco Daycoval
	INCLUI_ERRCNABR('707', '0303', '[Entrada Rejeitada] CEP invalido  Nao temos cobrador  Cobrador nao Localizado');
	INCLUI_ERRCNABR('707', '0304', '[Entrada Rejeitada] Sigla do Estado invalida');
	INCLUI_ERRCNABR('707', '0305', '[Entrada Rejeitada] Data de Vencimento invalida ou fora do prazo minimo');
	INCLUI_ERRCNABR('707', '0306', '[Entrada Rejeitada] Codigo do Banco invalido');
	INCLUI_ERRCNABR('707', '0308', '[Entrada Rejeitada] Nome do sacado nao informado');
	INCLUI_ERRCNABR('707', '0310', '[Entrada Rejeitada] Logradouro nao informado');
	INCLUI_ERRCNABR('707', '0314', '[Entrada Rejeitada] Registro em duplicidade');
	INCLUI_ERRCNABR('707', '0319', '[Entrada Rejeitada] Data de desconto invalida ou maior que a data de vencimento');
	INCLUI_ERRCNABR('707', '0320', '[Entrada Rejeitada] Valor de IOF nao numerico');
	INCLUI_ERRCNABR('707', '0322', '[Entrada Rejeitada] Valor de desconto + abatimento maior que o valor do titulo');
	INCLUI_ERRCNABR('707', '0325', '[Entrada Rejeitada] CNPJ ou CPF do sacado invalido (aceito com restricoes)');
	INCLUI_ERRCNABR('707', '0326', '[Entrada Rejeitada] Especies de documento invalida (difere de 01...10,13 e 99)');
	INCLUI_ERRCNABR('707', '0327', '[Entrada Rejeitada] Data de emissao do titulo invalida');
	INCLUI_ERRCNABR('707', '0328', '[Entrada Rejeitada] Seu numero nao informado');
	INCLUI_ERRCNABR('707', '0329', '[Entrada Rejeitada] CEP e igual a espaco ou zeros; ou nao numerico');
	INCLUI_ERRCNABR('707', '0330', '[Entrada Rejeitada] Valor do titulo nao numerico ou invalido');
	INCLUI_ERRCNABR('707', '0336', '[Entrada Rejeitada] Valor de permanencia nao numerico');
	INCLUI_ERRCNABR('707', '0337', '[Entrada Rejeitada] Valor de permanencia inconsistente, pois, dentro de um mes, sera maior que o valor do titulo');
	INCLUI_ERRCNABR('707', '0338', '[Entrada Rejeitada] Valor de desconto/abatimento nao numerico ou invalido');
	INCLUI_ERRCNABR('707', '0339', '[Entrada Rejeitada] Valor de abatimento nao numerico');
	INCLUI_ERRCNABR('707', '0342', '[Entrada Rejeitada] Titulo ja existente em nossos registros. Nosso numero nao aceito');
	INCLUI_ERRCNABR('707', '0343', '[Entrada Rejeitada] Titulo enviado em duplicidade nesse movimento');
	INCLUI_ERRCNABR('707', '0344', '[Entrada Rejeitada] Titulo zerado ou em branco; ou nao numerico na remessa');
	INCLUI_ERRCNABR('707', '0346', '[Entrada Rejeitada] Titulo enviado fora da faixa de Nosso Numero, estipulada para o cliente.');
	INCLUI_ERRCNABR('707', '0351', '[Entrada Rejeitada] Tipo/Numero de Inscricao Sacador/Avalista Invalido');
	INCLUI_ERRCNABR('707', '0353', '[Entrada Rejeitada] Prazo de vencimento do titulo excede ao da contratacao');
	INCLUI_ERRCNABR('707', '0354', '[Entrada Rejeitada] Banco informado nao e nosso correspondente 140-142');
	INCLUI_ERRCNABR('707', '0355', '[Entrada Rejeitada] Banco correspondente informado nao cobra este CEP ou nao possui faixas de CEP cadastradas');
	INCLUI_ERRCNABR('707', '0356', '[Entrada Rejeitada] Nosso numero no correspondente nao foi informado');
	INCLUI_ERRCNABR('707', '0357', '[Entrada Rejeitada] Remessa contendo duas instrucoes incompativeis  nao protestar e dias de protesto ou prazo para protesto invalido.');
	INCLUI_ERRCNABR('707', '0358', '[Entrada Rejeitada] Entrada Rejeitada  Reprovado no Represamento para Analise');
	INCLUI_ERRCNABR('707', '0360', '[Entrada Rejeitada] CNPJ/CPF do sacado invalido  titulo recusado');
	INCLUI_ERRCNABR('707', '0387', '[Entrada Rejeitada] Excede Prazo maximo entre emissao e vencimento');
	INCLUI_ERRCNABR('707', '0399', '[Entrada Rejeitada] Titulo nao acatado pelo banco  entrar em contato Gerente da conta');
	INCLUI_ERRCNABR('707', '03AE', '[Entrada Rejeitada] Titulo nao possui abatimento');
	INCLUI_ERRCNABR('707', '03AG', '[Entrada Rejeitada] Movimento nao permitido  Titulo a vista ou contra apresentacao');
	INCLUI_ERRCNABR('707', '03AK', '[Entrada Rejeitada] Titulo pertence a outro cliente');
	INCLUI_ERRCNABR('707', '03AL', '[Entrada Rejeitada] Sacado impedido de entrar nesta cobranca');
	INCLUI_ERRCNABR('707', '03AY', '[Entrada Rejeitada] Titulo deve estar em aberto e vencido para acatar protesto');
	INCLUI_ERRCNABR('707', '03BC', '[Entrada Rejeitada] Analise gerencial-sacado invalido p/operacao credito');
	INCLUI_ERRCNABR('707', '03BD', '[Entrada Rejeitada] Analise gerencial-sacado inadimplente');
	INCLUI_ERRCNABR('707', '03BE', '[Entrada Rejeitada] Analise gerencial-sacado difere do exigido');
	INCLUI_ERRCNABR('707', '03BF', '[Entrada Rejeitada] Analise gerencial-vencto excede vencto da operacao de credito');
	INCLUI_ERRCNABR('707', '03BG', '[Entrada Rejeitada] Analise gerencial-sacado com baixa liquidez');
	INCLUI_ERRCNABR('707', '03BH', '[Entrada Rejeitada] Analise gerencial-sacado excede concentracao');
	INCLUI_ERRCNABR('707', '03CB', '[Entrada Rejeitada] Titulo possui protesto efetivado/a efetivar hoje');
	INCLUI_ERRCNABR('707', '03CC', '[Entrada Rejeitada] Valor de iof incompativel com a especie documento');
	INCLUI_ERRCNABR('707', '03CD', '[Entrada Rejeitada] Efetivacao de protesto sem agenda valida');
	INCLUI_ERRCNABR('707', '03CE', '[Entrada Rejeitada] Titulo nao aceito - pessoa fisica');
	INCLUI_ERRCNABR('707', '03CF', '[Entrada Rejeitada] Excede prazo maximo da entrada ao vencimento');
	INCLUI_ERRCNABR('707', '03CG', '[Entrada Rejeitada] Titulo nao aceito  por analise gerencial');
	INCLUI_ERRCNABR('707', '03CH', '[Entrada Rejeitada] Titulo em espera  em analise pelo banco');
	INCLUI_ERRCNABR('707', '03CJ', '[Entrada Rejeitada] Analise gerencial-vencto do titulo abaixo przcurto');
	INCLUI_ERRCNABR('707', '03CK', '[Entrada Rejeitada] Analise gerencial-vencto do titulo abaixo przlongo');
	INCLUI_ERRCNABR('707', '03CS', '[Entrada Rejeitada] Titulo rejeitado pela checagem de duplicatas');
	INCLUI_ERRCNABR('707', '03CT', '[Entrada Rejeitada] Titulo ja baixado');
	INCLUI_ERRCNABR('707', '03DA', '[Entrada Rejeitada] Analise gerencial  Entrada de Titulo Descontado com limite cancelado');
	INCLUI_ERRCNABR('707', '03DB', '[Entrada Rejeitada] Analise gerencial  Entrada de Titulo Descontado com limite vencido');
	INCLUI_ERRCNABR('707', '03DC', '[Entrada Rejeitada] Analise gerencial - cedente com limite cancelado');
	INCLUI_ERRCNABR('707', '03DD', '[Entrada Rejeitada] Analise gerencial  cedente e sacado e teve seu limite cancelado');
	INCLUI_ERRCNABR('707', '03DE', '[Entrada Rejeitada] Analise gerencial - apontamento no Serasa');
	INCLUI_ERRCNABR('707', '03DG', '[Entrada Rejeitada] Endereco sacador/avalista nao informado');
	INCLUI_ERRCNABR('707', '03DH', '[Entrada Rejeitada] Cep do sacador/avalista nao informado');
	INCLUI_ERRCNABR('707', '03DI', '[Entrada Rejeitada] Cidade do sacador/avalista nao informado');
	INCLUI_ERRCNABR('707', '03DJ', '[Entrada Rejeitada] Estado do sacador/avalista invalido ou n informado');
	INCLUI_ERRCNABR('707', '03DM', '[Entrada Rejeitada] Cliente sem Codigo de Flash cadastrado no cobrador');
	INCLUI_ERRCNABR('707', '03DN', '[Entrada Rejeitada] Titulo Descontado com Prazo ZERO  Recusado');
	INCLUI_ERRCNABR('707', '03DO', '[Entrada Rejeitada] Titulo em Prejuizo');
	INCLUI_ERRCNABR('707', '03DP', '[Entrada Rejeitada] Data de Referencia menor que a Data de Emissao do Titulo');
	INCLUI_ERRCNABR('707', '03DT', '[Entrada Rejeitada] Nosso Numero do Correspondente nao deve ser informado');
	INCLUI_ERRCNABR('707', '03EB', '[Entrada Rejeitada] HSBC nao aceita endereco de sacado com mais de 38 caracteres');
	INCLUI_ERRCNABR('707', '1505', '[Baixa Rejeitada] Solicitacao de baixa para titulo ja baixado ou liquidado');
	INCLUI_ERRCNABR('707', '1506', '[Baixa Rejeitada] Solicitacao de baixa para titulo nao registrado no sistema');
	INCLUI_ERRCNABR('707', '1508', '[Baixa Rejeitada] Solicitacao de baixa para titulo em float');
	INCLUI_ERRCNABR('707', '1605', '[Instrucao Rejeitada] Solicitacao de baixa para titulo ja baixado ou liquidado');
	INCLUI_ERRCNABR('707', '1604', '[Instrucao Rejeitada] Data de Vencimento nao numerica ou invalida');
	INCLUI_ERRCNABR('707', '1614', '[Instrucao Rejeitada] Registro em duplicidade');
	INCLUI_ERRCNABR('707', '1620', '[Instrucao Rejeitada] Campo livre informado');
	INCLUI_ERRCNABR('707', '1621', '[Instrucao Rejeitada] Titulo nao registrado no sistema');
	INCLUI_ERRCNABR('707', '1622', '[Instrucao Rejeitada] Titulo baixada ou liquidado');
	INCLUI_ERRCNABR('707', '1627', '[Instrucao Rejeitada] Instrucao nao aceita, por nao ter sido emitida ordem de protesto ao cartorio');
	INCLUI_ERRCNABR('707', '1628', '[Instrucao Rejeitada] Titulo tem instrucao de cartorio ativa');
	INCLUI_ERRCNABR('707', '1629', '[Instrucao Rejeitada] Titulo nao tem instrucao de cartorio ativa');
	INCLUI_ERRCNABR('707', '1630', '[Instrucao Rejeitada] Existe instrucao de nao protestar, ativa para o titulo');
	INCLUI_ERRCNABR('707', '1637', '[Instrucao Rejeitada] Titulo Descontado - Instrucao nao permitida para a carteira');
	INCLUI_ERRCNABR('707', '1638', '[Instrucao Rejeitada] Valor do abatimento nao numerico ou maior que a soma do valor do titulo + pemanencia + multa');
	INCLUI_ERRCNABR('707', '1639', '[Instrucao Rejeitada] Titulo em cartorio');
	INCLUI_ERRCNABR('707', '1640', '[Instrucao Rejeitada] Instrucao recusada - cobranca vinculada / caucionada');
	INCLUI_ERRCNABR('707', '1699', '[Instrucao Rejeitada] Ocorrencia desconhecida na remessa');
	COMMIT;
END;
/
BEGIN
-- BANCO ALFA 025

   INCLUI_ERRCNABR('025', '0200', '[ENTRADA CONFIRMADA] OCORRENCIA ACEITA');
   INCLUI_ERRCNABR('025', '0217', '[ENTRADA CONFIRMADA] DATA VENCIMENTO ANTERIOR A DATA DE EMISSAO');
   INCLUI_ERRCNABR('025', '0221', '[ENTRADA CONFIRMADA] ESPECIE DO TITULO INVALIDO');
   INCLUI_ERRCNABR('025', '0224', '[ENTRADA CONFIRMADA] DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('025', '0238', '[ENTRADA CONFIRMADA] PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('025', '0239', '[ENTRADA CONFIRMADA] PEDIDO P.PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('025', '0243', '[ENTRADA CONFIRMADA] PRAZO PARA BAIXA DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('025', '0245', '[ENTRADA CONFIRMADA] NOME DO SACADO INVALIDO');
   INCLUI_ERRCNABR('025', '0246', '[ENTRADA CONFIRMADA] TIPO/NUM. DE INSCRICAO DO SACADO INVALIDOS');
   INCLUI_ERRCNABR('025', '0247', '[ENTRADA CONFIRMADA] ENDERECO DO SACADO INVALIDO');
   INCLUI_ERRCNABR('025', '0248', '[ENTRADA CONFIRMADA] CEP INVALIDO');
   INCLUI_ERRCNABR('025', '0250', '[ENTRADA CONFIRMADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('025', '0253', '[ENTRADA CONFIRMADA] N INCR. SACADOR/AVALISTA INVALIDOS (CNPJ/CPF)');
   INCLUI_ERRCNABR('025', '0254', '[ENTRADA CONFIRMADA] SACADOR/AVALISTA NAO INFORMADO');
   INCLUI_ERRCNABR('025', '0267', '[ENTRADA CONFIRMADA] DEB. AUTOMATICO AGENDADO');
   INCLUI_ERRCNABR('025', '0268', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO ERRO NOS DADOS DE REMESSA');
   INCLUI_ERRCNABR('025', '0269', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - SACADO NAO CONSTA NO CAD. AUTORIZANTE');
   INCLUI_ERRCNABR('025', '0270', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - CEDENTE NAO AUTORIZADO PELO SACADO');
   INCLUI_ERRCNABR('025', '0271', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - CEDENTE NAO CADASTRADO P/ DEBITO AUTOMATICO');
   INCLUI_ERRCNABR('025', '0272', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - CODIGO DE MOEDA DIFERENTE DE R$');
   INCLUI_ERRCNABR('025', '0273', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('025', '0275', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - TIPO NUMERO DE INSCRICAO DO DEBITADO INVALIDO');
   INCLUI_ERRCNABR('025', '0286', '[ENTRADA CONFIRMADA] SEU NUMERO INVALIDO');
   INCLUI_ERRCNABR('025', '0302', '[ENTRADA REJEITADA] CODIGO DO REGISTRO DETALHE INVALIDO');
   INCLUI_ERRCNABR('025', '0303', '[ENTRADA REJEITADA] CODIGO DA OCORRENCIA INVALIDO');
   INCLUI_ERRCNABR('025', '0304', '[ENTRADA REJEITADA] COD. DA OCORR. NAO PERMITIDA P/A CARTEIRA');
   INCLUI_ERRCNABR('025', '0305', '[ENTRADA REJEITADA] COD. DA OCORRENCIA NAO NUMERICA');
   INCLUI_ERRCNABR('025', '0308', '[ENTRADA REJEITADA] NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('025', '0309', '[ENTRADA REJEITADA] NOSSO NUMERO DUPLICADO');
   INCLUI_ERRCNABR('025', '0310', '[ENTRADA REJEITADA] CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('025', '0316', '[ENTRADA REJEITADA] DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('025', '0318', '[ENTRADA REJEITADA] VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('025', '0320', '[ENTRADA REJEITADA] VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('025', '0321', '[ENTRADA REJEITADA] ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('025', '0322', '[ENTRADA REJEITADA] ESPECIE NAO PERMITIDA P/ CARTEIRA');
   INCLUI_ERRCNABR('025', '0324', '[ENTRADA REJEITADA] DATA DE EMISSAO INVALIDA');
   INCLUI_ERRCNABR('025', '0350', '[ENTRADA REJEITADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('025', '0363', '[ENTRADA REJEITADA] ENTRADA P/TITULO JA CADASTRADO');
   INCLUI_ERRCNABR('025', '0368', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - ERRO NOS DADOS DE REMESSA');
   INCLUI_ERRCNABR('025', '0369', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - SACADO NAO CONSTA NO CAD. DE AUTORIZANTE');
   INCLUI_ERRCNABR('025', '0370', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - CEDENTE NAO AUTORIZADO PELO SACADO');
   INCLUI_ERRCNABR('025', '0371', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - CEDENTE NAO CADASTRADO P/ DEBITO AUTOMATICO');
   INCLUI_ERRCNABR('025', '0372', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - CODIGO DE MOEDA DIFERENTE DE R$');
   INCLUI_ERRCNABR('025', '0373', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('025', '0374', '[ENTRADA REJEITADA] DEB. NAO AGENDADO, CONFORME SEU PEDIDO, TITULO NAO REGISTRADO');
   INCLUI_ERRCNABR('025', '0375', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - TIPO NUMERO DE INSCRICAO DO DEBITADO INVALIDO');
   INCLUI_ERRCNABR('025', '06  ', '[LIQUIDACAO NORMAL] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '0910', '[BAIXADO AUT. VIA ARQUIVO] BAIXA COMANDADA PELO CLIENTE');
   INCLUI_ERRCNABR('025', '1000', '[BAIXADO CONF. INST. AG.] BAIXA COMANDADA');
   INCLUI_ERRCNABR('025', '1014', '[BAIXADO CONF. INST. AG.] TITULO  PROTESTADO');
   INCLUI_ERRCNABR('025', '1015', '[BAIXADO CONF. INST. AG.] TITULO EXCLUIDO');
   INCLUI_ERRCNABR('025', '11  ', '[EM SER (TITULO PENDENTE)] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '12  ', '[ABATIMENTO CONCEDIDO] -SEM MOTIVO');
   INCLUI_ERRCNABR('025', '13  ', '[ABATIMENTO CANCELADO] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '14  ', '[VENCIMENTO ALTERADO] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '15  ', '[LIQUIDACAO EM CARTORIO] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '17  ', '[LIQUIDACAO APOS BAIXA] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '18  ', '[ACERTO DE DEPOSITARIA] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '19  ', '[CONF.RECEB.INST. PROTESTO ] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '20  ', '[CONF.RECEB.INST.SUST.PROT.] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '21  ', '[ACERTO CONT. PARTICIPANTE] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '23  ', '[ENTRADA TITULO EM CARTORIO] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '2448', '[ENTRADA REJEITADA] CEP INVALIDO');
   INCLUI_ERRCNABR('025', '2707', '[BAIXA REJEITADA] AGENCIA/CONTA/DV. INVALIDO');
   INCLUI_ERRCNABR('025', '2708', '[BAIXA REJEITADA] NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('025', '2710', '[BAIXA REJEITADA] CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('025', '2715', '[BAIXA REJEITADA] CARTEIRA/AG./CONTA/NUM. INVALIDOS');
   INCLUI_ERRCNABR('025', '2740', '[BAIXA REJEITADA] TITULO COM ORDEM DE PROTESTO');
   INCLUI_ERRCNABR('025', '2742', '[BAIXA REJEITADA] CODIGO P/BAIXA/DEV; VIA TELEB. INVALIDO');
   INCLUI_ERRCNABR('025', '2760', '[BAIXA REJEITADA] MOVIMENTO P/TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('025', '2803', '[DEB. DE TARIFAS/CUSTOS] TARIFA DE SUSTACAO(valor informado-posicao 176 a 188)');
   INCLUI_ERRCNABR('025', '2808', '[DEB. DE TARIFAS/CUSTOS] CUSTAS DE PROTESTO(valor informado-posicao 189 a 201)');
   INCLUI_ERRCNABR('025', '2804', '[DEB. DE TARIFAS/CUSTOS] TARIFA DE PROTESTO (valor informado-posicao 176 a 188)');
   INCLUI_ERRCNABR('025', '3001', '[ALTERACAO/DADOS REJEITADOS] CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('025', '3004', '[ALTERACAO/DADOS REJEITADOS] CODIGO DE OCORRENCIA NAO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('025', '3005', '[ALTERACAO/DADOS REJEITADOS] CODIGO DA OCORRENCIA NAO NUMERICO');
   INCLUI_ERRCNABR('025', '3008', '[ALTERACAO/DADOS REJEITADOS] NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('025', '3015', '[ALTERACAO/DADOS REJEITADOS] CARACTERISTICAS  DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('025', '3016', '[ALTERACAO/DADOS REJEITADOS] DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('025', '3017', '[ALTERACAO/DADOS REJEITADOS] DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSAO');
   INCLUI_ERRCNABR('025', '3018', '[ALTERACAO/DADOS REJEITADOS] VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('025', '3024', '[ALTERACAO/DADOS REJEITADOS] DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('025', '3029', '[ALTERACAO/DADOS REJEITADOS] VALOR DESC. MAIOR/IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('025', '3030', '[ALTERACAO/DADOS REJEITADOS] DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('025', '3031', '[ALTERACAO/DADOS REJEITADOS] CONCESSAO DE DESCONTO JA EXISTENTE - DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('025', '3033', '[ALTERACAO/DADOS REJEITADOS] VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('025', '3034', '[ALTERACAO/DADOS REJEITADOS] VALOR ABAT. MAIOR/IGUAL VALOR DO TITULO');
   INCLUI_ERRCNABR('025', '3038', '[ALTERACAO/DADOS REJEITADOS] PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('025', '3039', '[ALTERACAO/DADOS REJEITADOS] PEDIDO DE PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('025', '3040', '[ALTERACAO/DADOS REJEITADOS] TITULO COM ORDEM DE PROTESTO EMITIDO');
   INCLUI_ERRCNABR('025', '3042', '[ALTERACAO/DADOS REJEITADOS] CODIGO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('025', '3060', '[ALTERACAO/DADOS REJEITADOS] MOVIMENTO PARA TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('025', '3085', '[ALTERACAO/DADOS REJEITADOS] TITULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('025', '3201', '[INSTRUCAO REJEITADA] CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('025', '3204', '[INSTRUCAO REJEITADA] CODIGO DE OCORRENCIA NAO PERMITIDO PARA A CARTEIRA');
   INCLUI_ERRCNABR('025', '3215', '[INSTRUCAO REJEITADA] CARACTERISTICAS DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('025', '3216', '[INSTRUCAO REJEITADA] DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('025', '3217', '[INSTRUCAO REJEITADA] DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSAO');
   INCLUI_ERRCNABR('025', '3218', '[INSTRUCAO REJEITADA] VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('025', '3220', '[INSTRUCAO REJEITADA] VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('025', '3221', '[INSTRUCAO REJEITADA] ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('025', '3223', '[INSTRUCAO REJEITADA] ACEITE INVALIDO');
   INCLUI_ERRCNABR('025', '3224', '[INSTRUCAO REJEITADA] DATA DE EMISSAO INVALIDA');
   INCLUI_ERRCNABR('025', '3228', '[INSTRUCAO REJEITADA] CODIGO DO DESCONTO INVALIDO');
   INCLUI_ERRCNABR('025', '3229', '[INSTRUCAO REJEITADA] VALOR DO DESCONTO MAIOR/IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('025', '3230', '[INSTRUCAO REJEITADA] DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('025', '3231', '[INSTRUCAO REJEITADA] CONCESSAO DE DESCONTO-JA EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('025', '3233', '[INSTRUCAO REJEITADA] VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('025', '3234', '[INSTRUCAO REJEITADA] VALOR DO ABATIMENTO MAIOR/IGUAL AO VALOR ANTERIOR');
   INCLUI_ERRCNABR('025', '3236', '[INSTRUCAO REJEITADA] CONCESSAO DE ABATIMENTO-JA EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('025', '3238', '[INSTRUCAO REJEITADA] PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('025', '3239', '[INSTRUCAO REJEITADA] PEDIDO DE PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('025', '3240', '[INSTRUCAO REJEITADA] TITULO COM ORDEM DE PROTESTO EMITIDO');
   INCLUI_ERRCNABR('025', '3241', '[INSTRUCAO REJEITADA] PEDIDO DE CANCELAMENTO P/ TITULOS S/INSTRUCAO PROTESTO');
   INCLUI_ERRCNABR('025', '3242', '[INSTRUCAO REJEITADA] CODIGO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('025', '3245', '[INSTRUCAO REJEITADA] NOME DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('025', '3246', '[INSTRUCAO REJEITADA] TIPO/NUMERO DE INCRICAO DO SACADO INVALIDOS');
   INCLUI_ERRCNABR('025', '3247', '[INSTRUCAO REJEITADA] ENDERECO DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('025', '3248', '[INSTRUCAO REJEITADA] CEP INVALIDO');
   INCLUI_ERRCNABR('025', '3250', '[INSTRUCAO REJEITADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('025', '3253', '[INSTRUCAO REJEITADA] TIPO/NUMERO DE INSCRICAO DO SACADOR AVALISTA INVALIDOS');
   INCLUI_ERRCNABR('025', '3260', '[INSTRUCAO REJEITADA] MOVIMENTO PARA TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('025', '3285', '[INSTRUCAO REJEITADA] TITULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('025', '3286', '[INSTRUCAO REJEITADA] SEU NUMERO INVALIDO');
   INCLUI_ERRCNABR('025', '33  ', '[CONFIRMACAO ALTERACAO DADOS] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '34  ', '[RETIRADO CARTORIO E PENDENTE] SEM MOTIVO');
   INCLUI_ERRCNABR('025', '3581', '[CANCELAMENTO DEB. AUTOM.] TENTATIVAS ESGOTADAS, BAIXADO');
   INCLUI_ERRCNABR('025', '3582', '[CANCELAMENTO DEB. AUTOM.] TENTATIVAS ESGOTADAS, PENDENTE');
   COMMIT;
END;
/
BEGIN
-- BANCO BRR 394
   INCLUI_ERRCNABR('394', '0200', '[ENTRADA CONFIRMADA] OCORRENCIA ACEITA');
   INCLUI_ERRCNABR('394', '0217', '[ENTRADA CONFIRMADA] DATA VENCIMENTO ANTERIOR A DATA DE EMISSAO');
   INCLUI_ERRCNABR('394', '0221', '[ENTRADA CONFIRMADA] ESPECIE DO TITULO INVALIDO');
   INCLUI_ERRCNABR('394', '0224', '[ENTRADA CONFIRMADA] DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('394', '0238', '[ENTRADA CONFIRMADA] PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('394', '0239', '[ENTRADA CONFIRMADA] PEDIDO P.PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('394', '0243', '[ENTRADA CONFIRMADA] PRAZO PARA BAIXA DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('394', '0245', '[ENTRADA CONFIRMADA] NOME DO SACADO INVALIDO');
   INCLUI_ERRCNABR('394', '0246', '[ENTRADA CONFIRMADA] TIPO/NUM. DE INSCRICAO DO SACADO INVALIDOS');
   INCLUI_ERRCNABR('394', '0247', '[ENTRADA CONFIRMADA] ENDERECO DO SACADO INVALIDO');
   INCLUI_ERRCNABR('394', '0248', '[ENTRADA CONFIRMADA] CEP INVALIDO');
   INCLUI_ERRCNABR('394', '0250', '[ENTRADA CONFIRMADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('394', '0253', '[ENTRADA CONFIRMADA] N INCR. SACADOR/AVALISTA INVALIDOS (CNPJ/CPF)');
   INCLUI_ERRCNABR('394', '0254', '[ENTRADA CONFIRMADA] SACADOR/AVALISTA NAO INFORMADO');
   INCLUI_ERRCNABR('394', '0267', '[ENTRADA CONFIRMADA] DEB. AUTOMATICO AGENDADO');
   INCLUI_ERRCNABR('394', '0268', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO ERRO NOS DADOS DE REMESSA');
   INCLUI_ERRCNABR('394', '0269', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - SACADO NAO CONSTA NO CAD. AUTORIZANTE');
   INCLUI_ERRCNABR('394', '0270', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - CEDENTE NAO AUTORIZADO PELO SACADO');
   INCLUI_ERRCNABR('394', '0271', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - CEDENTE NAO CADASTRADO P/ DEBITO AUTOMATICO');
   INCLUI_ERRCNABR('394', '0272', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - CODIGO DE MOEDA DIFERENTE DE R$');
   INCLUI_ERRCNABR('394', '0273', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('394', '0275', '[ENTRADA CONFIRMADA] DEB. NAO AGENDADO - TIPO NUMERO DE INSCRICAO DO DEBITADO INVALIDO');
   INCLUI_ERRCNABR('394', '0286', '[ENTRADA CONFIRMADA] SEU NUMERO INVALIDO');
   INCLUI_ERRCNABR('394', '0302', '[ENTRADA REJEITADA] CODIGO DO REGISTRO DETALHE INVALIDO');
   INCLUI_ERRCNABR('394', '0303', '[ENTRADA REJEITADA] CODIGO DA OCORRENCIA INVALIDO');
   INCLUI_ERRCNABR('394', '0304', '[ENTRADA REJEITADA] COD. DA OCORR. NAO PERMITIDA P/A CARTEIRA');
   INCLUI_ERRCNABR('394', '0305', '[ENTRADA REJEITADA] COD. DA OCORRENCIA NAO NUMERICA');
   INCLUI_ERRCNABR('394', '0308', '[ENTRADA REJEITADA] NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('394', '0309', '[ENTRADA REJEITADA] NOSSO NUMERO DUPLICADO');
   INCLUI_ERRCNABR('394', '0310', '[ENTRADA REJEITADA] CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('394', '0316', '[ENTRADA REJEITADA] DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('394', '0318', '[ENTRADA REJEITADA] VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('394', '0320', '[ENTRADA REJEITADA] VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('394', '0321', '[ENTRADA REJEITADA] ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('394', '0322', '[ENTRADA REJEITADA] ESPECIE NAO PERMITIDA P/ CARTEIRA');
   INCLUI_ERRCNABR('394', '0324', '[ENTRADA REJEITADA] DATA DE EMISSAO INVALIDA');
   INCLUI_ERRCNABR('394', '0350', '[ENTRADA REJEITADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('394', '0363', '[ENTRADA REJEITADA] ENTRADA P/TITULO JA CADASTRADO');
   INCLUI_ERRCNABR('394', '0368', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - ERRO NOS DADOS DE REMESSA');
   INCLUI_ERRCNABR('394', '0369', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - SACADO NAO CONSTA NO CAD. DE AUTORIZANTE');
   INCLUI_ERRCNABR('394', '0370', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - CEDENTE NAO AUTORIZADO PELO SACADO');
   INCLUI_ERRCNABR('394', '0371', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - CEDENTE NAO CADASTRADO P/ DEBITO AUTOMATICO');
   INCLUI_ERRCNABR('394', '0372', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - CODIGO DE MOEDA DIFERENTE DE R$');
   INCLUI_ERRCNABR('394', '0373', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('394', '0374', '[ENTRADA REJEITADA] DEB. NAO AGENDADO, CONFORME SEU PEDIDO, TITULO NAO REGISTRADO');
   INCLUI_ERRCNABR('394', '0375', '[ENTRADA REJEITADA] DEB. NAO AGENDADO - TIPO NUMERO DE INSCRICAO DO DEBITADO INVALIDO');
   INCLUI_ERRCNABR('394', '06  ', '[LIQUIDACAO NORMAL] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '0910', '[BAIXADO AUT. VIA ARQUIVO] BAIXA COMANDADA PELO CLIENTE');
   INCLUI_ERRCNABR('394', '1000', '[BAIXADO CONF. INST. AG.] BAIXA COMANDADA');
   INCLUI_ERRCNABR('394', '1014', '[BAIXADO CONF. INST. AG.] TITULO  PROTESTADO');
   INCLUI_ERRCNABR('394', '1015', '[BAIXADO CONF. INST. AG.] TITULO EXCLUIDO');
   INCLUI_ERRCNABR('394', '11  ', '[EM SER (TITULO PENDENTE)] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '12  ', '[ABATIMENTO CONCEDIDO] -SEM MOTIVO');
   INCLUI_ERRCNABR('394', '13  ', '[ABATIMENTO CANCELADO] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '14  ', '[VENCIMENTO ALTERADO] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '15  ', '[LIQUIDACAO EM CARTORIO] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '17  ', '[LIQUIDACAO APOS BAIXA] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '18  ', '[ACERTO DE DEPOSITARIA] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '19  ', '[CONF.RECEB.INST. PROTESTO ] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '20  ', '[CONF.RECEB.INST.SUST.PROT.] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '21  ', '[ACERTO CONT. PARTICIPANTE] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '23  ', '[ENTRADA TITULO EM CARTORIO] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '2448', '[ENTRADA REJEITADA] CEP INVALIDO');
   INCLUI_ERRCNABR('394', '2707', '[BAIXA REJEITADA] AGENCIA/CONTA/DV. INVALIDO');
   INCLUI_ERRCNABR('394', '2708', '[BAIXA REJEITADA] NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('394', '2710', '[BAIXA REJEITADA] CARTEIRA INVALIDA');
   INCLUI_ERRCNABR('394', '2715', '[BAIXA REJEITADA] CARTEIRA/AG./CONTA/NUM. INVALIDOS');
   INCLUI_ERRCNABR('394', '2740', '[BAIXA REJEITADA] TITULO COM ORDEM DE PROTESTO');
   INCLUI_ERRCNABR('394', '2742', '[BAIXA REJEITADA] CODIGO P/BAIXA/DEV; VIA TELEB. INVALIDO');
   INCLUI_ERRCNABR('394', '2760', '[BAIXA REJEITADA] MOVIMENTO P/TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('394', '2803', '[DEB. DE TARIFAS/CUSTOS] TARIFA DE SUSTACAO(valor informado-posicao 176 a 188)');
   INCLUI_ERRCNABR('394', '2808', '[DEB. DE TARIFAS/CUSTOS] CUSTAS DE PROTESTO(valor informado-posicao 189 a 201)');
   INCLUI_ERRCNABR('394', '2804', '[DEB. DE TARIFAS/CUSTOS] TARIFA DE PROTESTO (valor informado-posicao 176 a 188)');
   INCLUI_ERRCNABR('394', '3001', '[ALTERACAO/DADOS REJEITADOS] CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('394', '3004', '[ALTERACAO/DADOS REJEITADOS] CODIGO DE OCORRENCIA NAO PERMITIDO PARA CARTEIRA');
   INCLUI_ERRCNABR('394', '3005', '[ALTERACAO/DADOS REJEITADOS] CODIGO DA OCORRENCIA NAO NUMERICO');
   INCLUI_ERRCNABR('394', '3008', '[ALTERACAO/DADOS REJEITADOS] NOSSO NUMERO INVALIDO');
   INCLUI_ERRCNABR('394', '3015', '[ALTERACAO/DADOS REJEITADOS] CARACTERISTICAS  DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('394', '3016', '[ALTERACAO/DADOS REJEITADOS] DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('394', '3017', '[ALTERACAO/DADOS REJEITADOS] DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSAO');
   INCLUI_ERRCNABR('394', '3018', '[ALTERACAO/DADOS REJEITADOS] VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('394', '3024', '[ALTERACAO/DADOS REJEITADOS] DATA DA EMISSAO INVALIDA');
   INCLUI_ERRCNABR('394', '3029', '[ALTERACAO/DADOS REJEITADOS] VALOR DESC. MAIOR/IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('394', '3030', '[ALTERACAO/DADOS REJEITADOS] DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('394', '3031', '[ALTERACAO/DADOS REJEITADOS] CONCESSAO DE DESCONTO JA EXISTENTE - DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('394', '3033', '[ALTERACAO/DADOS REJEITADOS] VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('394', '3034', '[ALTERACAO/DADOS REJEITADOS] VALOR ABAT. MAIOR/IGUAL VALOR DO TITULO');
   INCLUI_ERRCNABR('394', '3038', '[ALTERACAO/DADOS REJEITADOS] PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('394', '3039', '[ALTERACAO/DADOS REJEITADOS] PEDIDO DE PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('394', '3040', '[ALTERACAO/DADOS REJEITADOS] TITULO COM ORDEM DE PROTESTO EMITIDO');
   INCLUI_ERRCNABR('394', '3042', '[ALTERACAO/DADOS REJEITADOS] CODIGO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('394', '3060', '[ALTERACAO/DADOS REJEITADOS] MOVIMENTO PARA TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('394', '3085', '[ALTERACAO/DADOS REJEITADOS] TITULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('394', '3201', '[INSTRUCAO REJEITADA] CODIGO DO BANCO INVALIDO');
   INCLUI_ERRCNABR('394', '3204', '[INSTRUCAO REJEITADA] CODIGO DE OCORRENCIA NAO PERMITIDO PARA A CARTEIRA');
   INCLUI_ERRCNABR('394', '3215', '[INSTRUCAO REJEITADA] CARACTERISTICAS DA COBRANCA INCOMPATIVEIS');
   INCLUI_ERRCNABR('394', '3216', '[INSTRUCAO REJEITADA] DATA DE VENCIMENTO INVALIDA');
   INCLUI_ERRCNABR('394', '3217', '[INSTRUCAO REJEITADA] DATA DE VENCIMENTO ANTERIOR A DATA DE EMISSAO');
   INCLUI_ERRCNABR('394', '3218', '[INSTRUCAO REJEITADA] VENCIMENTO FORA DO PRAZO DE OPERACAO');
   INCLUI_ERRCNABR('394', '3220', '[INSTRUCAO REJEITADA] VALOR DO TITULO INVALIDO');
   INCLUI_ERRCNABR('394', '3221', '[INSTRUCAO REJEITADA] ESPECIE DO TITULO INVALIDA');
   INCLUI_ERRCNABR('394', '3223', '[INSTRUCAO REJEITADA] ACEITE INVALIDO');
   INCLUI_ERRCNABR('394', '3224', '[INSTRUCAO REJEITADA] DATA DE EMISSAO INVALIDA');
   INCLUI_ERRCNABR('394', '3228', '[INSTRUCAO REJEITADA] CODIGO DO DESCONTO INVALIDO');
   INCLUI_ERRCNABR('394', '3229', '[INSTRUCAO REJEITADA] VALOR DO DESCONTO MAIOR/IGUAL AO VALOR DO TITULO');
   INCLUI_ERRCNABR('394', '3230', '[INSTRUCAO REJEITADA] DESCONTO A CONCEDER NAO CONFERE');
   INCLUI_ERRCNABR('394', '3231', '[INSTRUCAO REJEITADA] CONCESSAO DE DESCONTO-JA EXISTE DESCONTO ANTERIOR');
   INCLUI_ERRCNABR('394', '3233', '[INSTRUCAO REJEITADA] VALOR DO ABATIMENTO INVALIDO');
   INCLUI_ERRCNABR('394', '3234', '[INSTRUCAO REJEITADA] VALOR DO ABATIMENTO MAIOR/IGUAL AO VALOR ANTERIOR');
   INCLUI_ERRCNABR('394', '3236', '[INSTRUCAO REJEITADA] CONCESSAO DE ABATIMENTO-JA EXISTE ABATIMENTO ANTERIOR');
   INCLUI_ERRCNABR('394', '3238', '[INSTRUCAO REJEITADA] PRAZO PARA PROTESTO INVALIDO');
   INCLUI_ERRCNABR('394', '3239', '[INSTRUCAO REJEITADA] PEDIDO DE PROTESTO NAO PERMITIDO PARA O TITULO');
   INCLUI_ERRCNABR('394', '3240', '[INSTRUCAO REJEITADA] TITULO COM ORDEM DE PROTESTO EMITIDO');
   INCLUI_ERRCNABR('394', '3241', '[INSTRUCAO REJEITADA] PEDIDO DE CANCELAMENTO P/ TITULOS S/INSTRUCAO PROTESTO');
   INCLUI_ERRCNABR('394', '3242', '[INSTRUCAO REJEITADA] CODIGO PARA BAIXA/DEVOLUCAO INVALIDO');
   INCLUI_ERRCNABR('394', '3245', '[INSTRUCAO REJEITADA] NOME DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('394', '3246', '[INSTRUCAO REJEITADA] TIPO/NUMERO DE INCRICAO DO SACADO INVALIDOS');
   INCLUI_ERRCNABR('394', '3247', '[INSTRUCAO REJEITADA] ENDERECO DO SACADO NAO INFORMADO');
   INCLUI_ERRCNABR('394', '3248', '[INSTRUCAO REJEITADA] CEP INVALIDO');
   INCLUI_ERRCNABR('394', '3250', '[INSTRUCAO REJEITADA] CEP REFERENTE A BANCO CORRESPONDENTE');
   INCLUI_ERRCNABR('394', '3253', '[INSTRUCAO REJEITADA] TIPO/NUMERO DE INSCRICAO DO SACADOR AVALISTA INVALIDOS');
   INCLUI_ERRCNABR('394', '3260', '[INSTRUCAO REJEITADA] MOVIMENTO PARA TITULO NAO CADASTRADO');
   INCLUI_ERRCNABR('394', '3285', '[INSTRUCAO REJEITADA] TITULO COM PAGAMENTO VINCULADO');
   INCLUI_ERRCNABR('394', '3286', '[INSTRUCAO REJEITADA] SEU NUMERO INVALIDO');
   INCLUI_ERRCNABR('394', '33  ', '[CONFIRMACAO ALTERACAO DADOS] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '34  ', '[RETIRADO CARTORIO E PENDENTE] SEM MOTIVO');
   INCLUI_ERRCNABR('394', '3581', '[CANCELAMENTO DEB. AUTOM.] TENTATIVAS ESGOTADAS, BAIXADO');
   INCLUI_ERRCNABR('394', '3582', '[CANCELAMENTO DEB. AUTOM.] TENTATIVAS ESGOTADAS, PENDENTE');
   COMMIT;
END;
/